/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "grammar.y"


/*
 * ufdbGuard is copyrighted (C) 2005-2024 by URLfilterDB B.V. with all rights reserved.
 *
 * Parts of the ufdbGuard daemon are based on squidGuard.
 * squidGuard is copyrighted (C) 1998 by
 * ElTele st AS, Oslo, Norway, with all rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License (version 2) as
 * published by the Free Software Foundation.  It is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License (GPL) for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * (GPL2) along with this program.
 */

#define YYMALLOC  ufdbMalloc
#define YYFREE    ufdbFree

#define UFDB_LOG_USER_QUOTA   0   /* TODO remove */

#undef UFDB_DEBUG_ACL_ACCESS
#define UFDB_DEBUG_ACL_ACCESS 0

#include "ufdb.h"
#include "sg.h"
#include "ufdb_globals.h"
#include "ufdblib.h"
#include "ufdbdb.h"
#include "ufdbchkport.h"

#define UFDB_DEBUG 0

#if UFDB_DEBUG
#undef YYDEBUG
#define YYDEBUG 1
#endif

#define UFDB_TIME_DEBUG 0

#if __linux__
#include <sys/mman.h>
#endif
#include <pthread.h>
#include <sys/types.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <netdb.h>
#include <grp.h>
#include <syslog.h>
#include <signal.h>
#include <sched.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/socket.h>


extern FILE * yyin;
extern FILE * yyout;

int    lineno;

static int   numTimeElements = 0;
static int * TimeElementsEvents = NULL;

static int   time_switch = 0;
static int   date_switch = 0;

static void setDBhome( char * dbhome );
static void setAdministrator( char * value );
static void setLogdir( char * value );
static void setPidfile( char * value );
static void setRefreshUserlist( int nmin );
static void setRefreshDomainlist( int nmin );
static void setRefreshIPlist( int nmin );
static void ufdbSourceExecIPList( char * command );

static void ufdbSourceGroup( int groupType, char * groupName );
static void ufdbSourceUserQuota( const char * seconds, const char * sporadic, const char * renew );
static void ufdbSourceUser( char * user );
static void ufdbSourceUserList( char * file );
static void ufdbSourceExecUserList( char * command );

static void defSource( char * source );
static void defSourceEnd( void );
static struct Source * defSourceFindName( struct Source * slist, const char * name );
static void defSourceDomain( char * );
static void ufdbSourceEval( int method  );
static void defSourceIPV4List( char * file );
static void defSourceIPV6List( char * file );

static void ufdbCategoryCACertsFile( char * cacertsFile );
static void ufdbCategoryCACertsDir( char * cacertsDir );

static void sgIpv4( const char * name, int type, const char * file, int lineno );
static void sgIpv6( const char * addr, int type, const char * file, int line );

void ufdbFreeDomainDb( struct sgDb * dbp );

static void   ufdbAcl( const char * name, const char * value, int within );
static void   ufdbAclSetValue( const char * what, const char * value, int allowed );

static void   sgTime( char * );
static struct ufdbTime * sgTimeFindName( const char * name );
static void   sgTimeElementInit( void );
static void   sgTimeElementAdd( char *, char );
static void   sgTimeElementEnd( void );
static void   sgTimeElementClone( void );
static void   defSourceTime( char * name, int within );

static void   ufdbCategoryTime( char * name, int within );
static void   ufdbCategoryActiveBumping( int flag );
static void   ufdbCategoryBlockConnect( int flag );
static void   ufdbCategoryRewrite( char * value );
static void   ufdbCategoryRedirect( char * value );
static void   ufdbCategoryExecDomainList( char * command );

static void   ufdbCategoryUrlList( char * urllist );
static void   ufdbCategoryOption( int value, int option );

static void   sgRewrite( char * rewrite );
static void   sgRewriteTime( char * name, int within );
static void   sgRewriteSubstitute( char * string );
static struct sgRewrite * sgRewriteFindName( const char * name );

static void   logConfig( void );


#line 206 "grammar.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "grammar.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ADMINISTRATOR = 3,              /* ADMINISTRATOR  */
  YYSYMBOL_QSTRING = 4,                    /* QSTRING  */
  YYSYMBOL_CHECK_PROXY_TUNNELS = 5,        /* CHECK_PROXY_TUNNELS  */
  YYSYMBOL_QUEUE_CHECKS = 6,               /* QUEUE_CHECKS  */
  YYSYMBOL_AGGRESSIVE = 7,                 /* AGGRESSIVE  */
  YYSYMBOL_LOG_ONLY = 8,                   /* LOG_ONLY  */
  YYSYMBOL_ON = 9,                         /* ON  */
  YYSYMBOL_OFF = 10,                       /* OFF  */
  YYSYMBOL_CHAR_MINUS = 11,                /* CHAR_MINUS  */
  YYSYMBOL_CHAR_I = 12,                    /* CHAR_I  */
  YYSYMBOL_CHAR_EXCLAMATION = 13,          /* CHAR_EXCLAMATION  */
  YYSYMBOL_IGNORECASE = 14,                /* IGNORECASE  */
  YYSYMBOL_COMMA = 15,                     /* COMMA  */
  YYSYMBOL_EQUAL = 16,                     /* EQUAL  */
  YYSYMBOL_SOCKET_TYPE = 17,               /* SOCKET_TYPE  */
  YYSYMBOL_TCP = 18,                       /* TCP  */
  YYSYMBOL_PORT = 19,                      /* PORT  */
  YYSYMBOL_HTTP_SERVER = 20,               /* HTTP_SERVER  */
  YYSYMBOL_INTERFACE = 21,                 /* INTERFACE  */
  YYSYMBOL_IMAGES = 22,                    /* IMAGES  */
  YYSYMBOL_HTTPS_PROHIBIT_INSECURE_SSLV2 = 23, /* HTTPS_PROHIBIT_INSECURE_SSLV2  */
  YYSYMBOL_HTTPS_PROHIBIT_INSECURE_SSLV3 = 24, /* HTTPS_PROHIBIT_INSECURE_SSLV3  */
  YYSYMBOL_HTTPS_PROHIBIT_INSECURE_TLSV1_0 = 25, /* HTTPS_PROHIBIT_INSECURE_TLSV1_0  */
  YYSYMBOL_HTTPS_CONNECTION_CACHE_SIZE = 26, /* HTTPS_CONNECTION_CACHE_SIZE  */
  YYSYMBOL_IDENTIFIER = 27,                /* IDENTIFIER  */
  YYSYMBOL_WORD = 28,                      /* WORD  */
  YYSYMBOL_END = 29,                       /* END  */
  YYSYMBOL_START_BRACKET = 30,             /* START_BRACKET  */
  YYSYMBOL_STOP_BRACKET = 31,              /* STOP_BRACKET  */
  YYSYMBOL_WEEKDAY = 32,                   /* WEEKDAY  */
  YYSYMBOL_CATEGORY = 33,                  /* CATEGORY  */
  YYSYMBOL_REWRITE = 34,                   /* REWRITE  */
  YYSYMBOL_ACL = 35,                       /* ACL  */
  YYSYMBOL_CPUS = 36,                      /* CPUS  */
  YYSYMBOL_TIME = 37,                      /* TIME  */
  YYSYMBOL_TVAL = 38,                      /* TVAL  */
  YYSYMBOL_DVAL = 39,                      /* DVAL  */
  YYSYMBOL_DVALCRON = 40,                  /* DVALCRON  */
  YYSYMBOL_BLOCK_BUMPED_CONNECT = 41,      /* BLOCK_BUMPED_CONNECT  */
  YYSYMBOL_EVALUATE_AND = 42,              /* EVALUATE_AND  */
  YYSYMBOL_EVALUATE_OR = 43,               /* EVALUATE_OR  */
  YYSYMBOL_SOURCE = 44,                    /* SOURCE  */
  YYSYMBOL_CONTINUE = 45,                  /* CONTINUE  */
  YYSYMBOL_IPV4ADDR = 46,                  /* IPV4ADDR  */
  YYSYMBOL_IPV4NET = 47,                   /* IPV4NET  */
  YYSYMBOL_IPV4CLASS = 48,                 /* IPV4CLASS  */
  YYSYMBOL_IPV4RANGE = 49,                 /* IPV4RANGE  */
  YYSYMBOL_IPV6ADDR = 50,                  /* IPV6ADDR  */
  YYSYMBOL_IPV6NET = 51,                   /* IPV6NET  */
  YYSYMBOL_DBHOME = 52,                    /* DBHOME  */
  YYSYMBOL_DOMAINLIST = 53,                /* DOMAINLIST  */
  YYSYMBOL_EXECDOMAINLIST = 54,            /* EXECDOMAINLIST  */
  YYSYMBOL_REFRESHDOMAINLIST = 55,         /* REFRESHDOMAINLIST  */
  YYSYMBOL_URLLIST = 56,                   /* URLLIST  */
  YYSYMBOL_EXPRESSIONLIST = 57,            /* EXPRESSIONLIST  */
  YYSYMBOL_CACERTS = 58,                   /* CACERTS  */
  YYSYMBOL_CACERTSDIR = 59,                /* CACERTSDIR  */
  YYSYMBOL_IPV4 = 60,                      /* IPV4  */
  YYSYMBOL_IPV4LIST = 61,                  /* IPV4LIST  */
  YYSYMBOL_IPV6 = 62,                      /* IPV6  */
  YYSYMBOL_IPV6LIST = 63,                  /* IPV6LIST  */
  YYSYMBOL_DOMAIN = 64,                    /* DOMAIN  */
  YYSYMBOL_UNIX = 65,                      /* UNIX  */
  YYSYMBOL_LDAP = 66,                      /* LDAP  */
  YYSYMBOL_USER = 67,                      /* USER  */
  YYSYMBOL_USERLIST = 68,                  /* USERLIST  */
  YYSYMBOL_EXECUSERLIST = 69,              /* EXECUSERLIST  */
  YYSYMBOL_REFRESHUSERLIST = 70,           /* REFRESHUSERLIST  */
  YYSYMBOL_EXECIPLIST = 71,                /* EXECIPLIST  */
  YYSYMBOL_REFRESHIPLIST = 72,             /* REFRESHIPLIST  */
  YYSYMBOL_USERQUOTA = 73,                 /* USERQUOTA  */
  YYSYMBOL_GROUP = 74,                     /* GROUP  */
  YYSYMBOL_NL = 75,                        /* NL  */
  YYSYMBOL_NUMBER = 76,                    /* NUMBER  */
  YYSYMBOL_NUMBERS = 77,                   /* NUMBERS  */
  YYSYMBOL_PASS = 78,                      /* PASS  */
  YYSYMBOL_REDIRECT = 79,                  /* REDIRECT  */
  YYSYMBOL_SUBST = 80,                     /* SUBST  */
  YYSYMBOL_CHAR = 81,                      /* CHAR  */
  YYSYMBOL_MINUTELY = 82,                  /* MINUTELY  */
  YYSYMBOL_HOURLY = 83,                    /* HOURLY  */
  YYSYMBOL_DAILY = 84,                     /* DAILY  */
  YYSYMBOL_WEEKLY = 85,                    /* WEEKLY  */
  YYSYMBOL_DATE = 86,                      /* DATE  */
  YYSYMBOL_REDIRECT_FATAL_ERROR = 87,      /* REDIRECT_FATAL_ERROR  */
  YYSYMBOL_REDIRECT_LOADING_DATABASE = 88, /* REDIRECT_LOADING_DATABASE  */
  YYSYMBOL_REDIRECT_HTTPS = 89,            /* REDIRECT_HTTPS  */
  YYSYMBOL_REDIRECT_BUMPED_HTTPS = 90,     /* REDIRECT_BUMPED_HTTPS  */
  YYSYMBOL_WITHIN = 91,                    /* WITHIN  */
  YYSYMBOL_OUTSIDE = 92,                   /* OUTSIDE  */
  YYSYMBOL_ELSE = 93,                      /* ELSE  */
  YYSYMBOL_ANONYMOUS = 94,                 /* ANONYMOUS  */
  YYSYMBOL_SPORADIC = 95,                  /* SPORADIC  */
  YYSYMBOL_PIDFILE = 96,                   /* PIDFILE  */
  YYSYMBOL_LOGFILE = 97,                   /* LOGFILE  */
  YYSYMBOL_LOGDIR = 98,                    /* LOGDIR  */
  YYSYMBOL_LOGPASS = 99,                   /* LOGPASS  */
  YYSYMBOL_LOGBLOCK = 100,                 /* LOGBLOCK  */
  YYSYMBOL_LOGALL = 101,                   /* LOGALL  */
  YYSYMBOL_LOGALL_HTTPD = 102,             /* LOGALL_HTTPD  */
  YYSYMBOL_MAIL_SERVER = 103,              /* MAIL_SERVER  */
  YYSYMBOL_MY_HOSTNAME = 104,              /* MY_HOSTNAME  */
  YYSYMBOL_ADMIN_EMAIL = 105,              /* ADMIN_EMAIL  */
  YYSYMBOL_SENDER_EMAIL = 106,             /* SENDER_EMAIL  */
  YYSYMBOL_EXTERNAL_STATUS_COMMAND = 107,  /* EXTERNAL_STATUS_COMMAND  */
  YYSYMBOL_TOKEN_ALLOW = 108,              /* TOKEN_ALLOW  */
  YYSYMBOL_TOKEN_DENY = 109,               /* TOKEN_DENY  */
  YYSYMBOL_YOUTUBE_EDUFILTER = 110,        /* YOUTUBE_EDUFILTER  */
  YYSYMBOL_YOUTUBE_EDUFILTER_ID = 111,     /* YOUTUBE_EDUFILTER_ID  */
  YYSYMBOL_ALLOW_GOOGLE_HTTPS_USING_IP = 112, /* ALLOW_GOOGLE_HTTPS_USING_IP  */
  YYSYMBOL_URL_LOOKUP_RESULT_DB_RELOAD = 113, /* URL_LOOKUP_RESULT_DB_RELOAD  */
  YYSYMBOL_URL_LOOKUP_RESULT_FATAL_ERROR = 114, /* URL_LOOKUP_RESULT_FATAL_ERROR  */
  YYSYMBOL_URL_LOOKUP_DELAY_DB_RELOAD = 115, /* URL_LOOKUP_DELAY_DB_RELOAD  */
  YYSYMBOL_OPTION = 116,                   /* OPTION  */
  YYSYMBOL_UFDB_SHOW_URL_DETAILS = 117,    /* UFDB_SHOW_URL_DETAILS  */
  YYSYMBOL_UFDB_LOG_URL_DETAILS = 118,     /* UFDB_LOG_URL_DETAILS  */
  YYSYMBOL_SQUID_VERSION = 119,            /* SQUID_VERSION  */
  YYSYMBOL_SQUID_USES_ACTIVE_BUMPING = 120, /* SQUID_USES_ACTIVE_BUMPING  */
  YYSYMBOL_UPLOAD_CRASH_REPORTS = 121,     /* UPLOAD_CRASH_REPORTS  */
  YYSYMBOL_LOOKUP_REVERSE_IP = 122,        /* LOOKUP_REVERSE_IP  */
  YYSYMBOL_USE_IPV6_ON_WAN = 123,          /* USE_IPV6_ON_WAN  */
  YYSYMBOL_PARSE_URL_PARAMETERS = 124,     /* PARSE_URL_PARAMETERS  */
  YYSYMBOL_STRIP_DOMAIN_FROM_USERNAME = 125, /* STRIP_DOMAIN_FROM_USERNAME  */
  YYSYMBOL_UFDB_DEBUG_FILTER = 126,        /* UFDB_DEBUG_FILTER  */
  YYSYMBOL_UFDB_DEBUG_COREDUMP = 127,      /* UFDB_DEBUG_COREDUMP  */
  YYSYMBOL_MADVISE_HUGEPAGES = 128,        /* MADVISE_HUGEPAGES  */
  YYSYMBOL_FAST_REFRESH = 129,             /* FAST_REFRESH  */
  YYSYMBOL_UFDB_DEBUG_SKYPE_PROBES = 130,  /* UFDB_DEBUG_SKYPE_PROBES  */
  YYSYMBOL_UFDB_DEBUG_GTALK_PROBES = 131,  /* UFDB_DEBUG_GTALK_PROBES  */
  YYSYMBOL_UFDB_DEBUG_YAHOOMSG_PROBES = 132, /* UFDB_DEBUG_YAHOOMSG_PROBES  */
  YYSYMBOL_UFDB_DEBUG_AIM_PROBES = 133,    /* UFDB_DEBUG_AIM_PROBES  */
  YYSYMBOL_UFDB_DEBUG_FBCHAT_PROBES = 134, /* UFDB_DEBUG_FBCHAT_PROBES  */
  YYSYMBOL_UFDB_DEBUG_CITRIXONLINE_PROBES = 135, /* UFDB_DEBUG_CITRIXONLINE_PROBES  */
  YYSYMBOL_UFDB_EXPRESSION_OPTIMISATION = 136, /* UFDB_EXPRESSION_OPTIMISATION  */
  YYSYMBOL_UFDB_EXPRESSION_DEBUG = 137,    /* UFDB_EXPRESSION_DEBUG  */
  YYSYMBOL_UFDB_DEBUG_EXTERNAL_SCRIPTS = 138, /* UFDB_DEBUG_EXTERNAL_SCRIPTS  */
  YYSYMBOL_UFDB_NUM_WORKER_THREADS = 139,  /* UFDB_NUM_WORKER_THREADS  */
  YYSYMBOL_ENFORCE_HTTPS_WITH_HOSTNAME = 140, /* ENFORCE_HTTPS_WITH_HOSTNAME  */
  YYSYMBOL_ENFORCE_HTTPS_OFFICAL_CERTIFICATE = 141, /* ENFORCE_HTTPS_OFFICAL_CERTIFICATE  */
  YYSYMBOL_ALLOW_SKYPE_OVER_HTTPS = 142,   /* ALLOW_SKYPE_OVER_HTTPS  */
  YYSYMBOL_ALLOW_UNKNOWN_PROTOCOL_OVER_HTTPS = 143, /* ALLOW_UNKNOWN_PROTOCOL_OVER_HTTPS  */
  YYSYMBOL_ALLOW_GTALK_OVER_HTTPS = 144,   /* ALLOW_GTALK_OVER_HTTPS  */
  YYSYMBOL_ALLOW_YAHOOMSG_OVER_HTTPS = 145, /* ALLOW_YAHOOMSG_OVER_HTTPS  */
  YYSYMBOL_ALLOW_AIM_OVER_HTTPS = 146,     /* ALLOW_AIM_OVER_HTTPS  */
  YYSYMBOL_ALLOW_FBCHAT_OVER_HTTPS = 147,  /* ALLOW_FBCHAT_OVER_HTTPS  */
  YYSYMBOL_ALLOW_CITRIXONLINE_OVER_HTTPS = 148, /* ALLOW_CITRIXONLINE_OVER_HTTPS  */
  YYSYMBOL_ALLOW_ANYDESK_OVER_HTTPS = 149, /* ALLOW_ANYDESK_OVER_HTTPS  */
  YYSYMBOL_ALLOW_TEAMVIEWER_OVER_HTTPS = 150, /* ALLOW_TEAMVIEWER_OVER_HTTPS  */
  YYSYMBOL_ANALYSE_UNCATEGORISED = 151,    /* ANALYSE_UNCATEGORISED  */
  YYSYMBOL_LOG_UNCATEGORISED_URLS = 152,   /* LOG_UNCATEGORISED_URLS  */
  YYSYMBOL_UPLOAD_STATS = 153,             /* UPLOAD_STATS  */
  YYSYMBOL_SAFE_SEARCH = 154,              /* SAFE_SEARCH  */
  YYSYMBOL_MAX_LOGFILE_SIZE = 155,         /* MAX_LOGFILE_SIZE  */
  YYSYMBOL_YYACCEPT = 156,                 /* $accept  */
  YYSYMBOL_start = 157,                    /* start  */
  YYSYMBOL_qidentifier = 158,              /* qidentifier  */
  YYSYMBOL_https_cache_size = 159,         /* https_cache_size  */
  YYSYMBOL_allow_or_deny = 160,            /* allow_or_deny  */
  YYSYMBOL_on_or_off = 161,                /* on_or_off  */
  YYSYMBOL_log_pass = 162,                 /* log_pass  */
  YYSYMBOL_log_block = 163,                /* log_block  */
  YYSYMBOL_log_all = 164,                  /* log_all  */
  YYSYMBOL_logall_httpd = 165,             /* logall_httpd  */
  YYSYMBOL_youtube_edufilter = 166,        /* youtube_edufilter  */
  YYSYMBOL_youtube_edufilter_id = 167,     /* youtube_edufilter_id  */
  YYSYMBOL_allow_google_https_using_ip = 168, /* allow_google_https_using_ip  */
  YYSYMBOL_madvise_hugepages = 169,        /* madvise_hugepages  */
  YYSYMBOL_fast_refresh = 170,             /* fast_refresh  */
  YYSYMBOL_debug_filter = 171,             /* debug_filter  */
  YYSYMBOL_debug_coredump = 172,           /* debug_coredump  */
  YYSYMBOL_enforce_https_with_hostname = 173, /* enforce_https_with_hostname  */
  YYSYMBOL_enforce_https_offical_certificate = 174, /* enforce_https_offical_certificate  */
  YYSYMBOL_https_prohibit_insecure_sslv2 = 175, /* https_prohibit_insecure_sslv2  */
  YYSYMBOL_https_prohibit_insecure_sslv3 = 176, /* https_prohibit_insecure_sslv3  */
  YYSYMBOL_https_prohibit_insecure_tlsv1_0 = 177, /* https_prohibit_insecure_tlsv1_0  */
  YYSYMBOL_check_proxy_tunnel_option = 178, /* check_proxy_tunnel_option  */
  YYSYMBOL_check_proxy_tunnels = 179,      /* check_proxy_tunnels  */
  YYSYMBOL_admin_spec = 180,               /* admin_spec  */
  YYSYMBOL_dbhome = 181,                   /* dbhome  */
  YYSYMBOL_refreshuserlist = 182,          /* refreshuserlist  */
  YYSYMBOL_refreshiplist = 183,            /* refreshiplist  */
  YYSYMBOL_refreshdomainlist = 184,        /* refreshdomainlist  */
  YYSYMBOL_url_lookup_result_db_reload = 185, /* url_lookup_result_db_reload  */
  YYSYMBOL_url_lookup_result_fatal_error = 186, /* url_lookup_result_fatal_error  */
  YYSYMBOL_url_lookup_delay_db_reload = 187, /* url_lookup_delay_db_reload  */
  YYSYMBOL_squid_version = 188,            /* squid_version  */
  YYSYMBOL_num_worker_threads = 189,       /* num_worker_threads  */
  YYSYMBOL_upload_crash_reports = 190,     /* upload_crash_reports  */
  YYSYMBOL_lookup_reverse_ip = 191,        /* lookup_reverse_ip  */
  YYSYMBOL_use_ipv6_on_wan = 192,          /* use_ipv6_on_wan  */
  YYSYMBOL_parse_url_parameters = 193,     /* parse_url_parameters  */
  YYSYMBOL_squid_uses_active_bumping = 194, /* squid_uses_active_bumping  */
  YYSYMBOL_ufdb_log_url_details = 195,     /* ufdb_log_url_details  */
  YYSYMBOL_ufdb_show_url_details = 196,    /* ufdb_show_url_details  */
  YYSYMBOL_ufdb_debug_skype_probes = 197,  /* ufdb_debug_skype_probes  */
  YYSYMBOL_ufdb_debug_gtalk_probes = 198,  /* ufdb_debug_gtalk_probes  */
  YYSYMBOL_ufdb_debug_yahoomsg_probes = 199, /* ufdb_debug_yahoomsg_probes  */
  YYSYMBOL_ufdb_debug_aim_probes = 200,    /* ufdb_debug_aim_probes  */
  YYSYMBOL_ufdb_debug_fbchat_probes = 201, /* ufdb_debug_fbchat_probes  */
  YYSYMBOL_ufdb_debug_citrixonline_probes = 202, /* ufdb_debug_citrixonline_probes  */
  YYSYMBOL_ufdb_expression_optimisation = 203, /* ufdb_expression_optimisation  */
  YYSYMBOL_ufdb_expression_debug = 204,    /* ufdb_expression_debug  */
  YYSYMBOL_ufdb_debug_external_scripts = 205, /* ufdb_debug_external_scripts  */
  YYSYMBOL_mail_server = 206,              /* mail_server  */
  YYSYMBOL_my_hostname = 207,              /* my_hostname  */
  YYSYMBOL_admin_email = 208,              /* admin_email  */
  YYSYMBOL_sender_email = 209,             /* sender_email  */
  YYSYMBOL_external_status_command = 210,  /* external_status_command  */
  YYSYMBOL_logdir = 211,                   /* logdir  */
  YYSYMBOL_pidfile = 212,                  /* pidfile  */
  YYSYMBOL_socket_type = 213,              /* socket_type  */
  YYSYMBOL_port = 214,                     /* port  */
  YYSYMBOL_interface = 215,                /* interface  */
  YYSYMBOL_cpus = 216,                     /* cpus  */
  YYSYMBOL_upload_stats = 217,             /* upload_stats  */
  YYSYMBOL_redirect_https = 218,           /* redirect_https  */
  YYSYMBOL_redirect_bumped_https = 219,    /* redirect_bumped_https  */
  YYSYMBOL_redirect_loading_database = 220, /* redirect_loading_database  */
  YYSYMBOL_redirect_fatal_error = 221,     /* redirect_fatal_error  */
  YYSYMBOL_log_uncategorised_urls = 222,   /* log_uncategorised_urls  */
  YYSYMBOL_analyse_uncategorised = 223,    /* analyse_uncategorised  */
  YYSYMBOL_strip_domain_from_username = 224, /* strip_domain_from_username  */
  YYSYMBOL_safe_search = 225,              /* safe_search  */
  YYSYMBOL_max_logfile_size = 226,         /* max_logfile_size  */
  YYSYMBOL_httpd_option = 227,             /* httpd_option  */
  YYSYMBOL_httpd_options = 228,            /* httpd_options  */
  YYSYMBOL_http_server_def = 229,          /* http_server_def  */
  YYSYMBOL_category = 230,                 /* category  */
  YYSYMBOL_category_block = 231,           /* category_block  */
  YYSYMBOL_category_contents = 232,        /* category_contents  */
  YYSYMBOL_category_content = 233,         /* category_content  */
  YYSYMBOL_source = 234,                   /* source  */
  YYSYMBOL_source_block = 235,             /* source_block  */
  YYSYMBOL_source_contents = 236,          /* source_contents  */
  YYSYMBOL_source_content = 237,           /* source_content  */
  YYSYMBOL_domain = 238,                   /* domain  */
  YYSYMBOL_user = 239,                     /* user  */
  YYSYMBOL_acl_block = 240,                /* acl_block  */
  YYSYMBOL_acl_contents = 241,             /* acl_contents  */
  YYSYMBOL_acl_header = 242,               /* acl_header  */
  YYSYMBOL_acl_content = 243,              /* acl_content  */
  YYSYMBOL_244_1 = 244,                    /* $@1  */
  YYSYMBOL_access_contents = 245,          /* access_contents  */
  YYSYMBOL_access_content = 246,           /* access_content  */
  YYSYMBOL_access_pass = 247,              /* access_pass  */
  YYSYMBOL_ipv4s = 248,                    /* ipv4s  */
  YYSYMBOL_ipv4 = 249,                     /* ipv4  */
  YYSYMBOL_ipv6s = 250,                    /* ipv6s  */
  YYSYMBOL_ipv6 = 251,                     /* ipv6  */
  YYSYMBOL_rew = 252,                      /* rew  */
  YYSYMBOL_rew_block = 253,                /* rew_block  */
  YYSYMBOL_rew_contents = 254,             /* rew_contents  */
  YYSYMBOL_rew_content = 255,              /* rew_content  */
  YYSYMBOL_time = 256,                     /* time  */
  YYSYMBOL_time_block = 257,               /* time_block  */
  YYSYMBOL_time_contents = 258,            /* time_contents  */
  YYSYMBOL_time_content = 259,             /* time_content  */
  YYSYMBOL_260_2 = 260,                    /* $@2  */
  YYSYMBOL_261_3 = 261,                    /* $@3  */
  YYSYMBOL_262_4 = 262,                    /* $@4  */
  YYSYMBOL_263_5 = 263,                    /* $@5  */
  YYSYMBOL_264_6 = 264,                    /* $@6  */
  YYSYMBOL_265_7 = 265,                    /* $@7  */
  YYSYMBOL_266_8 = 266,                    /* $@8  */
  YYSYMBOL_ttime = 267,                    /* ttime  */
  YYSYMBOL_268_9 = 268,                    /* $@9  */
  YYSYMBOL_date = 269,                     /* date  */
  YYSYMBOL_dval = 270,                     /* dval  */
  YYSYMBOL_tval = 271,                     /* tval  */
  YYSYMBOL_dvalcron = 272,                 /* dvalcron  */
  YYSYMBOL_an_error = 273,                 /* an_error  */
  YYSYMBOL_statements = 274,               /* statements  */
  YYSYMBOL_statement = 275                 /* statement  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   572

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  156
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  120
/* YYNRULES -- Number of rules.  */
#define YYNRULES  350
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  517

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   410


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   227,   227,   231,   232,   236,   241,   242,   246,   247,
     248,   252,   256,   260,   264,   268,   272,   276,   280,   284,
     288,   289,   294,   298,   304,   310,   316,   322,   329,   330,
     331,   332,   336,   340,   344,   345,   349,   354,   359,   364,
     368,   372,   376,   381,   404,   409,   414,   419,   424,   429,
     433,   437,   441,   445,   449,   453,   457,   461,   465,   469,
     473,   477,   481,   485,   489,   494,   495,   499,   500,   504,
     505,   509,   520,   527,   531,   532,   536,   541,   546,   551,
     556,   561,   568,   573,   581,   588,   593,   606,   607,   613,
     619,   620,   621,   625,   626,   630,   634,   635,   637,   639,
     641,   646,   650,   651,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   701,
     703,   705,   710,   714,   718,   719,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     738,   740,   742,   744,   745,   746,   747,   748,   749,   750,
     751,   752,   753,   754,   757,   760,   763,   766,   771,   772,
     773,   774,   778,   779,   780,   781,   785,   788,   789,   793,
     794,   795,   799,   801,   800,   806,   807,   811,   819,   820,
     821,   822,   823,   826,   829,   832,   838,   839,   840,   841,
     842,   843,   847,   848,   849,   853,   855,   857,   859,   864,
     865,   866,   870,   872,   877,   878,   882,   886,   887,   892,
     893,   894,   895,   898,   901,   904,   911,   915,   919,   920,
     925,   925,   925,   926,   926,   926,   927,   927,   927,   928,
     928,   929,   933,   933,   934,   938,   939,   940,   941,   942,
     943,   946,   949,   952,   956,   962,   963,   967,   968,   969,
     970,   971,   972,   973,   974,   975,   976,   977,   978,   979,
     980,   981,   982,   983,   984,   985,   986,   987,   988,   989,
     990,   991,   992,   993,   994,   995,   996,   997,   998,   999,
    1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,
    1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,  1019,
    1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,
    1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,
    1040
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ADMINISTRATOR",
  "QSTRING", "CHECK_PROXY_TUNNELS", "QUEUE_CHECKS", "AGGRESSIVE",
  "LOG_ONLY", "ON", "OFF", "CHAR_MINUS", "CHAR_I", "CHAR_EXCLAMATION",
  "IGNORECASE", "COMMA", "EQUAL", "SOCKET_TYPE", "TCP", "PORT",
  "HTTP_SERVER", "INTERFACE", "IMAGES", "HTTPS_PROHIBIT_INSECURE_SSLV2",
  "HTTPS_PROHIBIT_INSECURE_SSLV3", "HTTPS_PROHIBIT_INSECURE_TLSV1_0",
  "HTTPS_CONNECTION_CACHE_SIZE", "IDENTIFIER", "WORD", "END",
  "START_BRACKET", "STOP_BRACKET", "WEEKDAY", "CATEGORY", "REWRITE", "ACL",
  "CPUS", "TIME", "TVAL", "DVAL", "DVALCRON", "BLOCK_BUMPED_CONNECT",
  "EVALUATE_AND", "EVALUATE_OR", "SOURCE", "CONTINUE", "IPV4ADDR",
  "IPV4NET", "IPV4CLASS", "IPV4RANGE", "IPV6ADDR", "IPV6NET", "DBHOME",
  "DOMAINLIST", "EXECDOMAINLIST", "REFRESHDOMAINLIST", "URLLIST",
  "EXPRESSIONLIST", "CACERTS", "CACERTSDIR", "IPV4", "IPV4LIST", "IPV6",
  "IPV6LIST", "DOMAIN", "UNIX", "LDAP", "USER", "USERLIST", "EXECUSERLIST",
  "REFRESHUSERLIST", "EXECIPLIST", "REFRESHIPLIST", "USERQUOTA", "GROUP",
  "NL", "NUMBER", "NUMBERS", "PASS", "REDIRECT", "SUBST", "CHAR",
  "MINUTELY", "HOURLY", "DAILY", "WEEKLY", "DATE", "REDIRECT_FATAL_ERROR",
  "REDIRECT_LOADING_DATABASE", "REDIRECT_HTTPS", "REDIRECT_BUMPED_HTTPS",
  "WITHIN", "OUTSIDE", "ELSE", "ANONYMOUS", "SPORADIC", "PIDFILE",
  "LOGFILE", "LOGDIR", "LOGPASS", "LOGBLOCK", "LOGALL", "LOGALL_HTTPD",
  "MAIL_SERVER", "MY_HOSTNAME", "ADMIN_EMAIL", "SENDER_EMAIL",
  "EXTERNAL_STATUS_COMMAND", "TOKEN_ALLOW", "TOKEN_DENY",
  "YOUTUBE_EDUFILTER", "YOUTUBE_EDUFILTER_ID",
  "ALLOW_GOOGLE_HTTPS_USING_IP", "URL_LOOKUP_RESULT_DB_RELOAD",
  "URL_LOOKUP_RESULT_FATAL_ERROR", "URL_LOOKUP_DELAY_DB_RELOAD", "OPTION",
  "UFDB_SHOW_URL_DETAILS", "UFDB_LOG_URL_DETAILS", "SQUID_VERSION",
  "SQUID_USES_ACTIVE_BUMPING", "UPLOAD_CRASH_REPORTS", "LOOKUP_REVERSE_IP",
  "USE_IPV6_ON_WAN", "PARSE_URL_PARAMETERS", "STRIP_DOMAIN_FROM_USERNAME",
  "UFDB_DEBUG_FILTER", "UFDB_DEBUG_COREDUMP", "MADVISE_HUGEPAGES",
  "FAST_REFRESH", "UFDB_DEBUG_SKYPE_PROBES", "UFDB_DEBUG_GTALK_PROBES",
  "UFDB_DEBUG_YAHOOMSG_PROBES", "UFDB_DEBUG_AIM_PROBES",
  "UFDB_DEBUG_FBCHAT_PROBES", "UFDB_DEBUG_CITRIXONLINE_PROBES",
  "UFDB_EXPRESSION_OPTIMISATION", "UFDB_EXPRESSION_DEBUG",
  "UFDB_DEBUG_EXTERNAL_SCRIPTS", "UFDB_NUM_WORKER_THREADS",
  "ENFORCE_HTTPS_WITH_HOSTNAME", "ENFORCE_HTTPS_OFFICAL_CERTIFICATE",
  "ALLOW_SKYPE_OVER_HTTPS", "ALLOW_UNKNOWN_PROTOCOL_OVER_HTTPS",
  "ALLOW_GTALK_OVER_HTTPS", "ALLOW_YAHOOMSG_OVER_HTTPS",
  "ALLOW_AIM_OVER_HTTPS", "ALLOW_FBCHAT_OVER_HTTPS",
  "ALLOW_CITRIXONLINE_OVER_HTTPS", "ALLOW_ANYDESK_OVER_HTTPS",
  "ALLOW_TEAMVIEWER_OVER_HTTPS", "ANALYSE_UNCATEGORISED",
  "LOG_UNCATEGORISED_URLS", "UPLOAD_STATS", "SAFE_SEARCH",
  "MAX_LOGFILE_SIZE", "$accept", "start", "qidentifier",
  "https_cache_size", "allow_or_deny", "on_or_off", "log_pass",
  "log_block", "log_all", "logall_httpd", "youtube_edufilter",
  "youtube_edufilter_id", "allow_google_https_using_ip",
  "madvise_hugepages", "fast_refresh", "debug_filter", "debug_coredump",
  "enforce_https_with_hostname", "enforce_https_offical_certificate",
  "https_prohibit_insecure_sslv2", "https_prohibit_insecure_sslv3",
  "https_prohibit_insecure_tlsv1_0", "check_proxy_tunnel_option",
  "check_proxy_tunnels", "admin_spec", "dbhome", "refreshuserlist",
  "refreshiplist", "refreshdomainlist", "url_lookup_result_db_reload",
  "url_lookup_result_fatal_error", "url_lookup_delay_db_reload",
  "squid_version", "num_worker_threads", "upload_crash_reports",
  "lookup_reverse_ip", "use_ipv6_on_wan", "parse_url_parameters",
  "squid_uses_active_bumping", "ufdb_log_url_details",
  "ufdb_show_url_details", "ufdb_debug_skype_probes",
  "ufdb_debug_gtalk_probes", "ufdb_debug_yahoomsg_probes",
  "ufdb_debug_aim_probes", "ufdb_debug_fbchat_probes",
  "ufdb_debug_citrixonline_probes", "ufdb_expression_optimisation",
  "ufdb_expression_debug", "ufdb_debug_external_scripts", "mail_server",
  "my_hostname", "admin_email", "sender_email", "external_status_command",
  "logdir", "pidfile", "socket_type", "port", "interface", "cpus",
  "upload_stats", "redirect_https", "redirect_bumped_https",
  "redirect_loading_database", "redirect_fatal_error",
  "log_uncategorised_urls", "analyse_uncategorised",
  "strip_domain_from_username", "safe_search", "max_logfile_size",
  "httpd_option", "httpd_options", "http_server_def", "category",
  "category_block", "category_contents", "category_content", "source",
  "source_block", "source_contents", "source_content", "domain", "user",
  "acl_block", "acl_contents", "acl_header", "acl_content", "$@1",
  "access_contents", "access_content", "access_pass", "ipv4s", "ipv4",
  "ipv6s", "ipv6", "rew", "rew_block", "rew_contents", "rew_content",
  "time", "time_block", "time_contents", "time_content", "$@2", "$@3",
  "$@4", "$@5", "$@6", "$@7", "$@8", "ttime", "$@9", "date", "dval",
  "tval", "dvalcron", "an_error", "statements", "statement", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-374)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-263)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -374,    15,    67,  -374,  -374,    25,   370,    -5,   -54,     5,
      94,   311,   311,   311,   -36,   105,   119,    41,   -75,    81,
      81,   276,     6,    20,    31,  -374,   113,   120,   124,   132,
     297,   303,   311,   311,   311,   311,   134,   137,   141,   149,
     154,   311,   160,   311,   170,   170,   311,   311,   311,   179,
     311,   311,   311,   311,   311,   311,     7,   311,   311,   311,
     311,   311,   311,   311,   311,   311,   311,   311,   311,   158,
     311,   311,    18,   311,   311,   311,   161,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,   195,  -374,   200,  -374,  -374,   211,  -374,
     217,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,   240,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,   242,   258,   266,   281,   274,   219,   431,
     475,    38,    74,   232,   106,   305,   240,  -374,  -374,   -18,
    -374,  -374,  -374,   307,   249,    81,   286,   224,   335,   338,
     364,    81,    81,     3,   261,  -374,  -374,  -374,  -374,  -374,
    -374,   385,  -374,   396,  -374,   269,  -374,   410,    81,    81,
     234,   425,    81,    81,   116,  -374,  -374,  -374,    81,    81,
     121,  -374,  -374,  -374,   -14,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,    81,    81,     2,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,   429,   439,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,   454,  -374,   311,   311,   311,   311,   311,   311,   363,
     417,   311,   311,   311,   311,   311,   311,   311,   311,   311,
     311,   196,  -374,  -374,   111,  -374,  -374,   212,  -374,   465,
     473,   291,  -374,  -374,  -374,  -374,   241,  -374,  -374,  -374,
    -374,  -374,   476,  -374,  -374,  -374,  -374,   498,  -374,   294,
      81,   299,   136,   308,   310,   292,   503,  -374,   523,   123,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,    30,  -374,  -374,  -374,  -374,
    -374,   272,  -374,  -374,  -374,  -374,  -374,  -374,   291,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,   148,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,    78,   341,  -374,
    -374,  -374,  -374,  -374,   432,  -374,  -374,  -374,   525,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,   341,   341,   341,   345,
    -374,   348,   377,   348,   365,  -374,   222,  -374,  -374,  -374,
    -374,   348,   348,   348,   341,   341,   341,  -374,  -374,  -374,
     348,   382,  -374,   178,   341,  -374,  -374
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
     275,     0,     0,     1,   274,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   349,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   282,   284,   285,
     286,   287,   342,   344,   343,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   283,   281,   297,   325,   326,   327,
     306,   307,   305,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     328,   300,   301,   302,   303,   304,   298,   299,   329,   331,
     330,   332,   333,   334,   335,   336,   337,   339,   338,   341,
     340,   345,   280,   277,   279,     0,   278,   346,     0,   347,
       0,   348,   350,   276,    33,    29,    30,    31,    28,    32,
      70,    69,    71,     0,     4,     3,    73,    72,    10,     8,
       9,    25,    26,    27,     5,   100,    97,    98,    99,    96,
     235,   234,   197,    74,    75,   246,   152,    35,    34,    38,
      36,    37,    80,    79,    77,    78,    68,    67,    66,    65,
      11,    12,    13,    14,    60,    61,    62,    63,    64,    15,
      16,    17,     6,     7,    39,    40,    41,    50,    49,    42,
      48,    44,    45,    46,    47,    84,    21,    20,    22,    18,
      19,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      43,    23,    24,    83,    82,    81,    76,    85,    86,   102,
     154,   237,   248,     0,     0,     0,    94,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    95,   196,     0,
     205,   198,   101,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   103,   153,   179,   180,   187,
     222,     0,   229,     0,   188,     0,   192,     0,     0,     0,
       0,     0,     0,     0,     0,   155,   236,   239,     0,     0,
       0,   238,   261,   247,   253,   259,   249,    87,    89,    90,
      88,    92,    91,    93,   199,     0,     0,     0,   125,   124,
     106,   105,   104,   107,   110,   109,   108,   113,     0,     0,
     112,   111,   119,   118,   121,   120,   123,   122,   126,   127,
     151,     0,   150,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   173,   175,   174,   176,   178,   177,   156,   192,     0,
       0,   157,   160,   159,   163,   164,     0,   166,   165,   181,
     182,   186,     0,   185,   240,   241,   245,     0,   244,     0,
       0,     0,     0,     0,     0,   202,     0,   216,     0,     0,
     206,   115,   114,   117,   116,   149,   148,   136,   137,   138,
     128,   131,   129,   133,   135,   139,   147,   140,   141,   142,
     143,   144,   145,   146,   130,     0,   225,   228,   227,   226,
     223,     0,   232,   233,   230,   191,   190,   189,   158,   162,
     161,   168,   167,   195,   194,   193,     0,   184,   183,   243,
     242,   251,   254,   257,   271,   273,   260,   266,   270,   200,
     201,   203,   209,   208,   207,   211,   210,   215,     0,   214,
     224,   231,   172,   169,   170,   171,     0,     0,     0,     0,
     272,   265,     0,   269,     0,   217,     0,   221,   218,   213,
     212,   252,   255,   258,   268,     0,     0,   205,   219,   220,
     267,     0,   264,     0,     0,   204,   263
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -374,  -374,   -10,  -374,   380,    -9,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,   162,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,    52,  -374,  -374,  -374,  -374,  -374,   -76,
    -374,  -374,  -374,    -3,  -374,    -7,  -374,  -374,  -374,  -374,
    -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,  -374,
    -374,  -373,  -374,  -374,   -49,  -131,  -374,  -374,  -374,  -374
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,   455,    77,   214,   171,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,   159,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   256,   257,   142,   143,   144,   259,   285,   145,   146,
     260,   305,   377,   381,   147,   258,   270,   271,   494,   327,
     410,   474,   371,   440,   374,   444,   148,   149,   261,   311,
     150,   151,   262,   316,   399,   486,   400,   487,   401,   488,
     402,   491,   505,   466,   467,   492,   468,   152,     2,   153
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     167,   183,   184,   172,   173,   179,   181,   164,   168,   185,
     186,   188,   324,   160,  -256,     3,   169,   170,  -250,   168,
     197,   199,   162,   200,   201,   202,   203,   169,   170,   154,
     165,   350,   209,   405,   211,   163,   406,   216,   217,   218,
     174,   220,   221,   222,   223,   224,   225,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     161,   241,   242,   244,   245,   246,   247,    -2,     4,   306,
       5,   182,     6,   325,   326,   312,   436,   437,   438,   439,
     407,   408,   189,   226,     7,   164,     8,     9,    10,   489,
      11,    12,    13,    14,   243,   493,   190,   351,   164,   409,
      15,    16,    17,    18,    19,   313,   175,   191,   165,   164,
     164,    20,   176,   501,   502,   503,   490,   192,   307,    21,
     164,   165,    22,   164,   193,   164,   441,   164,   194,   308,
     309,   510,   165,   165,   318,   310,   195,    23,   204,    24,
     166,   205,    25,   165,   391,   206,   165,   180,   165,   396,
     165,   477,   319,   207,    26,    27,    28,    29,   208,   314,
     315,   442,   443,    30,   210,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,   464,   465,    41,    42,    43,
      44,    45,    46,   219,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,   515,
     392,   435,   406,   177,   178,   397,   164,   478,    72,    73,
      74,    75,    76,   164,   482,   249,   164,   445,   164,   508,
     250,   483,   484,   485,   240,   337,   338,   248,   339,   165,
     446,   251,   436,   437,   438,   439,   165,   252,   269,   165,
     268,   165,   340,   164,   320,   322,   407,   408,   263,   253,
     330,   254,   255,   329,   332,   333,   336,   341,   343,   345,
     347,   348,   349,   352,   264,   409,   165,   331,   212,   213,
     164,   373,   265,   376,   353,   354,   355,   383,   384,   385,
     164,   388,   389,   390,   393,   164,   266,   334,   394,   395,
     398,   164,   356,   165,   187,   267,   453,   164,   317,   164,
     386,   164,   168,   165,   335,   403,   404,   456,   165,   454,
     169,   170,   442,   443,   165,   196,   461,   463,   412,   414,
     165,   198,   165,   321,   165,   328,   378,   379,   469,   164,
     470,   416,   164,   380,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   165,   342,   168,   165,   344,   447,   164,   450,
     452,   357,   169,   170,   511,   512,   155,   156,   157,   490,
     158,   358,   458,   516,   464,   471,  -262,   460,   506,   164,
     462,   165,   346,   514,  -132,   507,   473,  -132,   476,   479,
     164,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   165,   372,   164,   370,  -132,  -132,   168,  -132,
    -132,  -132,  -132,   165,   375,   215,   169,   170,   323,   164,
     448,   513,   480,   164,   481,     0,   164,   165,   382,   495,
     504,     0,  -132,   164,     0,   496,     0,   497,  -134,     0,
       0,  -134,   165,   387,  -132,  -132,   165,   411,   164,   165,
    -132,     0,   272,     0,   498,   273,   165,   413,   500,   164,
    -134,  -134,     0,  -134,  -134,  -134,  -134,   164,     0,  -132,
     164,   165,   415,     0,   274,   275,   509,   276,   277,   278,
     279,     0,   165,   449,     0,     0,  -134,     0,     0,     0,
     165,   451,   164,   165,   457,     0,   286,   164,  -134,  -134,
     280,     0,     0,     0,  -134,     0,     0,   287,   288,     0,
     289,     0,   281,   282,     0,   165,   459,   164,   283,   164,
     165,   472,     0,  -134,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,     0,   299,   284,   300,   301,
     165,   475,   165,   499,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   302,   303,     0,     0,
       0,     0,   304
};

static const yytype_int16 yycheck[] =
{
      10,    76,    77,    12,    13,    15,    16,     4,     1,    19,
      20,    21,    30,    18,    28,     0,     9,    10,    32,     1,
      30,    31,    76,    32,    33,    34,    35,     9,    10,     4,
      27,    28,    41,    31,    43,    30,    34,    46,    47,    48,
      76,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      65,    70,    71,    72,    73,    74,    75,     0,     1,    31,
       3,    30,     5,    91,    92,     1,    46,    47,    48,    49,
      78,    79,    76,    76,    17,     4,    19,    20,    21,    11,
      23,    24,    25,    26,    76,   468,    76,    94,     4,    97,
      33,    34,    35,    36,    37,    31,     1,    76,    27,     4,
       4,    44,     7,   486,   487,   488,    38,     4,    80,    52,
       4,    27,    55,     4,     4,     4,    15,     4,     4,    91,
      92,   504,    27,    27,    28,    97,     4,    70,     4,    72,
      46,     4,    75,    27,    28,     4,    27,    28,    27,    28,
      27,    28,    46,     4,    87,    88,    89,    90,     4,    85,
      86,    50,    51,    96,     4,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,    39,    40,   110,   111,   112,
     113,   114,   115,     4,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,    31,
      94,    15,    34,   108,   109,    94,     4,    94,   151,   152,
     153,   154,   155,     4,    76,    30,     4,    15,     4,     7,
      30,    83,    84,    85,    76,    11,    12,    76,    14,    27,
      28,    30,    46,    47,    48,    49,    27,    30,   258,    27,
      31,    27,    28,     4,   264,   265,    78,    79,    16,    19,
      11,    21,    22,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,    16,    97,    27,    28,   108,   109,
       4,   291,    16,   293,    23,    24,    25,   297,   298,   299,
       4,   301,   302,   303,   304,     4,    15,    11,   308,   309,
     310,     4,    41,    27,    28,    31,    15,     4,    76,     4,
      76,     4,     1,    27,    28,   325,   326,    76,    27,    28,
       9,    10,    50,    51,    27,    28,    32,    28,   338,   339,
      27,    28,    27,    28,    27,    28,    67,    68,    30,     4,
      30,   351,     4,    74,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,    27,    28,     1,    27,    28,   377,     4,   379,
     380,   110,     9,    10,   505,   506,     6,     7,     8,    38,
      10,   120,   392,   514,    39,    93,    38,   397,    11,     4,
     400,    27,    28,    11,    31,    30,   406,    34,   408,   409,
       4,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,    27,    28,     4,   154,    53,    54,     1,    56,
      57,    58,    59,    27,    28,    45,     9,    10,   266,     4,
     378,   507,   435,     4,   441,    -1,     4,    27,    28,     7,
     489,    -1,    79,     4,    -1,    13,    -1,    15,    31,    -1,
      -1,    34,    27,    28,    91,    92,    27,    28,     4,    27,
      97,    -1,    31,    -1,   474,    34,    27,    28,   478,     4,
      53,    54,    -1,    56,    57,    58,    59,     4,    -1,   116,
       4,    27,    28,    -1,    53,    54,   496,    56,    57,    58,
      59,    -1,    27,    28,    -1,    -1,    79,    -1,    -1,    -1,
      27,    28,     4,    27,    28,    -1,    31,     4,    91,    92,
      79,    -1,    -1,    -1,    97,    -1,    -1,    42,    43,    -1,
      45,    -1,    91,    92,    -1,    27,    28,     4,    97,     4,
      27,    28,    -1,   116,    -1,    60,    61,    62,    63,    64,
      65,    -1,    67,    68,    69,    -1,    71,   116,    73,    74,
      27,    28,    27,    28,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    -1,    -1,
      -1,    -1,    97
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   157,   274,     0,     1,     3,     5,    17,    19,    20,
      21,    23,    24,    25,    26,    33,    34,    35,    36,    37,
      44,    52,    55,    70,    72,    75,    87,    88,    89,    90,
      96,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   110,   111,   112,   113,   114,   115,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   151,   152,   153,   154,   155,   159,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   229,   230,   231,   234,   235,   240,   252,   253,
     256,   257,   273,   275,     4,     6,     7,     8,    10,   178,
      18,    65,    76,    30,     4,    27,    46,   158,     1,     9,
      10,   161,   161,   161,    76,     1,     7,   108,   109,   158,
      28,   158,    30,    76,    77,   158,   158,    28,   158,    76,
      76,    76,     4,     4,     4,     4,    28,   158,    28,   158,
     161,   161,   161,   161,     4,     4,     4,     4,     4,   161,
       4,   161,   108,   109,   160,   160,   161,   161,   161,     4,
     161,   161,   161,   161,   161,   161,    76,   161,   161,   161,
     161,   161,   161,   161,   161,   161,   161,   161,   161,   161,
      76,   161,   161,    76,   161,   161,   161,   161,    76,    30,
      30,    30,    30,    19,    21,    22,   227,   228,   241,   232,
     236,   254,   258,    16,    16,    16,    15,    31,    31,   158,
     242,   243,    31,    34,    53,    54,    56,    57,    58,    59,
      79,    91,    92,    97,   116,   233,    31,    42,    43,    45,
      60,    61,    62,    63,    64,    65,    67,    68,    69,    71,
      73,    74,    91,    92,    97,   237,    31,    80,    91,    92,
      97,   255,     1,    31,    85,    86,   259,    76,    28,    46,
     158,    28,   158,   228,    30,    91,    92,   245,    28,   158,
      11,    28,   158,   158,    11,    28,   158,    11,    12,    14,
      28,   158,    28,   158,    28,   158,    28,   158,   158,   158,
      28,    94,   158,    23,    24,    25,    41,   110,   120,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     154,   248,    28,   158,   250,    28,   158,   238,    67,    68,
      74,   239,    28,   158,   158,   158,    76,    28,   158,   158,
     158,    28,    94,   158,   158,   158,    28,    94,   158,   260,
     262,   264,   266,   158,   158,    31,    34,    78,    79,    97,
     246,    28,   158,    28,   158,    28,   158,   161,   161,   161,
     161,   161,   161,   161,   161,   161,   161,   161,   161,   161,
     161,   161,   161,   161,   161,    15,    46,    47,    48,    49,
     249,    15,    50,    51,   251,    15,    28,   158,   239,    28,
     158,    28,   158,    15,    28,   158,    76,    28,   158,    28,
     158,    32,   158,    28,    39,    40,   269,   270,   272,    30,
      30,    93,    28,   158,   247,    28,   158,    28,    94,   158,
     249,   251,    76,    83,    84,    85,   261,   263,   265,    11,
      38,   267,   271,   267,   244,     7,    13,    15,   158,    28,
     158,   267,   267,   267,   270,   268,    11,    30,     7,   158,
     267,   271,   271,   245,    11,    31,   271
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   156,   157,   158,   158,   159,   160,   160,   161,   161,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   171,   172,   173,   174,   175,   176,   177,   178,   178,
     178,   178,   179,   180,   181,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   211,   212,   212,   213,
     213,   214,   215,   215,   216,   216,   217,   218,   219,   220,
     221,   222,   223,   223,   224,   225,   226,   227,   227,   227,
     227,   227,   227,   228,   228,   229,   230,   230,   230,   230,
     230,   231,   232,   232,   233,   233,   233,   233,   233,   233,
     233,   233,   233,   233,   233,   233,   233,   233,   233,   233,
     233,   233,   233,   233,   233,   233,   233,   233,   233,   233,
     233,   233,   233,   233,   233,   233,   233,   233,   233,   233,
     233,   233,   233,   233,   233,   233,   233,   233,   233,   233,
     233,   233,   234,   235,   236,   236,   237,   237,   237,   237,
     237,   237,   237,   237,   237,   237,   237,   237,   237,   237,
     237,   237,   237,   237,   237,   237,   237,   237,   237,   237,
     237,   237,   237,   237,   237,   237,   237,   237,   238,   238,
     238,   238,   239,   239,   239,   239,   240,   241,   241,   242,
     242,   242,   243,   244,   243,   245,   245,   246,   246,   246,
     246,   246,   246,   246,   246,   246,   247,   247,   247,   247,
     247,   247,   248,   248,   248,   249,   249,   249,   249,   250,
     250,   250,   251,   251,   252,   252,   253,   254,   254,   255,
     255,   255,   255,   255,   255,   255,   256,   257,   258,   258,
     260,   261,   259,   262,   263,   259,   264,   265,   259,   266,
     259,   259,   268,   267,   267,   269,   269,   269,   269,   269,
     269,   270,   271,   272,   273,   274,   274,   275,   275,   275,
     275,   275,   275,   275,   275,   275,   275,   275,   275,   275,
     275,   275,   275,   275,   275,   275,   275,   275,   275,   275,
     275,   275,   275,   275,   275,   275,   275,   275,   275,   275,
     275,   275,   275,   275,   275,   275,   275,   275,   275,   275,
     275,   275,   275,   275,   275,   275,   275,   275,   275,   275,
     275,   275,   275,   275,   275,   275,   275,   275,   275,   275,
     275,   275,   275,   275,   275,   275,   275,   275,   275,   275,
     275
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     1,     1,
       1,     1,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     3,     3,     3,
       3,     3,     3,     3,     1,     4,     2,     2,     2,     2,
       2,     4,     0,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     3,     3,     3,     3,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     3,     3,
       3,     3,     2,     3,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     2,     2,     4,     0,     2,     2,     2,     3,     2,
       2,     3,     3,     2,     2,     2,     2,     3,     3,     4,
       4,     4,     4,     2,     2,     2,     2,     2,     2,     1,
       1,     2,     2,     3,     3,     2,     2,     1,     0,     2,
       2,     2,     0,     2,     2,     2,     4,     0,     2,     2,
       4,     4,     3,     0,     8,     0,     2,     2,     2,     2,
       2,     2,     3,     3,     2,     2,     0,     2,     2,     3,
       3,     2,     0,     2,     3,     1,     1,     1,     1,     0,
       2,     3,     1,     1,     2,     2,     4,     0,     2,     1,
       2,     2,     3,     3,     2,     2,     2,     4,     0,     2,
       0,     0,     5,     0,     0,     5,     0,     0,     5,     0,
       3,     1,     0,     5,     3,     2,     1,     4,     3,     2,
       1,     1,     1,     1,     1,     0,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* qidentifier: IDENTIFIER  */
#line 231 "grammar.y"
                                { (yyval.string) = (yyvsp[0].string); }
#line 1937 "grammar.tab.c"
    break;

  case 4: /* qidentifier: QSTRING  */
#line 232 "grammar.y"
                                { (yyval.string) = (yyvsp[0].string); }
#line 1943 "grammar.tab.c"
    break;

  case 5: /* https_cache_size: HTTPS_CONNECTION_CACHE_SIZE NUMBER  */
#line 236 "grammar.y"
                                                       { ufdbNewGV.httpsConnectionCacheSize = atoi( (yyvsp[0].string) );
		                                         ufdbFree( (yyvsp[0].string) ); }
#line 1950 "grammar.tab.c"
    break;

  case 6: /* allow_or_deny: TOKEN_ALLOW  */
#line 241 "grammar.y"
                                { (yyval.integer) = UFDB_ALLOW; }
#line 1956 "grammar.tab.c"
    break;

  case 7: /* allow_or_deny: TOKEN_DENY  */
#line 242 "grammar.y"
                                { (yyval.integer) = UFDB_DENY; }
#line 1962 "grammar.tab.c"
    break;

  case 8: /* on_or_off: ON  */
#line 246 "grammar.y"
                        { (yyval.integer) = 1; }
#line 1968 "grammar.tab.c"
    break;

  case 9: /* on_or_off: OFF  */
#line 247 "grammar.y"
                        { (yyval.integer) = 0; }
#line 1974 "grammar.tab.c"
    break;

  case 10: /* on_or_off: error  */
#line 248 "grammar.y"
                        { ufdbLogFatalError( "syntax error at line %d: expected 'on' or 'off'", lineno );   }
#line 1980 "grammar.tab.c"
    break;

  case 11: /* log_pass: LOGPASS on_or_off  */
#line 252 "grammar.y"
                                        { ufdbNewGV.logPass = (yyvsp[0].integer); }
#line 1986 "grammar.tab.c"
    break;

  case 12: /* log_block: LOGBLOCK on_or_off  */
#line 256 "grammar.y"
                                        { ufdbNewGV.logBlock = (yyvsp[0].integer); }
#line 1992 "grammar.tab.c"
    break;

  case 13: /* log_all: LOGALL on_or_off  */
#line 260 "grammar.y"
                                        { ufdbNewGV.logAllRequests = (yyvsp[0].integer); }
#line 1998 "grammar.tab.c"
    break;

  case 14: /* logall_httpd: LOGALL_HTTPD on_or_off  */
#line 264 "grammar.y"
                                                 { ufdbNewGV.debugHttpd = (yyvsp[0].integer); }
#line 2004 "grammar.tab.c"
    break;

  case 15: /* youtube_edufilter: YOUTUBE_EDUFILTER on_or_off  */
#line 268 "grammar.y"
                                                 { ufdbNewGV.YoutubeEdufilter = (yyvsp[0].integer); }
#line 2010 "grammar.tab.c"
    break;

  case 16: /* youtube_edufilter_id: YOUTUBE_EDUFILTER_ID QSTRING  */
#line 272 "grammar.y"
                                                 { ufdbNewGV.YoutubeEdufilterID = (yyvsp[0].string); }
#line 2016 "grammar.tab.c"
    break;

  case 17: /* allow_google_https_using_ip: ALLOW_GOOGLE_HTTPS_USING_IP on_or_off  */
#line 276 "grammar.y"
                                                          { ufdbNewGV.allowGoogleHTTPSusingIP = (yyvsp[0].integer); }
#line 2022 "grammar.tab.c"
    break;

  case 18: /* madvise_hugepages: MADVISE_HUGEPAGES on_or_off  */
#line 280 "grammar.y"
                                                { ufdbNewGV.madviseHugePages = (yyvsp[0].integer); }
#line 2028 "grammar.tab.c"
    break;

  case 19: /* fast_refresh: FAST_REFRESH on_or_off  */
#line 284 "grammar.y"
                                                { ufdbNewGV.fastRefresh = (yyvsp[0].integer); }
#line 2034 "grammar.tab.c"
    break;

  case 20: /* debug_filter: UFDB_DEBUG_FILTER on_or_off  */
#line 288 "grammar.y"
                                                { ufdbNewGV.debug = ufdbGV.debug = (yyvsp[0].integer); }
#line 2040 "grammar.tab.c"
    break;

  case 21: /* debug_filter: UFDB_DEBUG_FILTER NUMBER  */
#line 289 "grammar.y"
                                                { ufdbNewGV.debug = ufdbGV.debug = atoi( (yyvsp[0].string) );
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 2047 "grammar.tab.c"
    break;

  case 22: /* debug_coredump: UFDB_DEBUG_COREDUMP on_or_off  */
#line 294 "grammar.y"
                                                { ufdbNewGV.debugCoreDump = (yyvsp[0].integer); }
#line 2053 "grammar.tab.c"
    break;

  case 23: /* enforce_https_with_hostname: ENFORCE_HTTPS_WITH_HOSTNAME on_or_off  */
#line 299 "grammar.y"
                    { ufdbLogError( "line %d: option enforce-https-with-hostname must be part of "
                                    "the security category", lineno );  }
#line 2060 "grammar.tab.c"
    break;

  case 24: /* enforce_https_offical_certificate: ENFORCE_HTTPS_OFFICAL_CERTIFICATE on_or_off  */
#line 305 "grammar.y"
                  { ufdbLogError( "line %d: option enforce-https-official-certificate must be part of "
                                  "the security category", lineno );  }
#line 2067 "grammar.tab.c"
    break;

  case 25: /* https_prohibit_insecure_sslv2: HTTPS_PROHIBIT_INSECURE_SSLV2 on_or_off  */
#line 311 "grammar.y"
                    { ufdbLogError( "line %d: option https-prohibit-insecure-sslv2 must be part of "
                                    "the security category", lineno );  }
#line 2074 "grammar.tab.c"
    break;

  case 26: /* https_prohibit_insecure_sslv3: HTTPS_PROHIBIT_INSECURE_SSLV3 on_or_off  */
#line 317 "grammar.y"
                    { ufdbLogError( "line %d: option https-prohibit-insecure-sslv3 must be part of "
                                    "the security category", lineno );  }
#line 2081 "grammar.tab.c"
    break;

  case 27: /* https_prohibit_insecure_tlsv1_0: HTTPS_PROHIBIT_INSECURE_TLSV1_0 on_or_off  */
#line 323 "grammar.y"
                    { ufdbLogError( "line %d: option https-prohibit-insecure-tlsv1_0 must be part of "
                                    "the security category", lineno );  }
#line 2088 "grammar.tab.c"
    break;

  case 28: /* check_proxy_tunnel_option: OFF  */
#line 329 "grammar.y"
                                { (yyval.integer) = UFDB_API_HTTPS_CHECK_OFF; }
#line 2094 "grammar.tab.c"
    break;

  case 29: /* check_proxy_tunnel_option: QUEUE_CHECKS  */
#line 330 "grammar.y"
                                { (yyval.integer) = UFDB_API_HTTPS_CHECK_QUEUE_CHECKS; }
#line 2100 "grammar.tab.c"
    break;

  case 30: /* check_proxy_tunnel_option: AGGRESSIVE  */
#line 331 "grammar.y"
                                { (yyval.integer) = UFDB_API_HTTPS_CHECK_AGGRESSIVE; }
#line 2106 "grammar.tab.c"
    break;

  case 31: /* check_proxy_tunnel_option: LOG_ONLY  */
#line 332 "grammar.y"
                                { (yyval.integer) = UFDB_API_HTTPS_LOG_ONLY; }
#line 2112 "grammar.tab.c"
    break;

  case 32: /* check_proxy_tunnels: CHECK_PROXY_TUNNELS check_proxy_tunnel_option  */
#line 336 "grammar.y"
                                                                { ufdbNewGV.tunnelCheckMethod = (yyvsp[0].integer); }
#line 2118 "grammar.tab.c"
    break;

  case 33: /* admin_spec: ADMINISTRATOR QSTRING  */
#line 340 "grammar.y"
                                         { setAdministrator( (yyvsp[0].string) ); }
#line 2124 "grammar.tab.c"
    break;

  case 34: /* dbhome: DBHOME qidentifier  */
#line 344 "grammar.y"
                                     { setDBhome( (yyvsp[0].string) ); }
#line 2130 "grammar.tab.c"
    break;

  case 35: /* dbhome: DBHOME WORD  */
#line 345 "grammar.y"
                                     { setDBhome( (yyvsp[0].string) ); }
#line 2136 "grammar.tab.c"
    break;

  case 36: /* refreshuserlist: REFRESHUSERLIST NUMBER  */
#line 349 "grammar.y"
                                              { setRefreshUserlist( atoi((yyvsp[0].string)) );
		                                ufdbFree( (yyvsp[0].string) ); }
#line 2143 "grammar.tab.c"
    break;

  case 37: /* refreshiplist: REFRESHIPLIST NUMBER  */
#line 354 "grammar.y"
                                              { setRefreshIPlist( atoi((yyvsp[0].string)) );
		                                ufdbFree( (yyvsp[0].string) ); }
#line 2150 "grammar.tab.c"
    break;

  case 38: /* refreshdomainlist: REFRESHDOMAINLIST NUMBER  */
#line 359 "grammar.y"
                                              { setRefreshDomainlist( atoi((yyvsp[0].string)) );
		                                ufdbFree( (yyvsp[0].string) ); }
#line 2157 "grammar.tab.c"
    break;

  case 39: /* url_lookup_result_db_reload: URL_LOOKUP_RESULT_DB_RELOAD allow_or_deny  */
#line 365 "grammar.y"
                                        { ufdbNewGV.URLlookupResultDBreload = (yyvsp[0].integer); }
#line 2163 "grammar.tab.c"
    break;

  case 40: /* url_lookup_result_fatal_error: URL_LOOKUP_RESULT_FATAL_ERROR allow_or_deny  */
#line 369 "grammar.y"
                                        { ufdbNewGV.URLlookupResultFatalError = (yyvsp[0].integer); }
#line 2169 "grammar.tab.c"
    break;

  case 41: /* url_lookup_delay_db_reload: URL_LOOKUP_DELAY_DB_RELOAD on_or_off  */
#line 373 "grammar.y"
                                        { ufdbNewGV.URLlookupDelayDBreload = (yyvsp[0].integer); }
#line 2175 "grammar.tab.c"
    break;

  case 42: /* squid_version: SQUID_VERSION QSTRING  */
#line 377 "grammar.y"
                                        { ufdbFree( ufdbNewGV.SquidVersion );  ufdbNewGV.SquidVersion = (yyvsp[0].string);  }
#line 2181 "grammar.tab.c"
    break;

  case 43: /* num_worker_threads: UFDB_NUM_WORKER_THREADS NUMBER  */
#line 382 "grammar.y"
                                        { int new_n_workers;
					  /* ONLY increase #workers */
					  new_n_workers = atoi( (yyvsp[0].string) );  
		                          ufdbFree( (yyvsp[0].string) );
					  if (new_n_workers < UFDB_MIN_THREADS)
					  {
					     ufdbLogError( "num-worker-threads must be at least %d",
                                                           UFDB_MIN_THREADS );
					     new_n_workers = UFDB_MIN_THREADS;
					  }
					  else if (new_n_workers > UFDB_MAX_THREADS)
					  {
					     ufdbLogError( "num-worker-threads can be at most %d",
                                                           UFDB_MAX_THREADS );
					     new_n_workers = UFDB_MAX_THREADS;
					  }
					  if (new_n_workers > ufdbNewGV.nWorkers)
					     ufdbNewGV.nWorkers = new_n_workers;
					}
#line 2205 "grammar.tab.c"
    break;

  case 44: /* upload_crash_reports: UPLOAD_CRASH_REPORTS on_or_off  */
#line 405 "grammar.y"
                                        { ufdbNewGV.uploadCrashReports = (yyvsp[0].integer);  }
#line 2211 "grammar.tab.c"
    break;

  case 45: /* lookup_reverse_ip: LOOKUP_REVERSE_IP on_or_off  */
#line 410 "grammar.y"
                                        { ufdbNewGV.lookupReverseIP = (yyvsp[0].integer);  }
#line 2217 "grammar.tab.c"
    break;

  case 46: /* use_ipv6_on_wan: USE_IPV6_ON_WAN on_or_off  */
#line 415 "grammar.y"
                                        { ufdbNewGV.useAlsoIPv6onWan = (yyvsp[0].integer);  }
#line 2223 "grammar.tab.c"
    break;

  case 47: /* parse_url_parameters: PARSE_URL_PARAMETERS on_or_off  */
#line 420 "grammar.y"
                                        { ufdbNewGV.parseURLparameters = (yyvsp[0].integer);  }
#line 2229 "grammar.tab.c"
    break;

  case 48: /* squid_uses_active_bumping: SQUID_USES_ACTIVE_BUMPING on_or_off  */
#line 425 "grammar.y"
                                        { ufdbNewGV.SquidUsesActiveBumping = (yyvsp[0].integer);  }
#line 2235 "grammar.tab.c"
    break;

  case 49: /* ufdb_log_url_details: UFDB_LOG_URL_DETAILS on_or_off  */
#line 429 "grammar.y"
                                                  { ufdbNewGV.logURLdetails = (yyvsp[0].integer); }
#line 2241 "grammar.tab.c"
    break;

  case 50: /* ufdb_show_url_details: UFDB_SHOW_URL_DETAILS on_or_off  */
#line 433 "grammar.y"
                                                   { ufdbNewGV.showURLdetails = (yyvsp[0].integer); }
#line 2247 "grammar.tab.c"
    break;

  case 51: /* ufdb_debug_skype_probes: UFDB_DEBUG_SKYPE_PROBES on_or_off  */
#line 437 "grammar.y"
                                                     { ufdbNewGV.debugSkype = (yyvsp[0].integer); }
#line 2253 "grammar.tab.c"
    break;

  case 52: /* ufdb_debug_gtalk_probes: UFDB_DEBUG_GTALK_PROBES on_or_off  */
#line 441 "grammar.y"
                                                     { ufdbNewGV.debugGtalk = (yyvsp[0].integer); }
#line 2259 "grammar.tab.c"
    break;

  case 53: /* ufdb_debug_yahoomsg_probes: UFDB_DEBUG_YAHOOMSG_PROBES on_or_off  */
#line 445 "grammar.y"
                                                        { ufdbNewGV.debugYahooMsg = (yyvsp[0].integer); }
#line 2265 "grammar.tab.c"
    break;

  case 54: /* ufdb_debug_aim_probes: UFDB_DEBUG_AIM_PROBES on_or_off  */
#line 449 "grammar.y"
                                                   { ufdbNewGV.debugAim = (yyvsp[0].integer); }
#line 2271 "grammar.tab.c"
    break;

  case 55: /* ufdb_debug_fbchat_probes: UFDB_DEBUG_FBCHAT_PROBES on_or_off  */
#line 453 "grammar.y"
                                                      { ufdbNewGV.debugFBchat = (yyvsp[0].integer); }
#line 2277 "grammar.tab.c"
    break;

  case 56: /* ufdb_debug_citrixonline_probes: UFDB_DEBUG_CITRIXONLINE_PROBES on_or_off  */
#line 457 "grammar.y"
                                                            { ufdbNewGV.debugCitrixOnline = (yyvsp[0].integer); }
#line 2283 "grammar.tab.c"
    break;

  case 57: /* ufdb_expression_optimisation: UFDB_EXPRESSION_OPTIMISATION on_or_off  */
#line 461 "grammar.y"
                                                          { ufdbNewGV.expressionOptimisation = (yyvsp[0].integer); }
#line 2289 "grammar.tab.c"
    break;

  case 58: /* ufdb_expression_debug: UFDB_EXPRESSION_DEBUG on_or_off  */
#line 465 "grammar.y"
                                                   { ufdbNewGV.debugRegexp = (yyvsp[0].integer); }
#line 2295 "grammar.tab.c"
    break;

  case 59: /* ufdb_debug_external_scripts: UFDB_DEBUG_EXTERNAL_SCRIPTS on_or_off  */
#line 469 "grammar.y"
                                                         { ufdbNewGV.debugExternalScripts = (yyvsp[0].integer); }
#line 2301 "grammar.tab.c"
    break;

  case 60: /* mail_server: MAIL_SERVER QSTRING  */
#line 473 "grammar.y"
                                       { ufdbFree( ufdbNewGV.emailServer ); ufdbNewGV.emailServer = (yyvsp[0].string); }
#line 2307 "grammar.tab.c"
    break;

  case 61: /* my_hostname: MY_HOSTNAME QSTRING  */
#line 477 "grammar.y"
                                       { ufdbFree( ufdbNewGV.myHostname ); ufdbNewGV.myHostname = (yyvsp[0].string); }
#line 2313 "grammar.tab.c"
    break;

  case 62: /* admin_email: ADMIN_EMAIL QSTRING  */
#line 481 "grammar.y"
                                       { ufdbFree( ufdbNewGV.adminEmail ); ufdbNewGV.adminEmail = (yyvsp[0].string); }
#line 2319 "grammar.tab.c"
    break;

  case 63: /* sender_email: SENDER_EMAIL QSTRING  */
#line 485 "grammar.y"
                                       { ufdbFree( ufdbNewGV.senderEmail ); ufdbNewGV.senderEmail = (yyvsp[0].string); }
#line 2325 "grammar.tab.c"
    break;

  case 64: /* external_status_command: EXTERNAL_STATUS_COMMAND QSTRING  */
#line 489 "grammar.y"
                                                    {  ufdbFree( ufdbNewGV.externalStatusCommand );  
		                                       ufdbNewGV.externalStatusCommand = (yyvsp[0].string); }
#line 2332 "grammar.tab.c"
    break;

  case 65: /* logdir: LOGDIR qidentifier  */
#line 494 "grammar.y"
                                       { setLogdir( (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) ); }
#line 2338 "grammar.tab.c"
    break;

  case 66: /* logdir: LOGDIR WORD  */
#line 495 "grammar.y"
                                       { setLogdir( (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) ); }
#line 2344 "grammar.tab.c"
    break;

  case 67: /* pidfile: PIDFILE qidentifier  */
#line 499 "grammar.y"
                                       { setPidfile( (yyvsp[0].string) ); }
#line 2350 "grammar.tab.c"
    break;

  case 68: /* pidfile: PIDFILE WORD  */
#line 500 "grammar.y"
                                       { setPidfile( (yyvsp[0].string) ); }
#line 2356 "grammar.tab.c"
    break;

  case 69: /* socket_type: SOCKET_TYPE UNIX  */
#line 504 "grammar.y"
                                       { ufdbNewGV.socketType = UFDB_SOCKETTYPE_UNIX; }
#line 2362 "grammar.tab.c"
    break;

  case 70: /* socket_type: SOCKET_TYPE TCP  */
#line 505 "grammar.y"
                                       { ufdbNewGV.socketType = UFDB_SOCKETTYPE_TCP;  }
#line 2368 "grammar.tab.c"
    break;

  case 71: /* port: PORT NUMBER  */
#line 509 "grammar.y"
                                       { ufdbNewGV.portNum = atoi( (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) ); 
                                         if (ufdbNewGV.portNum <= 0)
                                         {
                                            ufdbLogError( "port number must be > 0, using default port %d",
                                                          UFDB_DAEMON_PORT );
                                            ufdbNewGV.portNum = UFDB_DAEMON_PORT;
                                         }
                                       }
#line 2381 "grammar.tab.c"
    break;

  case 72: /* interface: INTERFACE qidentifier  */
#line 520 "grammar.y"
                                           { 
		                             if (strcmp( (yyvsp[0].string), "all" ) == 0)
						strcpy( ufdbNewGV.interface, "all" );    
					     else
					        ufdbLogFatalError( "interface must be \"all\" or IPv4 address" );
					     ufdbFree( (yyvsp[0].string) );
					   }
#line 2393 "grammar.tab.c"
    break;

  case 73: /* interface: INTERFACE IPV4ADDR  */
#line 527 "grammar.y"
                                     { strcpy( ufdbNewGV.interface, (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) ); }
#line 2399 "grammar.tab.c"
    break;

  case 74: /* cpus: CPUS NUMBER  */
#line 531 "grammar.y"
                                     { ufdbSetCPU( (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 2405 "grammar.tab.c"
    break;

  case 75: /* cpus: CPUS NUMBERS  */
#line 532 "grammar.y"
                                     { ufdbSetCPU( (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 2411 "grammar.tab.c"
    break;

  case 76: /* upload_stats: UPLOAD_STATS on_or_off  */
#line 537 "grammar.y"
                     { ufdbNewGV.uploadStats = (yyvsp[0].integer);   }
#line 2417 "grammar.tab.c"
    break;

  case 77: /* redirect_https: REDIRECT_HTTPS QSTRING  */
#line 542 "grammar.y"
                     { strcpy( ufdbNewGV.redirectHttps, (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) );  }
#line 2423 "grammar.tab.c"
    break;

  case 78: /* redirect_bumped_https: REDIRECT_BUMPED_HTTPS QSTRING  */
#line 547 "grammar.y"
                     { strcpy( ufdbNewGV.redirectBumpedHttps, (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) );  }
#line 2429 "grammar.tab.c"
    break;

  case 79: /* redirect_loading_database: REDIRECT_LOADING_DATABASE QSTRING  */
#line 552 "grammar.y"
                     { strcpy( ufdbNewGV.loadingDatabaseRedirect, (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) );  }
#line 2435 "grammar.tab.c"
    break;

  case 80: /* redirect_fatal_error: REDIRECT_FATAL_ERROR QSTRING  */
#line 557 "grammar.y"
                     { strcpy( ufdbNewGV.fatalErrorRedirect, (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) );  }
#line 2441 "grammar.tab.c"
    break;

  case 81: /* log_uncategorised_urls: LOG_UNCATEGORISED_URLS on_or_off  */
#line 562 "grammar.y"
                     {
			ufdbNewGV.logUncategorisedURLs = (yyvsp[0].integer);   
		     }
#line 2449 "grammar.tab.c"
    break;

  case 82: /* analyse_uncategorised: ANALYSE_UNCATEGORISED on_or_off  */
#line 569 "grammar.y"
                     { 
			ufdbNewGV.analyseUncategorisedURLs = (yyvsp[0].integer);   
		     }
#line 2457 "grammar.tab.c"
    break;

  case 83: /* analyse_uncategorised: ANALYSE_UNCATEGORISED NUMBER  */
#line 574 "grammar.y"
                     {
			ufdbNewGV.analyseUncategorisedURLs = atoi( (yyvsp[0].string) ); 
			ufdbFree( (yyvsp[0].string) ); 
		     }
#line 2466 "grammar.tab.c"
    break;

  case 84: /* strip_domain_from_username: STRIP_DOMAIN_FROM_USERNAME on_or_off  */
#line 582 "grammar.y"
                     {
		        ufdbNewGV.stripDomainFromUsername = (yyvsp[0].integer);
		     }
#line 2474 "grammar.tab.c"
    break;

  case 85: /* safe_search: SAFE_SEARCH on_or_off  */
#line 589 "grammar.y"
                     { ufdbNewGV.safeSearch = (yyvsp[0].integer); }
#line 2480 "grammar.tab.c"
    break;

  case 86: /* max_logfile_size: MAX_LOGFILE_SIZE NUMBER  */
#line 594 "grammar.y"
                     { 
		       ufdbNewGV.maxLogfileSize = strtoul( (yyvsp[0].string), NULL, 10 );
		       ufdbFree( (yyvsp[0].string) );
		       if (ufdbNewGV.maxLogfileSize < 2 * 1024 * 1024)		// minimum is 2 MB
		          ufdbNewGV.maxLogfileSize = 2 * 1024 * 1024;
		       if (ufdbNewGV.maxLogfileSize > 500000000000)	        // maximum is 500 GB
		          ufdbNewGV.maxLogfileSize = 500000000000;
                       ufdbGV.maxLogfileSize = ufdbNewGV.maxLogfileSize;        // we want immediate effect
		     }
#line 2494 "grammar.tab.c"
    break;

  case 87: /* httpd_option: PORT EQUAL NUMBER  */
#line 606 "grammar.y"
                                           { ufdbNewGV.httpdPort = atoi( (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 2500 "grammar.tab.c"
    break;

  case 88: /* httpd_option: INTERFACE EQUAL qidentifier  */
#line 607 "grammar.y"
                                              { if (strcmp((yyvsp[0].string),"all")== 0)
						strcpy( ufdbNewGV.httpdInterface, "all" );    
					     else
					        ufdbLogFatalError( "http-server interface must be \"all\" or IP address" );
					     ufdbFree( (yyvsp[0].string) );
					   }
#line 2511 "grammar.tab.c"
    break;

  case 89: /* httpd_option: INTERFACE EQUAL WORD  */
#line 613 "grammar.y"
                                           { if (strcmp((yyvsp[0].string),"all")== 0)
						strcpy( ufdbNewGV.httpdInterface, "all" );    
					     else
					        ufdbLogFatalError( "http-server interface must be \"all\" or IP address" );
					     ufdbFree( (yyvsp[0].string) );
					   }
#line 2522 "grammar.tab.c"
    break;

  case 90: /* httpd_option: INTERFACE EQUAL IPV4ADDR  */
#line 619 "grammar.y"
                                           { strcpy( ufdbNewGV.httpdInterface, (yyvsp[0].string) );       ufdbFree( (yyvsp[0].string) ); }
#line 2528 "grammar.tab.c"
    break;

  case 91: /* httpd_option: IMAGES EQUAL qidentifier  */
#line 620 "grammar.y"
                                           { strcpy( ufdbNewGV.httpdImagesDirectory, (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 2534 "grammar.tab.c"
    break;

  case 92: /* httpd_option: IMAGES EQUAL WORD  */
#line 621 "grammar.y"
                                           { strcpy( ufdbNewGV.httpdImagesDirectory, (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 2540 "grammar.tab.c"
    break;

  case 96: /* category: CATEGORY qidentifier  */
#line 634 "grammar.y"
                                       { ufdbCategory( (yyvsp[0].string) ); }
#line 2546 "grammar.tab.c"
    break;

  case 97: /* category: CATEGORY AGGRESSIVE  */
#line 635 "grammar.y"
                                       { ufdbCategory( ufdbStrdup("aggressive") );
		                         yyerror( (char *) "\"aggressive\" is a keyword and must be surrounded by quotes" ); }
#line 2553 "grammar.tab.c"
    break;

  case 98: /* category: CATEGORY TOKEN_ALLOW  */
#line 637 "grammar.y"
                                       { ufdbCategory( ufdbStrdup("allow") );
		                         yyerror( (char *) "\"allow\" is a keyword and must be surrounded by quotes" ); }
#line 2560 "grammar.tab.c"
    break;

  case 99: /* category: CATEGORY TOKEN_DENY  */
#line 639 "grammar.y"
                                       { ufdbCategory( ufdbStrdup("deny") );
		                         yyerror( (char *) "\"deny\" is a keyword and must be surrounded by quotes" ); }
#line 2567 "grammar.tab.c"
    break;

  case 100: /* category: CATEGORY error  */
#line 641 "grammar.y"
                                       { ufdbCategory( ufdbStrdup("syntax-error") );
		                         yyerror( (char *) "erroneous category definition.  Perhaps the category ID is a reserved word?" ); }
#line 2574 "grammar.tab.c"
    break;

  case 101: /* category_block: category START_BRACKET category_contents STOP_BRACKET  */
#line 647 "grammar.y"
                       { ufdbCategoryEnd(); }
#line 2580 "grammar.tab.c"
    break;

  case 104: /* category_content: DOMAINLIST qidentifier  */
#line 655 "grammar.y"
                                                        { ufdbCategoryDomainList( (yyvsp[0].string) ); }
#line 2586 "grammar.tab.c"
    break;

  case 105: /* category_content: DOMAINLIST WORD  */
#line 656 "grammar.y"
                                                        { ufdbCategoryDomainList( (yyvsp[0].string) ); }
#line 2592 "grammar.tab.c"
    break;

  case 106: /* category_content: DOMAINLIST CHAR_MINUS  */
#line 657 "grammar.y"
                                                        { ufdbCategoryDomainList( NULL ); }
#line 2598 "grammar.tab.c"
    break;

  case 107: /* category_content: EXECDOMAINLIST qidentifier  */
#line 658 "grammar.y"
                                                        { ufdbCategoryExecDomainList( (yyvsp[0].string) ); }
#line 2604 "grammar.tab.c"
    break;

  case 108: /* category_content: URLLIST qidentifier  */
#line 659 "grammar.y"
                                                        { ufdbCategoryUrlList( (yyvsp[0].string) ); }
#line 2610 "grammar.tab.c"
    break;

  case 109: /* category_content: URLLIST WORD  */
#line 660 "grammar.y"
                                                        { ufdbCategoryUrlList( (yyvsp[0].string) ); }
#line 2616 "grammar.tab.c"
    break;

  case 110: /* category_content: URLLIST CHAR_MINUS  */
#line 661 "grammar.y"
                                                        { ufdbCategoryUrlList( NULL ); }
#line 2622 "grammar.tab.c"
    break;

  case 111: /* category_content: EXPRESSIONLIST qidentifier  */
#line 662 "grammar.y"
                                                        { ufdbCategoryExpressionList( (yyvsp[0].string), "n" ); }
#line 2628 "grammar.tab.c"
    break;

  case 112: /* category_content: EXPRESSIONLIST WORD  */
#line 663 "grammar.y"
                                                        { ufdbCategoryExpressionList( (yyvsp[0].string), "n" ); }
#line 2634 "grammar.tab.c"
    break;

  case 113: /* category_content: EXPRESSIONLIST CHAR_MINUS  */
#line 664 "grammar.y"
                                                        { ufdbCategoryExpressionList( NULL, NULL ); }
#line 2640 "grammar.tab.c"
    break;

  case 114: /* category_content: EXPRESSIONLIST CHAR_I qidentifier  */
#line 665 "grammar.y"
                                                        { ufdbCategoryExpressionList( (yyvsp[0].string), "i" ); }
#line 2646 "grammar.tab.c"
    break;

  case 115: /* category_content: EXPRESSIONLIST CHAR_I WORD  */
#line 666 "grammar.y"
                                                        { ufdbCategoryExpressionList( (yyvsp[0].string), "i" ); }
#line 2652 "grammar.tab.c"
    break;

  case 116: /* category_content: EXPRESSIONLIST IGNORECASE qidentifier  */
#line 667 "grammar.y"
                                                        { ufdbCategoryExpressionList( (yyvsp[0].string), "i" ); }
#line 2658 "grammar.tab.c"
    break;

  case 117: /* category_content: EXPRESSIONLIST IGNORECASE WORD  */
#line 668 "grammar.y"
                                                        { ufdbCategoryExpressionList( (yyvsp[0].string), "i" ); }
#line 2664 "grammar.tab.c"
    break;

  case 118: /* category_content: CACERTS qidentifier  */
#line 669 "grammar.y"
                                                        { ufdbCategoryCACertsFile( (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) ); }
#line 2670 "grammar.tab.c"
    break;

  case 119: /* category_content: CACERTS WORD  */
#line 670 "grammar.y"
                                                        { ufdbCategoryCACertsFile( (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) ); }
#line 2676 "grammar.tab.c"
    break;

  case 120: /* category_content: CACERTSDIR qidentifier  */
#line 671 "grammar.y"
                                                        { ufdbCategoryCACertsDir( (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) ); }
#line 2682 "grammar.tab.c"
    break;

  case 121: /* category_content: CACERTSDIR WORD  */
#line 672 "grammar.y"
                                                        { ufdbCategoryCACertsDir( (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) ); }
#line 2688 "grammar.tab.c"
    break;

  case 122: /* category_content: REDIRECT qidentifier  */
#line 673 "grammar.y"
                                                        { ufdbCategoryRedirect( (yyvsp[0].string) ); }
#line 2694 "grammar.tab.c"
    break;

  case 123: /* category_content: REDIRECT WORD  */
#line 674 "grammar.y"
                                                        { ufdbCategoryRedirect( (yyvsp[0].string) ); }
#line 2700 "grammar.tab.c"
    break;

  case 124: /* category_content: REWRITE qidentifier  */
#line 675 "grammar.y"
                                                        { ufdbCategoryRewrite( (yyvsp[0].string) ); }
#line 2706 "grammar.tab.c"
    break;

  case 125: /* category_content: REWRITE WORD  */
#line 676 "grammar.y"
                                                        { ufdbCategoryRewrite( (yyvsp[0].string) ); }
#line 2712 "grammar.tab.c"
    break;

  case 126: /* category_content: WITHIN qidentifier  */
#line 677 "grammar.y"
                                                        { ufdbCategoryTime( (yyvsp[0].string), UFDB_ACL_WITHIN ); }
#line 2718 "grammar.tab.c"
    break;

  case 127: /* category_content: OUTSIDE qidentifier  */
#line 678 "grammar.y"
                                                        { ufdbCategoryTime( (yyvsp[0].string), UFDB_ACL_OUTSIDE ); }
#line 2724 "grammar.tab.c"
    break;

  case 128: /* category_content: OPTION BLOCK_BUMPED_CONNECT on_or_off  */
#line 679 "grammar.y"
                                                                     { ufdbCategoryBlockConnect( (yyvsp[0].integer) ); }
#line 2730 "grammar.tab.c"
    break;

  case 129: /* category_content: OPTION SQUID_USES_ACTIVE_BUMPING on_or_off  */
#line 680 "grammar.y"
                                                                     { ufdbCategoryActiveBumping( (yyvsp[0].integer) ); }
#line 2736 "grammar.tab.c"
    break;

  case 130: /* category_content: OPTION SAFE_SEARCH on_or_off  */
#line 681 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_SAFE_SEARCH );  }
#line 2742 "grammar.tab.c"
    break;

  case 131: /* category_content: OPTION YOUTUBE_EDUFILTER on_or_off  */
#line 682 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_YOUTUBE_EDUFILTER );  }
#line 2748 "grammar.tab.c"
    break;

  case 132: /* category_content: OPTION ENFORCE_HTTPS_WITH_HOSTNAME  */
#line 683 "grammar.y"
                                                                     { ufdbCategoryOption(  1, UFDB_OPT_HTTPS_WITH_HOSTNAME );  }
#line 2754 "grammar.tab.c"
    break;

  case 133: /* category_content: OPTION ENFORCE_HTTPS_WITH_HOSTNAME on_or_off  */
#line 684 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_HTTPS_WITH_HOSTNAME );  }
#line 2760 "grammar.tab.c"
    break;

  case 134: /* category_content: OPTION ENFORCE_HTTPS_OFFICAL_CERTIFICATE  */
#line 685 "grammar.y"
                                                                     { ufdbCategoryOption(  1, UFDB_OPT_HTTPS_OFFICAL_CERTIFICATE );  }
#line 2766 "grammar.tab.c"
    break;

  case 135: /* category_content: OPTION ENFORCE_HTTPS_OFFICAL_CERTIFICATE on_or_off  */
#line 686 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_HTTPS_OFFICAL_CERTIFICATE );  }
#line 2772 "grammar.tab.c"
    break;

  case 136: /* category_content: OPTION HTTPS_PROHIBIT_INSECURE_SSLV2 on_or_off  */
#line 687 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_PROHIBIT_INSECURE_SSLV2 );  }
#line 2778 "grammar.tab.c"
    break;

  case 137: /* category_content: OPTION HTTPS_PROHIBIT_INSECURE_SSLV3 on_or_off  */
#line 688 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_PROHIBIT_INSECURE_SSLV3 );  }
#line 2784 "grammar.tab.c"
    break;

  case 138: /* category_content: OPTION HTTPS_PROHIBIT_INSECURE_TLSV1_0 on_or_off  */
#line 689 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_PROHIBIT_INSECURE_TLSV1_0 );  }
#line 2790 "grammar.tab.c"
    break;

  case 139: /* category_content: OPTION ALLOW_SKYPE_OVER_HTTPS on_or_off  */
#line 690 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_SKYPE_OVER_HTTPS );  }
#line 2796 "grammar.tab.c"
    break;

  case 140: /* category_content: OPTION ALLOW_GTALK_OVER_HTTPS on_or_off  */
#line 691 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_GTALK_OVER_HTTPS );  }
#line 2802 "grammar.tab.c"
    break;

  case 141: /* category_content: OPTION ALLOW_YAHOOMSG_OVER_HTTPS on_or_off  */
#line 692 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_YAHOOMSG_OVER_HTTPS );  }
#line 2808 "grammar.tab.c"
    break;

  case 142: /* category_content: OPTION ALLOW_AIM_OVER_HTTPS on_or_off  */
#line 693 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_AIM_OVER_HTTPS );  }
#line 2814 "grammar.tab.c"
    break;

  case 143: /* category_content: OPTION ALLOW_FBCHAT_OVER_HTTPS on_or_off  */
#line 694 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_FBCHAT_OVER_HTTPS );  }
#line 2820 "grammar.tab.c"
    break;

  case 144: /* category_content: OPTION ALLOW_CITRIXONLINE_OVER_HTTPS on_or_off  */
#line 695 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_CITRIXONLINE_OVER_HTTPS );  }
#line 2826 "grammar.tab.c"
    break;

  case 145: /* category_content: OPTION ALLOW_ANYDESK_OVER_HTTPS on_or_off  */
#line 696 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_ANYDESK_OVER_HTTPS );  }
#line 2832 "grammar.tab.c"
    break;

  case 146: /* category_content: OPTION ALLOW_TEAMVIEWER_OVER_HTTPS on_or_off  */
#line 697 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_TEAMVIEWER_OVER_HTTPS );  }
#line 2838 "grammar.tab.c"
    break;

  case 147: /* category_content: OPTION ALLOW_UNKNOWN_PROTOCOL_OVER_HTTPS on_or_off  */
#line 698 "grammar.y"
                                                                     { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_UNKNOWN_PROTOCOL_OVER_HTTPS );  }
#line 2844 "grammar.tab.c"
    break;

  case 148: /* category_content: LOGFILE ANONYMOUS qidentifier  */
#line 699 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[0].string) ); 
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 2851 "grammar.tab.c"
    break;

  case 149: /* category_content: LOGFILE ANONYMOUS WORD  */
#line 701 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[0].string) ); 
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 2858 "grammar.tab.c"
    break;

  case 150: /* category_content: LOGFILE qidentifier  */
#line 703 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[0].string) ); 
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 2865 "grammar.tab.c"
    break;

  case 151: /* category_content: LOGFILE WORD  */
#line 705 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[0].string) ); 
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 2872 "grammar.tab.c"
    break;

  case 152: /* source: SOURCE qidentifier  */
#line 710 "grammar.y"
                                     { defSource( (yyvsp[0].string) ); }
#line 2878 "grammar.tab.c"
    break;

  case 153: /* source_block: source START_BRACKET source_contents STOP_BRACKET  */
#line 714 "grammar.y"
                                                                    { defSourceEnd(); }
#line 2884 "grammar.tab.c"
    break;

  case 159: /* source_content: USERLIST qidentifier  */
#line 726 "grammar.y"
                                                 { ufdbSourceUserList( (yyvsp[0].string) ); }
#line 2890 "grammar.tab.c"
    break;

  case 160: /* source_content: USERLIST WORD  */
#line 727 "grammar.y"
                                                 { ufdbSourceUserList( (yyvsp[0].string) ); }
#line 2896 "grammar.tab.c"
    break;

  case 161: /* source_content: UNIX USERLIST qidentifier  */
#line 728 "grammar.y"
                                                 { ufdbSourceUserList( (yyvsp[0].string) ); }
#line 2902 "grammar.tab.c"
    break;

  case 162: /* source_content: UNIX USERLIST WORD  */
#line 729 "grammar.y"
                                                 { ufdbSourceUserList( (yyvsp[0].string) ); }
#line 2908 "grammar.tab.c"
    break;

  case 163: /* source_content: EXECUSERLIST qidentifier  */
#line 730 "grammar.y"
                                                 { ufdbSourceExecUserList( (yyvsp[0].string) ); }
#line 2914 "grammar.tab.c"
    break;

  case 164: /* source_content: EXECIPLIST qidentifier  */
#line 731 "grammar.y"
                                                 { ufdbSourceExecIPList( (yyvsp[0].string) ); }
#line 2920 "grammar.tab.c"
    break;

  case 165: /* source_content: GROUP qidentifier  */
#line 732 "grammar.y"
                                                 { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[0].string) ); }
#line 2926 "grammar.tab.c"
    break;

  case 166: /* source_content: GROUP WORD  */
#line 733 "grammar.y"
                                                 { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[0].string) ); }
#line 2932 "grammar.tab.c"
    break;

  case 167: /* source_content: UNIX GROUP qidentifier  */
#line 734 "grammar.y"
                                                 { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[0].string) ); }
#line 2938 "grammar.tab.c"
    break;

  case 168: /* source_content: UNIX GROUP WORD  */
#line 735 "grammar.y"
                                                 { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[0].string) ); }
#line 2944 "grammar.tab.c"
    break;

  case 169: /* source_content: USERQUOTA NUMBER NUMBER HOURLY  */
#line 736 "grammar.y"
                                                 { ufdbSourceUserQuota( (yyvsp[-2].string), (yyvsp[-1].string), "3600" );  
		                                   ufdbFree( (yyvsp[-2].string) ); ufdbFree( (yyvsp[-1].string) ); }
#line 2951 "grammar.tab.c"
    break;

  case 170: /* source_content: USERQUOTA NUMBER NUMBER DAILY  */
#line 738 "grammar.y"
                                                 { ufdbSourceUserQuota( (yyvsp[-2].string), (yyvsp[-1].string), "86400" );  
		                                   ufdbFree( (yyvsp[-2].string) ); ufdbFree( (yyvsp[-1].string) ); }
#line 2958 "grammar.tab.c"
    break;

  case 171: /* source_content: USERQUOTA NUMBER NUMBER WEEKLY  */
#line 740 "grammar.y"
                                                 { ufdbSourceUserQuota( (yyvsp[-2].string), (yyvsp[-1].string), "604800" );  
		                                   ufdbFree( (yyvsp[-2].string) ); ufdbFree( (yyvsp[-1].string) ); }
#line 2965 "grammar.tab.c"
    break;

  case 172: /* source_content: USERQUOTA NUMBER NUMBER NUMBER  */
#line 742 "grammar.y"
                                                 { ufdbSourceUserQuota( (yyvsp[-2].string), (yyvsp[-1].string), (yyvsp[0].string) );  
		                                   ufdbFree( (yyvsp[-2].string) ); ufdbFree( (yyvsp[-1].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 2972 "grammar.tab.c"
    break;

  case 174: /* source_content: IPV4LIST qidentifier  */
#line 745 "grammar.y"
                                                 { defSourceIPV4List( (yyvsp[0].string) ); }
#line 2978 "grammar.tab.c"
    break;

  case 175: /* source_content: IPV4LIST WORD  */
#line 746 "grammar.y"
                                                 { defSourceIPV4List( (yyvsp[0].string) ); }
#line 2984 "grammar.tab.c"
    break;

  case 177: /* source_content: IPV6LIST qidentifier  */
#line 748 "grammar.y"
                                                 { defSourceIPV6List( (yyvsp[0].string) ); }
#line 2990 "grammar.tab.c"
    break;

  case 178: /* source_content: IPV6LIST WORD  */
#line 749 "grammar.y"
                                                 { defSourceIPV6List( (yyvsp[0].string) ); }
#line 2996 "grammar.tab.c"
    break;

  case 179: /* source_content: EVALUATE_AND  */
#line 750 "grammar.y"
                                                 { ufdbSourceEval( UFDB_EVAL_AND ); }
#line 3002 "grammar.tab.c"
    break;

  case 180: /* source_content: EVALUATE_OR  */
#line 751 "grammar.y"
                                                 { ufdbSourceEval( UFDB_EVAL_OR ); }
#line 3008 "grammar.tab.c"
    break;

  case 181: /* source_content: WITHIN qidentifier  */
#line 752 "grammar.y"
                                                 { defSourceTime( (yyvsp[0].string), UFDB_ACL_WITHIN ); }
#line 3014 "grammar.tab.c"
    break;

  case 182: /* source_content: OUTSIDE qidentifier  */
#line 753 "grammar.y"
                                                 { defSourceTime( (yyvsp[0].string), UFDB_ACL_OUTSIDE ); }
#line 3020 "grammar.tab.c"
    break;

  case 183: /* source_content: LOGFILE ANONYMOUS qidentifier  */
#line 754 "grammar.y"
                                                 { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                 lineno, (yyvsp[0].string) ); 
						   ufdbFree( (yyvsp[0].string) ); }
#line 3028 "grammar.tab.c"
    break;

  case 184: /* source_content: LOGFILE ANONYMOUS WORD  */
#line 757 "grammar.y"
                                                 { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                 lineno, (yyvsp[0].string) ); 
						   ufdbFree( (yyvsp[0].string) ); }
#line 3036 "grammar.tab.c"
    break;

  case 185: /* source_content: LOGFILE qidentifier  */
#line 760 "grammar.y"
                                                 { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                 lineno, (yyvsp[0].string) ); 
						   ufdbFree( (yyvsp[0].string) ); }
#line 3044 "grammar.tab.c"
    break;

  case 186: /* source_content: LOGFILE WORD  */
#line 763 "grammar.y"
                                                 { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                 lineno, (yyvsp[0].string) ); 
						   ufdbFree( (yyvsp[0].string) ); }
#line 3052 "grammar.tab.c"
    break;

  case 187: /* source_content: CONTINUE  */
#line 766 "grammar.y"
                                                 { ufdbNewGV.lastSource->cont_search = 1; }
#line 3058 "grammar.tab.c"
    break;

  case 189: /* domain: domain qidentifier  */
#line 772 "grammar.y"
                                        { defSourceDomain( (yyvsp[0].string) ); }
#line 3064 "grammar.tab.c"
    break;

  case 190: /* domain: domain WORD  */
#line 773 "grammar.y"
                                        { defSourceDomain( (yyvsp[0].string) ); }
#line 3070 "grammar.tab.c"
    break;

  case 193: /* user: user qidentifier  */
#line 779 "grammar.y"
                                        { ufdbSourceUser( (yyvsp[0].string) ); }
#line 3076 "grammar.tab.c"
    break;

  case 194: /* user: user WORD  */
#line 780 "grammar.y"
                                        { ufdbSourceUser( (yyvsp[0].string) ); }
#line 3082 "grammar.tab.c"
    break;

  case 199: /* acl_header: qidentifier START_BRACKET  */
#line 793 "grammar.y"
                                                                 { ufdbAcl( (yyvsp[-1].string), NULL, UFDB_ACL_NONE );  }
#line 3088 "grammar.tab.c"
    break;

  case 200: /* acl_header: qidentifier WITHIN qidentifier START_BRACKET  */
#line 794 "grammar.y"
                                                                 { ufdbAcl( (yyvsp[-3].string), (yyvsp[-1].string), UFDB_ACL_WITHIN );  }
#line 3094 "grammar.tab.c"
    break;

  case 201: /* acl_header: qidentifier OUTSIDE qidentifier START_BRACKET  */
#line 795 "grammar.y"
                                                                 { ufdbAcl( (yyvsp[-3].string), (yyvsp[-1].string), UFDB_ACL_OUTSIDE ); }
#line 3100 "grammar.tab.c"
    break;

  case 203: /* $@1: %empty  */
#line 801 "grammar.y"
                     { ufdbAcl( NULL, NULL, UFDB_ACL_ELSE );    }
#line 3106 "grammar.tab.c"
    break;

  case 207: /* access_content: PASS access_pass  */
#line 811 "grammar.y"
                                                { if (ufdbNewGV.lastAcl != NULL  &&  
                                                      ufdbNewGV.lastAcl->pass == NULL) 
                                                  {
                                                     ufdbLogMessage( "line %d: acl has an empty pass statement."
                                                                     "  Adding 'any'.", lineno );
                                                     ufdbAclSetValue( "pass", ufdbStrdup("any"), 1 );
                                                  }
                                                }
#line 3119 "grammar.tab.c"
    break;

  case 208: /* access_content: REWRITE qidentifier  */
#line 819 "grammar.y"
                                                { ufdbAclSetValue( "rewrite", (yyvsp[0].string), 0 ); }
#line 3125 "grammar.tab.c"
    break;

  case 209: /* access_content: REWRITE WORD  */
#line 820 "grammar.y"
                                                { ufdbAclSetValue( "rewrite", (yyvsp[0].string), 0 ); }
#line 3131 "grammar.tab.c"
    break;

  case 210: /* access_content: REDIRECT qidentifier  */
#line 821 "grammar.y"
                                                { ufdbAclSetValue( "redirect", (yyvsp[0].string), 0 ); }
#line 3137 "grammar.tab.c"
    break;

  case 211: /* access_content: REDIRECT WORD  */
#line 822 "grammar.y"
                                                { ufdbAclSetValue( "redirect", (yyvsp[0].string), 0 ); }
#line 3143 "grammar.tab.c"
    break;

  case 212: /* access_content: LOGFILE ANONYMOUS qidentifier  */
#line 823 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                lineno, (yyvsp[0].string) ); 
						  ufdbFree( (yyvsp[0].string) ); }
#line 3151 "grammar.tab.c"
    break;

  case 213: /* access_content: LOGFILE ANONYMOUS WORD  */
#line 826 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                lineno, (yyvsp[0].string) ); 
						  ufdbFree( (yyvsp[0].string) ); }
#line 3159 "grammar.tab.c"
    break;

  case 214: /* access_content: LOGFILE qidentifier  */
#line 829 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                lineno, (yyvsp[0].string) ); 
						  ufdbFree( (yyvsp[0].string) ); }
#line 3167 "grammar.tab.c"
    break;

  case 215: /* access_content: LOGFILE WORD  */
#line 832 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                lineno, (yyvsp[0].string) ); 
						  ufdbFree( (yyvsp[0].string) ); }
#line 3175 "grammar.tab.c"
    break;

  case 217: /* access_pass: access_pass AGGRESSIVE  */
#line 839 "grammar.y"
                                                            { yyerror( (char *) "\"aggressive\" is a keyword and must be surrounded by quotes" ); }
#line 3181 "grammar.tab.c"
    break;

  case 218: /* access_pass: access_pass qidentifier  */
#line 840 "grammar.y"
                                                            { ufdbAclSetValue( "pass", (yyvsp[0].string), 1 ); }
#line 3187 "grammar.tab.c"
    break;

  case 219: /* access_pass: access_pass CHAR_EXCLAMATION AGGRESSIVE  */
#line 841 "grammar.y"
                                                            { yyerror( (char *) "\"aggressive\" is a keyword and must be surrounded by quotes" ); }
#line 3193 "grammar.tab.c"
    break;

  case 220: /* access_pass: access_pass CHAR_EXCLAMATION qidentifier  */
#line 842 "grammar.y"
                                                            { ufdbAclSetValue( "pass", (yyvsp[0].string), 0 ); }
#line 3199 "grammar.tab.c"
    break;

  case 225: /* ipv4: IPV4ADDR  */
#line 853 "grammar.y"
                                                { sgIpv4( (yyvsp[0].string), SG_IPTYPE_HOST, ufdbNewGV.configFile, lineno );
		                                  ufdbFree( (yyvsp[0].string) );  }
#line 3206 "grammar.tab.c"
    break;

  case 226: /* ipv4: IPV4RANGE  */
#line 855 "grammar.y"
                                                { sgIpv4( (yyvsp[0].string), SG_IPTYPE_RANGE, ufdbNewGV.configFile, lineno );
		                                  ufdbFree( (yyvsp[0].string) );  }
#line 3213 "grammar.tab.c"
    break;

  case 227: /* ipv4: IPV4CLASS  */
#line 857 "grammar.y"
                                                { sgIpv4( (yyvsp[0].string), SG_IPTYPE_CLASS, ufdbNewGV.configFile, lineno );
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 3220 "grammar.tab.c"
    break;

  case 228: /* ipv4: IPV4NET  */
#line 859 "grammar.y"
                                                { sgIpv4( (yyvsp[0].string), SG_IPTYPE_CIDR, ufdbNewGV.configFile, lineno );
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 3227 "grammar.tab.c"
    break;

  case 232: /* ipv6: IPV6ADDR  */
#line 870 "grammar.y"
                                                { sgIpv6( (yyvsp[0].string), SG_IPV6TYPE_HOST, ufdbNewGV.configFile, lineno );
                                                  ufdbFree( (yyvsp[0].string) );  }
#line 3234 "grammar.tab.c"
    break;

  case 233: /* ipv6: IPV6NET  */
#line 872 "grammar.y"
                                                { sgIpv6( (yyvsp[0].string), SG_IPV6TYPE_CIDR, ufdbNewGV.configFile, lineno );
                                                  ufdbFree( (yyvsp[0].string) );  }
#line 3241 "grammar.tab.c"
    break;

  case 234: /* rew: REWRITE qidentifier  */
#line 877 "grammar.y"
                                        { sgRewrite( (yyvsp[0].string) ); }
#line 3247 "grammar.tab.c"
    break;

  case 235: /* rew: REWRITE WORD  */
#line 878 "grammar.y"
                                        { sgRewrite( (yyvsp[0].string) ); }
#line 3253 "grammar.tab.c"
    break;

  case 239: /* rew_content: SUBST  */
#line 892 "grammar.y"
                                                { sgRewriteSubstitute( (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 3259 "grammar.tab.c"
    break;

  case 240: /* rew_content: WITHIN qidentifier  */
#line 893 "grammar.y"
                                                { sgRewriteTime( (yyvsp[0].string), UFDB_ACL_WITHIN ); }
#line 3265 "grammar.tab.c"
    break;

  case 241: /* rew_content: OUTSIDE qidentifier  */
#line 894 "grammar.y"
                                                { sgRewriteTime( (yyvsp[0].string), UFDB_ACL_OUTSIDE ); }
#line 3271 "grammar.tab.c"
    break;

  case 242: /* rew_content: LOGFILE ANONYMOUS qidentifier  */
#line 895 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s",
		                                                lineno, (yyvsp[0].string) );
								ufdbFree( (yyvsp[0].string) ); }
#line 3279 "grammar.tab.c"
    break;

  case 243: /* rew_content: LOGFILE ANONYMOUS WORD  */
#line 898 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s",
		                                                lineno, (yyvsp[0].string) );
								ufdbFree( (yyvsp[0].string) ); }
#line 3287 "grammar.tab.c"
    break;

  case 244: /* rew_content: LOGFILE qidentifier  */
#line 901 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s",
		                                                lineno, (yyvsp[0].string) );
								ufdbFree( (yyvsp[0].string) ); }
#line 3295 "grammar.tab.c"
    break;

  case 245: /* rew_content: LOGFILE WORD  */
#line 904 "grammar.y"
                                                { ufdbLogError( "line %d: unsupported logfile context for %s",
		                                                lineno, (yyvsp[0].string) );
								ufdbFree( (yyvsp[0].string) ); }
#line 3303 "grammar.tab.c"
    break;

  case 246: /* time: TIME qidentifier  */
#line 911 "grammar.y"
                                                { sgTime( (yyvsp[0].string) ); }
#line 3309 "grammar.tab.c"
    break;

  case 250: /* $@2: %empty  */
#line 925 "grammar.y"
                         { sgTimeElementInit(); }
#line 3315 "grammar.tab.c"
    break;

  case 251: /* $@3: %empty  */
#line 925 "grammar.y"
                                                              { sgTimeElementAdd((yyvsp[0].string),T_WEEKDAY); }
#line 3321 "grammar.tab.c"
    break;

  case 253: /* $@4: %empty  */
#line 926 "grammar.y"
                         { sgTimeElementInit(); }
#line 3327 "grammar.tab.c"
    break;

  case 254: /* $@5: %empty  */
#line 926 "grammar.y"
                                                              { sgTimeElementAdd((yyvsp[0].string),T_WEEKLY); }
#line 3333 "grammar.tab.c"
    break;

  case 256: /* $@6: %empty  */
#line 927 "grammar.y"
                         { sgTimeElementInit(); }
#line 3339 "grammar.tab.c"
    break;

  case 257: /* $@7: %empty  */
#line 927 "grammar.y"
                                                              { sgTimeElementAdd((yyvsp[0].string),T_WEEKLY); }
#line 3345 "grammar.tab.c"
    break;

  case 259: /* $@8: %empty  */
#line 928 "grammar.y"
                         { sgTimeElementInit(); }
#line 3351 "grammar.tab.c"
    break;

  case 260: /* time_content: DATE $@8 date  */
#line 928 "grammar.y"
                                                              { sgTimeElementEnd(); }
#line 3357 "grammar.tab.c"
    break;

  case 261: /* time_content: error  */
#line 929 "grammar.y"
                         { ufdbLogFatalError( "invalid time specification at line %d", lineno );   }
#line 3363 "grammar.tab.c"
    break;

  case 262: /* $@9: %empty  */
#line 933 "grammar.y"
                         { sgTimeElementClone(); }
#line 3369 "grammar.tab.c"
    break;

  case 271: /* dval: DVAL  */
#line 946 "grammar.y"
                                { sgTimeElementAdd( (yyvsp[0].string), T_DVAL ); }
#line 3375 "grammar.tab.c"
    break;

  case 272: /* tval: TVAL  */
#line 949 "grammar.y"
                                { sgTimeElementAdd( (yyvsp[0].tval), T_TVAL ); }
#line 3381 "grammar.tab.c"
    break;

  case 273: /* dvalcron: DVALCRON  */
#line 952 "grammar.y"
                                { sgTimeElementAdd( (yyvsp[0].string), T_DVALCRON ); }
#line 3387 "grammar.tab.c"
    break;

  case 274: /* an_error: error  */
#line 956 "grammar.y"
                                {  yyerror( (char *) "syntax error" );  
                                   if (ufdbNewGV.serialno > 1  &&  ufdbNewGV.debug)
                                      logConfig(); 
                                }
#line 3396 "grammar.tab.c"
    break;


#line 3400 "grammar.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 1043 "grammar.y"


int ufdbReadConfig( 
   const char *      file )
{
   struct Source *   source;
   struct Category * cat;
   struct Acl *      acl;

   lineno = 1;
   ufdbResetCPUs();

   ufdbNewGV.configFile = file;

   yyin = fopen( ufdbNewGV.configFile, "r" );
   if (yyin == NULL) 
   {
      syslog( LOG_ALERT, "%s: cannot open configuration file %s", ufdbNewGV.progname, ufdbNewGV.configFile );
      ufdbLogFatalError( "cannot open configuration file %s", ufdbNewGV.configFile );
      return 0;
   }

   ufdbLogMessage( "configuration file: %s", ufdbNewGV.configFile );

   /* keep the old HTTPS redirection URL.  It is most likely that we need it during the database reload */
   /* dot not reset ufdbNewGV.RedirectHttps and ufdbNewGV.RedirectBumpedHttps. */

   ufdbNewGV.debug = 0;
   ufdbNewGV.debugCoreDump = 0;
   strcpy( ufdbNewGV.interface, "all" );
   ufdbNewGV.portNum = UFDB_DAEMON_PORT;
   ufdbNewGV.nWorkers = UFDB_MIN_THREADS;
   ufdbNewGV.debugHttpd = 0;
   ufdbNewGV.logPass = 0;
   ufdbNewGV.logBlock = 0;
   ufdbNewGV.logAllRequests = 0;
   ufdbNewGV.YoutubeEdufilter = 0;
   ufdbFree( ufdbNewGV.YoutubeEdufilterID );
   ufdbNewGV.YoutubeEdufilterID = NULL;
   ufdbNewGV.allowGoogleHTTPSusingIP = 0;

   /* When a database is reloaded, these variables may NOT be reset since they are used during the reload !! */
   ufdbNewGV.URLlookupDelayDBreload = 0;
   ufdbNewGV.URLlookupResultDBreload = UFDB_ALLOW;
   ufdbNewGV.URLlookupResultFatalError = UFDB_ALLOW;
   strcpy( ufdbNewGV.loadingDatabaseRedirect, "http://cgibin.urlfilterdb.com/cgi-bin/URLblocked.cgi?"
                "category=loading-database" );
   ufdbNewGV.SquidVersion = ufdbStrdup( UFDB_DEFAULT_SQUID_VERSION );

   ufdbNewGV.showURLdetails = 0;
   ufdbNewGV.logURLdetails = 0;
   ufdbNewGV.uploadCrashReports = 1;
   ufdbNewGV.lookupReverseIP = 0;
   ufdbNewGV.useAlsoIPv6onWan = 1;
   ufdbNewGV.debugSkype = 0;
   ufdbNewGV.debugGtalk = 0;
   ufdbNewGV.debugYahooMsg = 0;
   ufdbNewGV.debugAim = 0;
   ufdbNewGV.debugFBchat = 0;
   ufdbNewGV.debugCitrixOnline = 0;
   ufdbNewGV.debugRegexp = 0;
   ufdbNewGV.debugExternalScripts = 0;
   ufdbNewGV.expressionOptimisation = 1;
   ufdbNewGV.refreshUserlistInterval = UFDB_DEFAULT_REFRESH_USERLIST;
   ufdbNewGV.refreshIPlistInterval = UFDB_DEFAULT_REFRESH_IPLIST;
   ufdbNewGV.refreshDomainlistInterval = UFDB_DEFAULT_REFRESH_DOMAINLIST;
   ufdbNewGV.analyseUncategorisedURLs = 1;
   ufdbNewGV.logUncategorisedURLs = 0;
   ufdbNewGV.uploadStats = 1;
   ufdbNewGV.safeSearch = 1;
   ufdbNewGV.skipSafeCategory = 0;
   ufdbNewGV.stripDomainFromUsername = 0;
   ufdbNewGV.tunnelCheckMethod = UFDB_API_HTTPS_CHECK_OFF;
   ufdbNewGV.SquidUsesActiveBumping = 0;
   ufdbNewGV.httpsWithHostname = 0;
   ufdbNewGV.httpsOfficialCertificate = 0;
   ufdbNewGV.unknownProtocolOverHttps = 1;
   ufdbNewGV.httpsNoSSLv2 = 1;
   ufdbNewGV.httpsNoSSLv3 = 1;
   ufdbNewGV.httpdPort = 0;
   ufdbNewGV.dateOfCheckedDB[0] = '\0';
   strcpy( ufdbNewGV.httpdInterface, "all" );
   strcpy( ufdbNewGV.httpdImagesDirectory, "." );
 
   ufdbNewGV.databaseStatus = UFDB_API_STATUS_DATABASE_OK;

   (void) yyparse();		/* parse the configuration file ********************/
   fclose( yyin );

   ufdbNewGV.databaseLoadTime = time( NULL );

   /*
    * For analysis of uncategorised URLs we also load a "checked" category
    * that contains URLs that are reviewed and checked not to be part of
    * any other category.
    */
   char * dbhome;
   char   dbfname[1024];

   dbhome = ufdbNewGV.databaseDirectory;

   /* TODO: check if "checked" was not already loaded... */
   if (ufdbNewGV.analyseUncategorisedURLs > 0)
   {
      int status;
      sprintf( dbfname, "%s/checked/domains.ufdb", dbhome );
      status = UFDBloadDatabase( &ufdbNewGV, &ufdbNewGV.checkedDB, dbfname );
      if (status != UFDB_API_OK  &&  status != UFDB_API_STATUS_DATABASE_OLD)
      {
         ufdbNewGV.checkedDB.mem = NULL;
         ufdbNewGV.checkedDB.index = NULL;
         ufdbNewGV.checkedDB.table.nNextLevels = 0;
         if (ufdbGV.debug)
            ufdbLogMessage( "The URL database appears not be from URLfilterDB. No problem." );
      }
      else
      {
         if (ufdbGV.debug)
            ufdbLogMessage( "table \"checked\" is loaded: %s %8.8s",
                            ufdbNewGV.checkedDB.date, ufdbNewGV.checkedDB.flags );
         sprintf( dbfname, "%s/checked/expressions", dbhome );
         (void) UFDBloadExpressions( &ufdbNewGV.checkedExpressions, dbfname );
         ufdbLogMessage( "The implicitly allowed URL category 'checked' is loaded." );
      }
   }

   if (ufdbNewGV.defaultAcl == NULL)
      ufdbLogFatalError( "\"default\" ACL is not defined" );
   else if (ufdbNewGV.defaultAcl->pass == NULL)
      ufdbLogError( "\"default\" ACL is empty: by default all URLs are blocked." );

   /* A configuration file may have a source definition which is not used in the ACL list.
    * This raises the question "what to do with this ?".
    * If we do nothing, the source is matched but has no ACL definition and is silently skipped.
    * Most likely the administrator overlooked something so a warning is useful.
    */
   source = ufdbNewGV.sourceList;
   if (source == NULL  &&  ufdbNewGV.defaultAcl == NULL)
      ufdbLogFatalError( "There are no sources and there is no default ACL" );

   for ( ; source != NULL;  source = source->next)
   {
      int found;

      found = 0;
      for (acl = ufdbNewGV.aclList;  acl != NULL;  acl = acl->next)
      {
         if (strcmp( acl->name, source->name ) == 0)
	 {
	    found = 1;
	    break;
	 }
      }
      if (!found)
      {
         ufdbLogError( "source \"%s\" has no ACL.  *****\n"
	               "This most likely may lead to unexpected results when the source is matched.  *****\n"
		       "It is strongly suggested to remove the source definition OR add the source to the acl.  *****",
		       source->name );
	 source->active = 0;
      }
      else if (acl->pass == NULL)
      {
         ufdbLogMessage( "source \"%s\" has an empty \"pass\" in its ACL *****", source->name );
      }
   }

   for (cat = ufdbNewGV.catList;  cat != NULL;  cat = cat->next)
   {
      if (cat->options == 0  &&  cat->domainlist == NULL  &&  cat->execdomainlist == NULL  && 
          cat->expressionlist == NULL  &&  cat->rewrite == NULL  &&  cat->name != NULL)
      {
         ufdbLogError( "category \"%s\" has no content definition  *****", cat->name );
      }
   }

   if (ufdbNewGV.adminEmail != NULL  &&  ufdbNewGV.emailServer == NULL)
   {
      ufdbLogError( "No email server is defined; cannot send email to \"%s\"  *****", ufdbNewGV.adminEmail );
   }
   if (ufdbNewGV.adminEmail != NULL  &&  ufdbNewGV.emailServer != NULL  &&  ufdbNewGV.senderEmail == NULL)
   {
      ufdbLogMessage( "WARNING: No sender email address is defined; using \"%s\" as sender",
                      ufdbNewGV.adminEmail );
   }

   if (strncmp( ufdbNewGV.SquidVersion, "6.", 2 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "5.", 2 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "4.", 2 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "3.5", 3 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "3.4", 3 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "3.3", 3 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "3.2", 3 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "3.1", 3 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "3.0", 3 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "2.7", 3 ) != 0  &&
       strncmp( ufdbNewGV.SquidVersion, "2.6", 3 ) != 0)
   {
      ufdbLogFatalError( "Unsupported Squid version \"%s\"  *****\n"
                         "The supported values for squid-version are: "
                         "6.x, 5.x, 4.x, 3.5, 3.4, 3.3, 3.2, 3.1, 3.0, 2.7, 2.6  *****\n"
			 "If the version of Squid is higher, it is recommended to upgrade ufdbGuard.  *****\n"
			 "Alternatively set squid-version to the highest supported version",
			 ufdbNewGV.SquidVersion );
   }
   if (strncmp( ufdbNewGV.SquidVersion, "6.", 2 ) == 0  ||
       strncmp( ufdbNewGV.SquidVersion, "5.", 2 ) == 0  ||
       strncmp( ufdbNewGV.SquidVersion, "4.", 2 ) == 0  ||  
       strncmp( ufdbNewGV.SquidVersion, "3.5", 3 ) == 0  ||  
       strncmp( ufdbNewGV.SquidVersion, "3.4", 3 ) == 0)
      ufdbNewGV.SquidHelperProtocol = UFDB_SQUID_HELPER_PROTOCOL3;
   else if (strncmp( ufdbNewGV.SquidVersion, "2.6", 3 ) == 0  ||  
            strncmp( ufdbNewGV.SquidVersion, "2.7", 3 ) == 0)
      ufdbNewGV.SquidHelperProtocol = UFDB_SQUID_HELPER_PROTOCOL1;
   else
      ufdbNewGV.SquidHelperProtocol = UFDB_SQUID_HELPER_PROTOCOL2;	/* 3.0 - 3.3 */

   BuildImplicitPassLists( &ufdbNewGV );

   return 1;
}


static void setDBhome( char * dbhome )
{
   struct stat dirbuf;

   if (strlen(dbhome) > sizeof(ufdbNewGV.databaseDirectory)-1)
   {
      ufdbLogFatalError( "maximum length for dbhome is %d", (int) sizeof(ufdbNewGV.databaseDirectory)-1 );
      ufdbFree( dbhome );
      return;
   }
   strcpy( ufdbNewGV.databaseDirectory, dbhome );

   if (stat( dbhome, &dirbuf ) != 0)
   {
      ufdbLogFatalError( "dbhome %s: directory does not exist or access rights are insufficient", dbhome );
   }
   else
   {
      if (!S_ISDIR(dirbuf.st_mode))
         ufdbLogFatalError( "dbhome: %s is not a directory", dbhome );
   }

   ufdbFree( dbhome );
}


static void setAdministrator( char * value )
{
   char * p;

   if (strlen(value) > sizeof(ufdbNewGV.administrator)-1)
   {
      ufdbLogError( "maximum length for administrator is %d", (int) sizeof(ufdbNewGV.administrator)-1 );
      return;
   }

   while ((p = (char *) strchr( value, '?' )) != NULL)
      *p = '_';
   while ((p = (char *) strchr( value, '&' )) != NULL)
      *p = '_';

   strcpy( ufdbNewGV.administrator, value );
   ufdbFree( value );
}


static void setLogdir( char * value )
{
   strcpy( ufdbNewGV.logDirectory, value );
   strcpy( ufdbGV.logDirectory, value );                // we need immediate effect

   ufdbSetGlobalErrorLogFile( ufdbNewGV.logDirectory, NULL, 0 );
}


static void setPidfile( char * value )
{
   if (ufdbNewGV.pidFilename != NULL)
      ufdbFree( ufdbNewGV.pidFilename );
   ufdbNewGV.pidFilename = value;
}


static void setRefreshUserlist( int nmin )
{
   if (nmin < 5  ||  nmin > 24*60)
   {
      ufdbLogError( "refreshuserlist must have a value between 5 and %d, resetting to %d.", 
                    24*60, UFDB_DEFAULT_REFRESH_USERLIST );
      nmin = UFDB_DEFAULT_REFRESH_USERLIST;
   }
   ufdbNewGV.refreshUserlistInterval = nmin;
}


static void setRefreshIPlist( int nmin )
{
   if (nmin < 5  ||  nmin > 24*60)
   {
      ufdbLogError( "refreshiplist must have a value between 5 and %d, resetting to %d.", 
                    24*60, UFDB_DEFAULT_REFRESH_IPLIST );
      nmin = UFDB_DEFAULT_REFRESH_IPLIST;
   }
   ufdbNewGV.refreshIPlistInterval = nmin;
}


static void setRefreshDomainlist( int nmin )
{
   if (nmin < 5  ||  nmin > 24*60)
   {
      ufdbLogError( "refreshdomainlist must have a value between 5 and %d, resetting to %d.", 
                    24*60, UFDB_DEFAULT_REFRESH_DOMAINLIST );
      nmin = UFDB_DEFAULT_REFRESH_DOMAINLIST;
   }
   ufdbNewGV.refreshDomainlistInterval = nmin;
}


/*
 * Source functions
 */

static void defSource( 
   char *          source )
{
   struct Source * sp;

   if (ufdbGV.debug)
      ufdbLogMessage( "defSource: defining source \"%s\"", source );

   if ((struct Source *) defSourceFindName(ufdbNewGV.sourceList,source) != NULL)
   {
      ufdbLogFatalError( "line %d: source %s is already defined in configuration file %s",
			 lineno, source, ufdbNewGV.configFile );
      ufdbFree( source );
      return;
   }

   sp = (struct Source *) ufdbMallocAligned( UFDB_CACHELINE_SIZE, sizeof(struct Source) );
   sp->name = source;
   sp->active = 1;
   sp->evaluationMethod = UFDB_EVAL_OR;
   sp->ipv4hosts = NULL;
   sp->ipv4 = NULL;
   sp->ipv6hosts = NULL;
   sp->ipv6 = NULL;
   sp->domainDb = NULL;
   sp->userDb = NULL;
   sp->time = NULL;
   sp->within = UFDB_ACL_NONE;
   sp->cont_search = 0;
   sp->sarg0 = NULL;
   sp->execiplistCommand = NULL;
   sp->next = NULL;
   sp->nblocks = 0;
   sp->nmatches = 0;

   if (ufdbNewGV.sourceList == NULL)
   {
      if (ufdbGV.debug)
         ufdbLogMessage( "defSource: SourceList is set to point to \"%s\"", source );
      ufdbNewGV.sourceList = sp;
      ufdbNewGV.lastSource = sp;
   }
   else
   {
      ufdbNewGV.lastSource->next = sp;
      ufdbNewGV.lastSource = sp;
   }
}


static void defSourceEnd( void )
{
   struct Source * s;

   s = ufdbNewGV.lastSource;
   if (s->ipv4 == NULL  &&  s->ipv4hosts == NULL  &&  
       s->ipv6 == NULL  &&  s->ipv6hosts == NULL  &&
       s->domainDb == NULL  &&  s->userDb == NULL)
   {
      if (s->execiplistCommand == NULL)
      {
	 ufdbLogError( "source \"%s\" missing active content, set inactive  *****", s->name );
	 s->time = NULL;
	 s->active = 0;
      }
      else
	 ufdbLogError( "source \"%s\" has an execiplist command but the list is empty and set inactive   *****",
	               s->name );
   }
}


static void ufdbSourceUser( 
   char *          user )
{
   char *          lc;
   struct Source * sp;

   sp = ufdbNewGV.lastSource;
   if (sp->userDb != NULL  &&  sp->userDb->type != SGDBTYPE_USERLIST)
   {
      ufdbLogFatalError( "user \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec userlists", 
                         user, sp->name, lineno );
      return;
   }
   if (sp->userDb == NULL)
   {
      sp->userDb = (struct sgDb *) ufdbMalloc( sizeof(struct sgDb) );
      sp->userDb->dbhome = NULL;
      sp->userDb->dbcp = (void *) UFDBmemDBinit();
      sp->userDb->type = SGDBTYPE_USERLIST;
      sp->userDb->entries = 0;
   }

   for (lc = user;  *lc != '\0';  lc++)    // convert username to lowercase
   {
      if (*lc <= 'Z'  &&  *lc >= 'A')
         *lc += 'a' - 'A';
   }

   if (ufdbGV.debug > 1)
      ufdbLogMessage( "ufdbSourceUser: adding user \"%s\"", user );

   sp->userDb->entries++;
   UFDBmemDBinsert( (struct UFDBmemDB *) sp->userDb->dbcp, user, NULL );
   ufdbFree( user );
}


static void ufdbSourceUnixGroup(
   char *          groupName  )
{
   struct Source * sp;
   struct group *  grp;
   int             n;
   char *          user;

   sp = ufdbNewGV.lastSource;
   if (sp->userDb != NULL  &&  sp->userDb->type != SGDBTYPE_USERLIST)
   {
      ufdbLogFatalError( "unix group \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec userlists", 
                         groupName, sp->name, lineno );
      return;
   }
   if (sp->userDb == NULL) 
   {
      sp->userDb = (struct sgDb *) ufdbMalloc( sizeof(struct sgDb) );
      sp->userDb->dbhome = NULL;
      sp->userDb->dbcp = (void *) UFDBmemDBinit();
      sp->userDb->type = SGDBTYPE_USERLIST;
      sp->userDb->entries = 0;
   }
 
   n = 0;
   setgrent();
   errno = 0;
   grp = getgrnam( groupName );
   if (grp != NULL)
   {
      if (ufdbGV.debug > 1)
         ufdbLogMessage( "found group \"%s\"", grp->gr_name );

      while ((user = grp->gr_mem[n]) != NULL)
      {
	 char * lc;

	 if (ufdbGV.debug > 1)
	    ufdbLogMessage( "group \"%s\" has user \"%s\"", grp->gr_name, user );
	 for (lc = user;  *lc != '\0';  lc++)  	// convert username to lowercase
	 {
	    if (*lc <= 'Z'  &&  *lc >= 'A')
	       *lc += 'a' - 'A';
	 }
	 UFDBmemDBinsert( (struct UFDBmemDB *) sp->userDb->dbcp, user, NULL );
	 sp->userDb->entries++;
	 n++;
      }
      ufdbLogMessage( "source \"%s\": unix group \"%s\" has %d members", sp->name, groupName, n );
      if (n == 0)
	 ufdbLogMessage( "WARNING: source \"%s\": \"%s\" is an empty group  +++++", sp->name, groupName );
   }
   else
   {
      ufdbLogFatalError( "source \"%s\": \"%s\" is not a unix group", sp->name, groupName );
      if (errno)
	 ufdbLogError( "ufdbSourceUnixGroup: getgrnam returned error %d: %s", errno, strerror(errno) );
   }
   endgrent();
}


static void ufdbSourceGroup( 
   int    groupType,
   char * groupName  )
{
   switch (groupType)
   {
   case UFDB_GROUPTYPE_UNIX:
      ufdbSourceUnixGroup( groupName );
      break;
   default:     
      ufdbLogFatalError( "ufdbSourceGroup: unknown group type %d", groupType );
   }

   ufdbFree( groupName );
}


struct sgDb * UFDBretrieveExecDomainlist( struct Category * cat )       // uses ufdbGV
{
   char *        t;
   FILE *        fp;
   struct sgDb * newdb;
   int           exitcode;
   struct stat   Stat0;
   struct stat   Stat1;
   char          line[1024];
   char          basefilename[1024];
   char          fullfilename[1024];
   char          command[3000];

   if (cat == NULL)
   {
      ufdbLogFatalError( "UFDBretrieveExecDomainlist: category is NULL" );
      return NULL;
   }

   if (cat->domainlist == NULL)
   {
      ufdbLogError( "will not execute command for category %s since domainlist is undefined", cat->name );
      return NULL;
   }

   if (cat->execdomainlist == NULL)
   {
      ufdbLogError( "can't execute command for category %s since execdomainlist is undefined", cat->name );
      return NULL;
   }

   if (cat->domainlist[0] == '/')
   {
      strcpy( basefilename, cat->domainlist );
   }
   else
   {
      char * dbhome;
      dbhome = ufdbGV.databaseDirectory;
      sprintf( basefilename, "%s/%s", dbhome, cat->domainlist );
   }
   strcpy( fullfilename, basefilename );
   strcat( fullfilename, UFDBfileSuffix );

   if (stat( fullfilename, &Stat0 ) != 0)
   {
      Stat0.st_mtime = 0;
      ufdbLogMessage( "category %s: pre-execdomainlist: domainlist does not exist (%s)",
                      cat->name, fullfilename );
   }

   /* The script that we will call needs the directory where the files reside,
    * so the popen-command contains a "cd" just before executing the script.
    * (note that we are multithreaded and cannot use chdir() here)
    */
   strcpy( command, "cd " );
   strcat( command, basefilename );
   t = strrchr( command, '/' );
   if (t != NULL)
      *t = '\0';
   strcat( command, " ; " );
   strcat( command, cat->execdomainlist );

   errno = 0;
   if ((fp = popen(command,"r")) == NULL)
   {
      ufdbLogFatalError( "category %s: can't execute command of execdomainlist \"%s\": popen failed: %s  *****",
                         cat->name, cat->execdomainlist, strerror(errno) );
      return NULL;
   }

   while (UFDBfgetsNoNL(line,sizeof(line)-1,fp) != NULL)
   {
      ufdbLogMessage( "execdomainlist for %s produced: %s", cat->name, line );
   }
   errno = 0;
   exitcode = pclose( fp );

   if (exitcode == -1  &&  errno == ECHILD)
      exitcode = 0;
      /* most likely the child handler thread already did a wait() */

   if (exitcode == 0)
   {
      if (ufdbGV.debug || ufdbGV.debugExternalScripts)
         ufdbLogMessage( "   execdomainlist for %s: exit 0 (OK)", cat->name );
   }
   else if (exitcode == -1)
   {
      ufdbLogError( "execdomainlist for %s: pclose error: %d (%s)", cat->name, errno, strerror(errno) );
      return NULL;
   }
   else if (exitcode > 0)
   {
      ufdbLogError( "execdomainlist for %s: command (%s) terminated with an error exit code %d", 
                    cat->name, cat->execdomainlist, exitcode );
      return NULL;
   }

   /* The command defined by 'execdomainlist' has been executed and the exit code was 0 (OK), so
    * now it is verified if the file timestamp of domains.ufdb is newer.
    */

   if (stat( fullfilename, &Stat1 ) != 0)
   {
      ufdbLogError( "execdomainlist for %s: command failed to produce a .ufdb file (%s)",
                    cat->name, fullfilename );
      return NULL;
   }

   newdb = (struct sgDb *) ufdbCalloc( sizeof(struct sgDb), 1 );
   newdb->dbhome = NULL;
   newdb->dbcp = NULL;
   newdb->type = SGDBTYPE_DOMAINLIST;

   sgDbInit( newdb, basefilename );
   if (newdb->dbcp == NULL)
   {
      ufdbLogError( "execdomainlist for %s: command produced a .ufdb file but I failed to load it", cat->name );
      ufdbFree( newdb );
      return NULL;
   }

   if (ufdbGV.debug || ufdbGV.debugExternalScripts)
      ufdbLogMessage( "execdomainlist for %s: new URL table is loaded", cat->name );

   return newdb;
}


static void ufdbSourceExecUserList(
   char *          command )            // must be malloced
{
   time_t          t0, te;
   struct Source * sp;

   /* execuserlist is used to dynamically retrieve a list of usernames and
    * is executed every 15 minutes to refresh the list of usernames.
    */

   sp = ufdbNewGV.lastSource;
   if (sp->userDb != NULL  &&  sp->userDb->type != SGDBTYPE_EXECUSERLIST)
   {
      ufdbLogFatalError( "execuserlist \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec userlists", 
                         command, sp->name, lineno );
      return;
   }
   if (sp->userDb != NULL)
   {
      ufdbLogFatalError( "execuserlist \"%s\" in source \"%s\" on line %d: "
                         "more than one execuserlist is not supported.  Merge the userlists in the script.", 
                         command, sp->name, lineno );
      return;
   }
   ufdbLogMessage( "execuserlist \"%s\"", command );

   t0 = time( NULL );
   sp->userDb = UFDBretrieveExecUserlist( &ufdbNewGV, command );
   sp->sarg0 = command;				/* command is already malloc-ed */
   te = time( NULL );

   if (te - t0 > 4)
      ufdbLogMessage( "WARNING: it took %ld seconds to execute \"%s\"  *****", (long) (te - t0), command );
 
   if (ufdbGV.debug>1 || ufdbGV.debugExternalScripts)
   {
      UFDBmemDBprintUserDB( "user", (struct UFDBmemDB *) sp->userDb->dbcp );
   }
}


static void ufdbSourceExecIPList(
   char *          command )            // must be malloced
{
   time_t          t0, te;
   struct Source * sp;

   /* execiplist is used to dynamically retrieve a list of IP addresses and
    * is executed every 15 minutes to refresh the list of IP addresses.
    */

   sp = ufdbNewGV.lastSource;
   if (sp->ipv4 != NULL  ||  sp->ipv6 != NULL)
   {
      ufdbLogFatalError( "execiplist \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec iplists", 
                         command, sp->name, lineno );
      return;
   }
   ufdbLogMessage( "execiplist \"%s\"", command );

   t0 = time( NULL );
   UFDBretrieveExecIPlist( &ufdbNewGV, command, &sp->ipv4hosts, &sp->ipv4, &sp->ipv6hosts, &sp->ipv6 );
   sp->execiplistCommand = command;			/* command is already malloc-ed */
   te = time( NULL );

   if (te - t0 > 4)
      ufdbLogMessage( "WARNING: it took %ld seconds to execute \"%s\"  *****", (long) (te - t0), command );
 
   if (ufdbGV.debug>1 || ufdbGV.debugExternalScripts)
   {
      UFDBlogIPv4( sp->ipv4 );
      UFDBlogIPv6( sp->ipv6 );
   }
}


static void ufdbSourceUserList( 
   char * file  )
{
   char * dbhome;
   char * f;
   FILE * fp;
   char * p;
   char * c;
   char * s;
   char * lc;
   char * lineptr;
   int    ullineno;
   struct sgDb * udb;
   struct Source * sp;
   char   line[10000];
 
   sp = ufdbNewGV.lastSource;
   if (ufdbGV.debug)
      ufdbLogMessage( "ufdbSourceUserList: source \"%s\"  file \"%s\"", 
       		      sp->name != NULL ? sp->name : "nosource", file );
   udb = sp->userDb;
   if (udb != NULL  &&  udb->type != SGDBTYPE_USERLIST)
   {
      ufdbLogFatalError( "userlist \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec userlists", 
                         file, sp->name, lineno );
      return;
   }
   if (udb == NULL)
   {
      udb = sp->userDb = (struct sgDb *) ufdbMalloc( sizeof(struct sgDb) );
      udb->dbhome = NULL;
      udb->dbcp = (void *) UFDBmemDBinit();
      udb->type = SGDBTYPE_USERLIST;
      udb->entries = 0;
   }
 
   dbhome = ufdbNewGV.databaseDirectory;
 
   if (file[0] == '/')
      f = file;
   else
   {
      f = (char *) ufdbMalloc( strlen(dbhome) + strlen(file) + 2 );
      strcpy( f, dbhome );
      strcat( f, "/" );
      strcat( f, file );
      ufdbFree( file );
   }
 
   if ((fp = fopen(f,"r")) == NULL)
   {
      ufdbLogError( "line %d: can't open userlist %s: %s  *****", lineno, f, strerror(errno) );
      ufdbFree( f );
      return;
   }
   ullineno = 0;
 
   ufdbLogMessage( "userlist \"%s\"", f );
 
   while (fgets(line,sizeof(line),fp) != NULL)
   {
      ullineno++;
      if (line[0] == '#')			/* skip comments */
         continue;
 
      p = strchr( line, '\n' );
      if (p != NULL)
      {
         *p = '\0';
         if (p != line) 
         {
  	    if (*(p - 1) == '\r') 		/* remove ^M  */
  	       *(p-1) = '\0';
         }
      }
  
      if (line[0] == '\0')
      {
         ufdbLogError( "userlist %s: line %d: line is empty", f, ullineno );
         continue;
      }
  
      c = strchr( line, '#' );		        /* remove comment */
      if (c != NULL)
         *c = '\0';
  
      p = strtok_r( line, " \t,", &lineptr );
      if (p == NULL  ||  *p == '\0')
         continue;
  
      /* we may have a passwd-style formatted file. Ignore ':' and everything else that follows. */
      if ((s = strchr(p,':')) != NULL) 
         *s = '\0';
  
      do
      {
         for (lc = p;  *lc != '\0';  lc++)      // convert username to lowercase
         {
  	    if (*lc <= 'Z'  &&  *lc >= 'A')
  	       *lc += 'a' - 'A';
         }
         if (*p != '\0')
 	 {
	    udb->entries++;
  	    UFDBmemDBinsert( (struct UFDBmemDB *) udb->dbcp, p, NULL );
         }
      } while ((p = strtok_r(NULL," \t,",&lineptr)) != NULL  &&  *p != '\0');
   }
   fclose( fp );

   if (ufdbGV.debug > 1)
   {
      ufdbLogMessage( "just read userlist \"%s\"", f );
      UFDBmemDBprintUserDB( "user", (struct UFDBmemDB *) udb->dbcp );
   }

   ufdbFree( f );
}


static void ufdbSourceUserQuota( 
   const char * seconds, 
   const char * sporadic,  
   const char * renew )
{
   if (seconds == NULL || sporadic == NULL || renew == NULL)
      { ; }      // prevent compiler warning

   ufdbLogError( "line %d: userquota is not supported", lineno );
}


static void defSourceDomain( 
   char * domain )
{
   struct Source * sp;

   sp = ufdbNewGV.lastSource;
   if (sp->domainDb == NULL) 
      sp->domainDb = (struct sgDb *) UFDBmemDBinit();

   if (ufdbGV.debug)
      ufdbLogMessage( "defSourceDomain \"%s\"", domain );

   UFDBmemDBinsert( (struct UFDBmemDB *) sp->domainDb, domain, NULL );

   ufdbFree( domain );
}


static void ufdbSourceEval( 
   int method  )
{
   if (ufdbNewGV.lastSource != NULL)
   {
      if (ufdbGV.debug)
         ufdbLogMessage( "ufdbSourceEval %d: %s", method, 
	                 method == UFDB_EVAL_OR ? "evaluate-or" : "evaluate-and" );
      ufdbNewGV.lastSource->evaluationMethod = method;
   }
}


static void defSourceTime( 
   char *         name, 
   int            within )
{
   struct ufdbTime *  t;

   if ((t = sgTimeFindName(name)) == NULL)
   {
      ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
		         lineno, name, ufdbNewGV.configFile );
      ufdbFree( name );
      return;
   }

   ufdbNewGV.lastSource->within = within;
   ufdbNewGV.lastSource->time = t;
   ufdbFree( name );
}


static struct Source * defSourceFindName( 
   struct Source * slist,
   const char *    name )
{
   for ( ;  slist != NULL;  slist = slist->next)
   {
      if (strcmp(name,slist->name) == 0)
         return slist;
   }
   return NULL;
}


static void defSourceIPV4List( 
   char * file )
{
   char * dbhome;
   char * f;
   FILE * fp;
   char * p;
   char * c;
   char * cidr;
   int    i;
   int    l = 0;
   char * lineptr;
   char   line[UFDB_MAX_URL_LENGTH];

   dbhome = ufdbNewGV.databaseDirectory;

   if (file[0] == '/') 
   {
      f = file;
   }
   else
   {
      f = (char *) ufdbMalloc( strlen(dbhome) + strlen(file) + 2 );
      strcpy( f, dbhome );
      strcat( f, "/" );
      strcat( f, file );
      ufdbFree( file );
   }

   if ((fp = fopen(f,"r")) == NULL) 
   {
      ufdbLogError( "line %d: can't open ipv4list %s: %s", lineno, f, strerror(errno) );
      ufdbFree( f );
      return;
   }

   ufdbLogMessage( "ipv4list \"%s\"", f );

   while (fgets(line,sizeof(line),fp) != NULL)
   {
      l++;
      if (*line == '#')
         continue;
      p = strchr( line, '\n' );
      if (p != NULL && p != line) 
      {
         if (*(p - 1) == '\r') 		        // remove ^M
            p--;
         *p = '\0';
      }
      c = strchr( line, '#' );
      p = strtok_r( line, " \t,", &lineptr );
      do {
         if (c != NULL && p >= c) 		// find the comment
            break;
         i = strspn( p, ".0123456789/-" );
         if (i == 0)
            break;
         *(p + i) = '\0';
         if ((cidr = strchr(p,'/')) != NULL) 
         {
            if (strchr(cidr,'.') == NULL)
               sgIpv4( p, SG_IPTYPE_CIDR, f, l );
            else 
               sgIpv4( p, SG_IPTYPE_CLASS, f, l );
          }
          else if ((cidr = strchr(p,'-')) != NULL) 
          {
             sgIpv4( p, SG_IPTYPE_RANGE, f, l );
          }
          else
          {
             sgIpv4( p, SG_IPTYPE_HOST, f, l );
          }
      } while ((p = strtok_r(NULL," \t,",&lineptr)) != NULL);
   }

   fclose( fp );
   ufdbFree( f );
}


static void defSourceIPV6List( 
   char * file )
{
   char * dbhome;
   char * f;
   FILE * fp;
   char * p;
   char * c;
   int    i;
   int    l = 0;
   char * lineptr;
   char   line[UFDB_MAX_URL_LENGTH];

   dbhome = ufdbNewGV.databaseDirectory;

   if (file[0] == '/') 
   {
      f = file;
   }
   else
   {
      f = (char *) ufdbMalloc( strlen(dbhome) + strlen(file) + 2 );
      strcpy( f, dbhome );
      strcat( f, "/" );
      strcat( f, file );
      ufdbFree( file );
   }

   if ((fp = fopen(f,"r")) == NULL) 
   {
      ufdbLogError( "line %d: can't open ipv6list %s: %s", lineno, f, strerror(errno) );
      ufdbFree( f );
      return;
   }

   ufdbLogMessage( "ipv6list \"%s\"", f );

   while (fgets(line,sizeof(line),fp) != NULL)
   {
      l++;
      if (*line == '#')
         continue;
      p = strchr( line, '\n' );
      if (p != NULL && p != line) 
      {
         if (*(p - 1) == '\r') 		        // remove ^M
            p--;
         *p = '\0';
      }
      c = strchr( line, '#' );
      p = strtok_r( line, " \t,", &lineptr );
      do {
         if (c != NULL && p >= c) 		// find the comment
            break;
         i = strspn( p, ":.0123456789ABCDEFabcdef/" );
         if (i == 0)
            break;
         *(p + i) = '\0';
         if (strchr(p,'/') != NULL) 
         {
            sgIpv6( p, SG_IPV6TYPE_CIDR, f, l );
         }
         else
         {
            sgIpv6( p, SG_IPV6TYPE_HOST, f, l );
         }
      } while ((p = strtok_r(NULL," \t,",&lineptr)) != NULL);
   }

   fclose( fp );
   ufdbFree( f );
}


/* category block functions */

void ufdbCategory( 
  char *            cat )
{
  struct Category * sp;

#if UFDB_DEBUG
   ufdbLogMessage( "ufdbCategory %s", cat );
#endif

  if (ufdbNewGV.catList != NULL) 
  {
    if ((struct Category *) ufdbCategoryFindByName(&ufdbNewGV,cat) != NULL)
    {
      ufdbLogFatalError( "line %d: category %s is already defined in configuration file %s",
		         lineno, cat, ufdbNewGV.configFile );
      ufdbFree( cat );
      return;
    }
  }

  sp = (struct Category *) ufdbMallocAligned( UFDB_CACHELINE_SIZE, sizeof(struct Category) );
  sp->active = 1;
  sp->within = UFDB_ACL_NONE;
  sp->activeBumping = UFDB_ACTIVE_BUMPING_NOTSET;
  sp->blockBumpedConnect = 0;
  sp->options = 0;
  sp->name = cat;
  sp->domainlist = NULL;
  sp->domainlistDb = NULL;
  sp->execdomainlist = NULL;
  sp->expressionlist = NULL;
  sp->regExp = NULL;
  sp->redirect = NULL;
  sp->time = NULL;
  sp->rewrite = NULL;
  sp->next = NULL;
  sp->nblocks = 0;
  sp->nmatches = 0;

  if (ufdbNewGV.catList == NULL) {
    ufdbNewGV.catList = sp;
    ufdbNewGV.lastCat = sp;
  } else {
    ufdbNewGV.lastCat->next = sp;
    ufdbNewGV.lastCat = sp;
  }

   /* category "security" is a special case: the options cannot be set default to 0
    * because the default value for allow-unknown-protocol-over-https is ON.
    */
   if (strcmp( cat, "security" ) == 0)
      sp->options = UFDB_OPT_UNKNOWN_PROTOCOL_OVER_HTTPS;
}


void ufdbCategoryEnd( void )
{
  struct Category * d;
 
  d = ufdbNewGV.lastCat;
  if (d->domainlist == NULL  &&  d->expressionlist == NULL  && 
      d->redirect == NULL  &&  d->rewrite == NULL  &&
      d->options == 0)
  {
    ufdbLogError( "category \"%s\" is missing content, set inactive  *****", d->name );
    d->time = NULL;
    d->active = 0;
  }
}


static void ufdbCategoryOption( int value, int option )
{
   struct Category * sp;

   sp = ufdbNewGV.lastCat;
   if (value)
      sp->options = sp->options | option;
   else
      sp->options = sp->options & (~option);

   if (option == UFDB_OPT_HTTPS_WITH_HOSTNAME)
      ufdbNewGV.httpsWithHostname = value;
   else if (option == UFDB_OPT_HTTPS_OFFICAL_CERTIFICATE)
      ufdbNewGV.httpsOfficialCertificate = value;
   else if (option == UFDB_OPT_SKYPE_OVER_HTTPS)
      ufdbNewGV.SkypeOverHttps = value;
   else if (option == UFDB_OPT_GTALK_OVER_HTTPS)
      ufdbNewGV.GtalkOverHttps = value;
   else if (option == UFDB_OPT_YAHOOMSG_OVER_HTTPS)
      ufdbNewGV.YahooMsgOverHttps = value;
   else if (option == UFDB_OPT_AIM_OVER_HTTPS)
      ufdbNewGV.AimOverHttps = value;
   else if (option == UFDB_OPT_FBCHAT_OVER_HTTPS)
      ufdbNewGV.FBchatOverHttps = value;
   else if (option == UFDB_OPT_CITRIXONLINE_OVER_HTTPS)
      ufdbNewGV.CitrixOnlineOverHttps = value;
   else if (option == UFDB_OPT_ANYDESK_OVER_HTTPS)
      ufdbNewGV.AnydeskOverHttps = value;
   else if (option == UFDB_OPT_TEAMVIEWER_OVER_HTTPS)
      ufdbNewGV.TeamviewerOverHttps = value;
   else if (option == UFDB_OPT_PROHIBIT_INSECURE_SSLV2)
      ufdbNewGV.httpsNoSSLv2 = value;
   else if (option == UFDB_OPT_PROHIBIT_INSECURE_SSLV3)
      ufdbNewGV.httpsNoSSLv3 = value;
   else if (option == UFDB_OPT_PROHIBIT_INSECURE_TLSV1_0)
      ufdbNewGV.httpsNoTLSv1_0 = value;
   else if (option == UFDB_OPT_UNKNOWN_PROTOCOL_OVER_HTTPS)
      ufdbNewGV.unknownProtocolOverHttps = value;
   else if (option == UFDB_OPT_SAFE_SEARCH)
      ;
   else if (option == UFDB_OPT_YOUTUBE_EDUFILTER)
      ;
   else
      ufdbLogError( "ufdbCategoryOption: unrecognised option %d *****", option );

   if (ufdbGV.debug > 1)
      ufdbLogMessage( "ufdbCategoryOption: %s: option %d set to %d", sp->name, option, value );
}


void ufdbCategoryDomainList( 
  char * domainlist )
{
  struct Category * sp;
  const char *      dbhome;
        char *      dl;
  const char *      name;

  if (ufdbGV.debug > 1)
     ufdbLogMessage( "ufdbCategoryDomainList %s", domainlist==NULL ? "NULL" : domainlist );

  if (ufdbNewGV.terminating)
     return;

  sp = ufdbNewGV.lastCat;

  if (sp->domainlistDb != NULL)
  {
     ufdbLogFatalError( "line %d: specify only one domainlist per category in configuration file %s",
		        lineno, ufdbNewGV.configFile );
     return;
  }

  dbhome = ufdbNewGV.databaseDirectory;

  if (domainlist == NULL)
  {
    name = sp->name;
    dl = (char *) ufdbMalloc( sizeof("/dest/") + strlen(name) + sizeof("/domainlist") + 2 );
    strcpy(dl,"/dest/");
    strcat(dl,name);
    strcat(dl,"/domainlist");

    sp->domainlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(dl) + 2 );
    strcpy(sp->domainlist,dbhome);
    strcat(sp->domainlist,"/");
    strcat(sp->domainlist,dl);
  }
  else
  {
    if (domainlist[0] == '/') 
      sp->domainlist = domainlist;
    else
    {
       sp->domainlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(domainlist) + 2 );
       strcpy( sp->domainlist, dbhome );
       strcat( sp->domainlist, "/" );
       strcat( sp->domainlist, domainlist );
       ufdbFree( (void*) domainlist );
    }
  }

  sp->domainlistDb = (struct sgDb *) ufdbCalloc( 1, sizeof(struct sgDb) );
  sp->domainlistDb->type = SGDBTYPE_DOMAINLIST;
  ufdbLogMessage( "loading URL table from \"%s\"", sp->domainlist );
  sgDbInit( sp->domainlistDb, sp->domainlist );
  if (sp->domainlistDb->dbcp == NULL  ||
      ((struct UFDBmemTable *) sp->domainlistDb->dbcp)->table.nNextLevels == 0)
  {
    ufdbLogError( "URL database table \"%s\" is empty and is ignored   *****", sp->domainlist );
    ufdbFreeDomainDb( sp->domainlistDb );
    sp->domainlistDb = NULL;
  }
}


static void ufdbCategoryExecDomainList( 
   char * command )
{
   struct Category * sp;

#if UFDB_DEBUG
   ufdbLogMessage( "ufdbCategoryExecDomainList %s", command );
#endif

   sp = ufdbNewGV.lastCat;

   if (sp == NULL)
   {
      ufdbLogFatalError( "execdomainlist is not within a URL category" );
      return;
   }
   sp->execdomainlist = command;

   if (ufdbGV.debug)
      ufdbLogMessage( "execdomainlist for category %s: \"%s\"", sp->name, command );
}


void ufdbFreeDomainDb( 
   struct sgDb * dbp )
{
   struct UFDBmemTable * mt;

   if (dbp == NULL)
      return;

   mt = (struct UFDBmemTable *) dbp->dbcp;
   if (mt != NULL)
   {
      if (mt->index != NULL)
      {
	 ufdbFree( mt->index );				/* version 2.x */
	 ufdbFree( mt->table.nextLevel );
      }
      else
	 UFDBfreeTableIndex_1_2( &(mt->table) ); 	/* version 1.2 */
#if HAVE_MADVISE && !UFDB_BARE_METAL_SUPPORT && __linux__
      if (mt->madvisedSize)
         madvise( mt->mem, mt->madvisedSize, MADV_NORMAL );
#endif
      if (mt->memStatus == UFDB_MEMSTATUS_MALLOC)
         ufdbFree( (void *) mt->mem );
      ufdbFree( mt );
   }
   ufdbFree( dbp );
}


void ufdbFreeIpv4List( struct Ipv4 * ipv4 )
{
   struct Ipv4 * tmp;

   while (ipv4 != NULL)
   {
      tmp = ipv4->next;
      ufdbFree( (void*) ipv4 );
      ipv4 = tmp;
   }
}


void ufdbFreeIpv6List( struct Ipv6 * ipv6 )
{
   struct Ipv6 * tmp;

   while (ipv6 != NULL)
   {
      tmp = ipv6->next;
      ufdbFree( (void*) ipv6 );
      ipv6 = tmp;
   }
}


static void ufdbFreeSourceList( struct Source * src )
{
   struct Source * tmp;

   while (src != NULL)
   {
      if (src->ipv4hosts != NULL)
         UFDBmemDBdeleteDB( src->ipv4hosts );
      ufdbFreeIpv4List( src->ipv4 );
      if (src->ipv6hosts != NULL)
         UFDBmemDBdeleteDB( src->ipv6hosts );
      ufdbFreeIpv6List( src->ipv6 );

      ufdbFree( (void*) src->name );
      if (src->domainDb != NULL)
	 UFDBmemDBdeleteDB( (struct UFDBmemDB *) src->domainDb );

      /* execuserlist content is saved during a reload except when ufdbguardd terminates */
      if (src->userDb != NULL  &&  src->userDb->type != SGDBTYPE_EXECUSERLIST)
      {
	 UFDBmemDBdeleteDB( (struct UFDBmemDB *) src->userDb->dbcp );
	 ufdbFree( (void*) src->userDb );
      }
      ufdbFree( (void*) src->sarg0 );
      ufdbFree( (void*) src->execiplistCommand );

      tmp = src->next;
      ufdbFree( (void*) src );
      src = tmp;
   }
}


static void ufdbFreeAclCategoryList( struct AclCategory * ac )
{
   struct AclCategory * tmp;

   while (ac != NULL)
   {
      ufdbFree( (void*) ac->name );
      tmp = ac->next;
      ufdbFree( (void*) ac );
      ac = tmp;
   }
}


static void ufdbFreeAclList( struct Acl * acl )
{
   struct Acl * tmp;

   while (acl != NULL)
   {
      ufdbFree( (void*) acl->name );
      ufdbFreeAclCategoryList( acl->pass );
      ufdbFreeAclCategoryList( acl->implicitPass );
      ufdbFree( (void*) acl->redirect );
      tmp = acl->next;
      ufdbFree( (void*) acl );
      acl = tmp;
   }
}


static void ufdbFreeCategoryList( struct Category * cat )
{
   struct Category * tmp;

   while (cat != NULL)
   {
      if (ufdbGV.debug > 1  ||  ufdbGV.debugRegexp)
         ufdbLogMessage( "ufdbFreeCategoryList: freeing regexp of category %s", cat->name );
      ufdbFreeRegExprList( cat->regExp );
      ufdbFree( (void*) cat->name );
      ufdbFree( (void*) cat->domainlist );
      ufdbFreeDomainDb( cat->domainlistDb );
      ufdbFree( (void*) cat->execdomainlist );
      ufdbFree( (void*) cat->expressionlist );
      ufdbFree( (void*) cat->redirect );
      /* ufdbFree( cat->rewrite );  freed in ufdbFreeRewriteList() */
      tmp = cat->next;
      ufdbFree( (void*) cat );
      cat = tmp;
   }
}


static void ufdbFreeRewriteList( 
   struct sgRewrite * p )
{
   struct sgRewrite * tmp;

   while (p != NULL)
   {
      ufdbFreeRegExprList( p->rewrite );
      ufdbFree( (void*) p->name );
      tmp = p->next;
      ufdbFree( (void*) p );
      p = tmp;
   }
}


static void ufdbFreeTimeElement( 
   struct TimeElement * p )
{
   struct TimeElement * tmp;

   while (p != NULL)
   {
      tmp = p->next;
      ufdbFree( (void*) p );
      p = tmp;
   }
}


static void ufdbFreeTime( 
   struct ufdbTime * p )
{
   struct ufdbTime * tmp;

   while (p != NULL)
   {
      ufdbFree( (void*) p->name );
      ufdbFreeTimeElement( p->element );
      tmp = p->next;
      ufdbFree( (void*) p );
      p = tmp;
   }
}


void ufdbFreeLastBits( struct ufdbGV * gv )
{
   /* we may need these variables during a reload */
   if (gv->pidFilename != NULL)
   {
      ufdbFree( (void*) gv->pidFilename );
      gv->pidFilename = NULL;
   }
   if (gv->emailServer != NULL)
   {
      ufdbFree( (void*) gv->emailServer );
      gv->emailServer = NULL;
   }
   if (gv->myHostname != NULL)
   {
      ufdbFree( (void*) gv->myHostname );
      gv->myHostname = NULL;
   }
   if (gv->adminEmail != NULL)
   {
      ufdbFree( (void*) gv->adminEmail );
      gv->adminEmail = NULL;
   }
   if (gv->senderEmail != NULL)
   {
      ufdbFree( (void*) gv->senderEmail );
      gv->senderEmail = NULL;
   }
   if (gv->externalStatusCommand != NULL)
   {
      ufdbFree( (void*) gv->externalStatusCommand );
      gv->externalStatusCommand = NULL;
   }
}


void ufdbFreeAllMemory( struct ufdbGV * gv )
{
   gv->logDirectory[0] = '\0';

   ufdbFreeRewriteList( gv->rewrite );
   gv->rewrite = NULL;
   gv->lastRewrite = NULL;
   gv->lastRewriteRegExec = NULL;

   ufdbFreeCategoryList( gv->catList );
   gv->catList = NULL;
   gv->lastCat = NULL;

   ufdbFreeAclList( gv->aclList );
   gv->aclList = NULL;
   gv->lastAcl = NULL;
   gv->defaultAcl = NULL;
   gv->lastAclCategory = NULL;

   ufdbFreeSourceList( (struct Source *) gv->sourceList );
   gv->sourceList = NULL;
   gv->lastSource = NULL;

   /* free ufdbNewGV.checkedDB */
   if (gv->checkedDB.mem != NULL)
   {
      if (gv->checkedDB.index != NULL)
      {
         ufdbFree( (void*) gv->checkedDB.index );
	 ufdbFree( gv->checkedDB.table.nextLevel );
      }
      else
	 UFDBfreeTableIndex_1_2( &(gv->checkedDB.table) );
#if HAVE_MADVISE && !UFDB_BARE_METAL_SUPPORT && __linux__
      if (gv->checkedDB.madvisedSize)
         madvise( gv->checkedDB.mem, gv->checkedDB.madvisedSize, MADV_NORMAL );
#endif
      gv->checkedDB.madvisedSize = 0;
      if (gv->checkedDB.memStatus == UFDB_MEMSTATUS_MALLOC)
         ufdbFree( (void*) gv->checkedDB.mem );
   }
   gv->checkedDB.table.nextLevel = NULL;
   gv->checkedDB.table.nNextLevels = 0;
   gv->checkedDB.mem = NULL;
   gv->checkedDB.index = NULL;

   if (gv->checkedExpressions != NULL)
   {
      ufdbFreeRegExprList( gv->checkedExpressions );
      gv->checkedExpressions = NULL;
   }

   ufdbFreeTime( gv->timeList );
   gv->timeList = NULL;
   gv->lastTime = NULL;

   gv->lastTimeElement = NULL;
   gv->timeElement = NULL;

   gv->lastRegExpDest = NULL;

   ufdbFree( (void*) gv->SquidVersion );
   gv->SquidVersion = NULL;
}


static void ufdbCategoryUrlList( 
   char * urllist )
{
   if (urllist == NULL)
      urllist = (char *) "-";
   ufdbLogError( "line %d: \"urllist %s\" is deprecated and ignored *****\n"
                 "ufdbGenTable should be called with the -u option to include URLs\n"
		 "ufdbGenTable combines URLs and domains in one table file so only the domainlist is required",
		 lineno, urllist );
   if (urllist[0] != '-')
      ufdbFree( (void*) urllist );
}


void ufdbCategoryExpressionList( 
  char * exprlist, 
  const char * chcase  )
{
  FILE * fp;
  char * dbhome;
  char * dl;
  const char * name;
  char * p;
  int    flags;
  struct stat         statbuf;
  struct Category *   sp;
  struct ufdbRegExp * regexp;
  char   buf[UFDB_MAX_URL_LENGTH];
  char   errbuf[256];

#if UFDB_DEBUG
   ufdbLogMessage( "ufdbCategoryExpressionList %s", exprlist );
#endif

  flags = REG_EXTENDED | REG_NOSUB;
  sp = ufdbNewGV.lastCat;
  dbhome = ufdbNewGV.databaseDirectory;

  if (exprlist == NULL)
  {
    name = sp->name;
    dl = (char *) ufdbMalloc( sizeof("/dest/") + strlen(name) + sizeof("/expressionlist") + 2 );
    strcpy(dl,"/dest/");
    strcat(dl,name);
    strcat(dl,"/expressionlist");

    flags |= REG_ICASE; 	/* default case insensitive */

    sp->expressionlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(dl) + 2 );
    strcpy(sp->expressionlist,dbhome);
    strcat(sp->expressionlist,"/");
    strcat(sp->expressionlist,dl);
  }
  else
  {
    if (exprlist[0] == '/') 
    {
      sp->expressionlist = exprlist;
    }
    else
    {
       sp->expressionlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(exprlist) + 2 );
       strcpy( sp->expressionlist, dbhome );
       strcat( sp->expressionlist, "/" );
       strcat( sp->expressionlist, exprlist );
       ufdbFree( (void*) exprlist );
    }
    if (*chcase == 'i')
       flags |= REG_ICASE;     /* set case insensitive */
  }

  ufdbLogMessage( "loading regular expressions from \"%s\"", sp->expressionlist );

  if ((fp = fopen(sp->expressionlist, "r")) == NULL) 
  {
    ufdbLogFatalError( "cannot open expression list %s: %s", sp->expressionlist, strerror(errno) );
    return;
  }

  if (0 == fstat( fileno(fp), &statbuf ))
  {
     if (!S_ISREG(statbuf.st_mode))
     {
        ufdbLogFatalError( "expression list %s: not a regular file", sp->expressionlist );
	fclose( fp );
	return;
     }
  }

  while (!feof(fp)  &&  fgets(buf, sizeof(buf), fp) != NULL) 
  {
    if (buf[0] == '#')
       continue;

    p = (char *) strchr( buf, '\n' );
    if (p != NULL  &&  p != buf) 
    {
      if (*(p-1) == '\r') 	/* removing ^M  */
	p--;
      *p = '\0';
    }
    /* TO-DO: warn about leading and trailing spaces */
    regexp = ufdbNewPatternBuffer( buf, flags );
    if (regexp->error) 
    {
      regerror( regexp->error, (regex_t*) regexp->compiled[0], errbuf, sizeof(errbuf) );
      ufdbLogError( "regular expression error in %s:\n%s : %s   *****", sp->expressionlist, errbuf, buf );
    }
    if (ufdbNewGV.lastCat->regExp == NULL) 
    {
      ufdbNewGV.lastCat->regExp = regexp;
      ufdbNewGV.lastRegExpDest = regexp;
    }
    else
    {
      ufdbNewGV.lastRegExpDest->next = regexp;
      ufdbNewGV.lastRegExpDest = regexp;
    }
  }
  fclose( fp );

  if (ufdbNewGV.expressionOptimisation)
     ufdbNewGV.lastCat->regExp = UFDBoptimizeExprList( sp->expressionlist, ufdbNewGV.lastCat->regExp );
}


static void ufdbCategoryCACertsFile(
   char *              cacertsFile )
{
   struct Category *   cat;

   cat = ufdbNewGV.lastCat;
   if (cat == NULL  ||  strcmp( cat->name, "security" ) != 0)
   {
      ufdbLogFatalError( "cacerts can only be defined inside the \"security\" category" );
      return;
   }

   if (*cacertsFile == '/')
      strcpy( ufdbNewGV.CAcertsFile, cacertsFile );
   else
   {
      char * dbh;
      dbh = ufdbNewGV.databaseDirectory;
      strcpy( ufdbNewGV.CAcertsFile, dbh );
      strcat( ufdbNewGV.CAcertsFile, "/" );
      strcat( ufdbNewGV.CAcertsFile, cacertsFile );
   }
}


static void ufdbCategoryCACertsDir(
   char *              cacertsDir )
{
   struct Category *   cat;

   cat = ufdbNewGV.lastCat;
   if (cat == NULL  ||  strcmp( cat->name, "security" ) != 0)
   {
      ufdbLogFatalError( "cacerts-dir can only be defined inside the \"security\" category" );
      return;
   }

   if (*cacertsDir == '/')
      strcpy( ufdbNewGV.CAcertsDir, cacertsDir );
   else
   {
      char * dbh;
      dbh = ufdbNewGV.databaseDirectory;
      strcpy( ufdbNewGV.CAcertsDir, dbh );
      strcat( ufdbNewGV.CAcertsDir, "/" );
      strcat( ufdbNewGV.CAcertsDir, cacertsDir );
   }
}


static void ufdbCategoryRedirect( 
   char * value )
{
   struct Category * sp;

#if UFDB_DEBUG
   ufdbLogMessage( "ufdbCategoryRedirect %s", value );
#endif

   sp = ufdbNewGV.lastCat;
   sp->redirect = value;
   /* TODO: check that "localhost" is not here if no 302 is used */
}


static void ufdbCategoryRewrite( 
  char *              value )
{
  struct sgRewrite *  rewrite;

  if ((rewrite = sgRewriteFindName(value)) == NULL)
  {
    ufdbLogFatalError( "line %d: rewrite %s is not defined in configuration file %s",
		       lineno, value, ufdbNewGV.configFile );
    return;
  }

  ufdbNewGV.lastCat->rewrite = rewrite;
}


static void ufdbCategoryBlockConnect( 
   int flag  )
{
   ufdbNewGV.lastCat->blockBumpedConnect = flag;

   if (ufdbGV.debug > 1)
      ufdbLogMessage( "ufdbCategoryBlockConnect: category \"%s\" : block-bumped-connect %s",
                      ufdbNewGV.lastCat->name, flag ? "on" : "off" );
}


static void ufdbCategoryActiveBumping( 
   int flag  )
{
   ufdbNewGV.lastCat->activeBumping = flag ? UFDB_ACTIVE_BUMPING_ON : UFDB_ACTIVE_BUMPING_OFF;

   if (ufdbGV.debug > 1)
      ufdbLogMessage( "ufdbCategoryActiveBumping: category \"%s\" : squid-uses-active-bumping %s",
                      ufdbNewGV.lastCat->name, flag ? "on" : "off" );
}


static void ufdbCategoryTime(  
   char *       name, 
   int  	within )
{
   struct ufdbTime * t;

   if ((t = sgTimeFindName(name)) == NULL) 
   {
      ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
   		         lineno, name, ufdbNewGV.configFile );
      ufdbFree( (void*) name );
      return;
   }

   ufdbNewGV.lastCat->within = within;
   ufdbNewGV.lastCat->time = t;
   ufdbFree( (void*) name );
}


struct Category * ufdbCategoryFindByName( 
   struct ufdbGV *   gv,
   const char *      name )
{
   struct Category * p;

   for (p = gv->catList;  p != NULL;  p = p->next)
   {
      if (strcmp(name,p->name) == 0)
         return p;
   }
   return NULL;
}


static void sgRewrite( 
  char * rewrite )
{
  struct sgRewrite * rew;

#if UFDB_DEBUG
   ufdbLogMessage( "sgRewrite %s", rewrite );
#endif

  if (ufdbNewGV.rewrite != NULL)
  {
    if ((struct sgRewrite *) sgRewriteFindName(rewrite) != NULL)
    {
      ufdbLogFatalError( "line %d: rewrite \"%s\" is not defined in configuration file %s",
		         lineno, rewrite, ufdbNewGV.configFile );
      ufdbFree( (void*) rewrite );
      return;
    }
  }

  rew = (struct sgRewrite *) ufdbMalloc( sizeof(struct sgRewrite) );
  rew->name = rewrite;
  rew->active = 1;
  rew->rewrite = NULL;
  rew->time = NULL;
  rew->within = UFDB_ACL_NONE;
  rew->next = NULL;

  if (ufdbNewGV.rewrite == NULL) 
  {
    ufdbNewGV.rewrite = rew;
    ufdbNewGV.lastRewrite = rew;
  }
  else
  {
    ufdbNewGV.lastRewrite->next = rew;
    ufdbNewGV.lastRewrite = rew;
  }
}


static void sgRewriteTime( 
  char * name, 
  int    within )
{
  struct ufdbTime * t;

#if UFDB_DEBUG
   ufdbLogMessage( "sgRewriteTime %s %d", name, within );
#endif

  if ((t = sgTimeFindName(name)) == NULL)
  {
    ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
		       lineno, name, ufdbNewGV.configFile );
    ufdbFree( (void*) name );
    return;
  }

  ufdbNewGV.lastRewrite->within = within;
  ufdbNewGV.lastRewrite->time = t;
  ufdbFree( (void*) name );
}


static void sgRewriteSubstitute( 
  char * string )
{
  char * pattern; 
  char * subst = NULL;
  char * p;
  int    flags = REG_EXTENDED;
  int    global = 0;
  char * httpcode = NULL;
  struct ufdbRegExp * regexp;
  char   errbuf[256];

  pattern = string + 2; 	/* skipping s@ */
  p = pattern;
  while ((p = strchr(p,'@')) != NULL)
  {
    if (*(p - 1) != '\\') 
    {
      *p = '\0';
      subst = p + 1;
      break;
    }
    p++;
  }

  p = strrchr( subst, '@' );
  while (p != NULL  &&  *p != '\0')
  {
    if (*p == 'r' )
      httpcode =  (char *) REDIRECT_TEMPORARILY;
    if (*p == 'R' )
      httpcode =  (char *) REDIRECT_PERMANENT;
    if (*p == 'i' || *p == 'I')
      flags |= REG_ICASE;
    if (*p == 'g')
      global = 1;
    *p = '\0'; 		/* removes @i from string */
    p++;
  } 

  regexp = ufdbNewPatternBuffer( pattern, flags );
  if (regexp->error) 
  {
      regerror( regexp->error, (regex_t*) regexp->compiled[0], errbuf, sizeof(errbuf) );
      ufdbLogError( "line %d: regular expression error in %s:\n%s   *****", lineno, pattern, errbuf );
  }
  else {
    regexp->substitute = ufdbStrdup( subst );
  }

  if (ufdbNewGV.lastRewrite->rewrite == NULL)
    ufdbNewGV.lastRewrite->rewrite = regexp;
  else 
    ufdbNewGV.lastRewriteRegExec->next = regexp;
  regexp->httpcode = httpcode;
  regexp->global = global;
  ufdbNewGV.lastRewriteRegExec = regexp;
}


static struct sgRewrite * sgRewriteFindName( 
   const char * name )
{
   struct sgRewrite * p;

   for (p = ufdbNewGV.rewrite;  p != NULL;  p = p->next)
   {
      if (strcmp(name,p->name) == 0)
         return p;
   }
   return NULL;
}


/*
 * Time functions
 */

/*
 * sgTime - parse configuration time statement.
 */
static void sgTime( 
  char *        name )
{
  struct ufdbTime * t;

  if (ufdbGV.debug > 1)
     ufdbLogMessage( "sgTime %s", name );

  if (ufdbNewGV.timeList != NULL)
  {
    if ((struct ufdbTime *) sgTimeFindName(name) != NULL)
    {
      ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
		         lineno, name, ufdbNewGV.configFile );
      ufdbFree( (void*) name );
      return;
    }
  }
  else 
    numTimeElements = 0;

  t = (struct ufdbTime *) ufdbMalloc( sizeof(struct ufdbTime) );
  t->name = name;
  t->active = 1;
  t->element = NULL;
  t->next = NULL;

  ufdbNewGV.timeElement = NULL;
  ufdbNewGV.lastTimeElement = NULL;
  if (ufdbNewGV.timeList == NULL) 
  {
    ufdbNewGV.timeList = t;
    ufdbNewGV.lastTime = t;
  }
  else
  {
    ufdbNewGV.lastTime->next = t;
    ufdbNewGV.lastTime = t;
  }
}


/*
 * sgTimeElementInit - initialise parsing of a configuration time element.
 */
static void sgTimeElementInit( void )
{
   struct TimeElement * te;

   te = (struct TimeElement *) ufdbCalloc( 1, sizeof(struct TimeElement) );
   numTimeElements++;

   if (ufdbNewGV.lastTime->element == NULL)
     ufdbNewGV.lastTime->element = te;
   if (ufdbNewGV.lastTimeElement != NULL)
     ufdbNewGV.lastTimeElement->next = te;
   ufdbNewGV.lastTimeElement = te;
}


/*
 * sgTimeElementEnd - finalise parsing of configuration time element.
 */
static void sgTimeElementEnd( void )
{
  time_switch = 0;
  date_switch = 0;

  if (ufdbNewGV.lastTimeElement->fromdate != 0)
  {
    if (ufdbNewGV.lastTimeElement->todate == 0)
      ufdbNewGV.lastTimeElement->todate = ufdbNewGV.lastTimeElement->fromdate + 86399;
    else 
      ufdbNewGV.lastTimeElement->todate = ufdbNewGV.lastTimeElement->todate + 86399;
  }

  if (ufdbNewGV.lastTimeElement->from == 0  &&  ufdbNewGV.lastTimeElement->to == 0)
    ufdbNewGV.lastTimeElement->to = 1439;  /* set time to 23:59 */
}


/*
 * sgTimeElementAdd - add configuration time element.
 */
static void sgTimeElementAdd( 
  char * element, 
  char   type ) 
{
  struct TimeElement * te;
  char * p;
  char   wday;
  int    h, m, Y, M, D;
  time_t sec;
  char * lineptr;

  wday = 0;
  M = 0;
  D = -1;
  te = ufdbNewGV.lastTimeElement;

  switch (type)
  {
  case T_WEEKDAY:
    p = strtok_r( element, " \t,", &lineptr );
    do {
      if (*p == '*') {
	wday = 0x7F;
      } else if (!strncmp(p,"sun",3)) {
	wday = wday | 0x01;
      } else if (!strncmp(p,"mon",3)) {
	wday = wday | 0x02;
      } else if (!strncmp(p,"tue",3)) {
	wday = wday | 0x04;
      } else if (!strncmp(p,"wed",3)) {
	wday = wday | 0x08;
      } else if (!strncmp(p,"thu",3)) {
	wday = wday | 0x10;
      } else if (!strncmp(p,"fri",3)) {
	wday = wday | 0x20;
      } else if (!strncmp(p,"sat",3)) {
	wday = wday | 0x40;
      }
      p = strtok_r( NULL, " \t,", &lineptr );
    } while (p != NULL);
    te->wday = wday;
    break;

  case T_TVAL:
    h = -1;
    m = -1;
    sscanf( element, "%d:%d", &h, &m );
    if ((h < 0 || h > 24) || (m < 0 || m > 59))
    {
      ufdbLogFatalError( "line %d: time format error in %s", lineno, ufdbNewGV.configFile );
      h = 0;
      m = 0;
    }
    if (time_switch == 0) 
    {
      time_switch++;
      te->from = (h * 60) + m ;
    }
    else
    {
      time_switch = 0;
      te->to = (h * 60) + m ;
    }
    break;

  case T_DVAL:
    sec = date2sec( element );
    if (sec == -1) 
    {
      ufdbLogFatalError( "line %d: date format error in %s", lineno, ufdbNewGV.configFile );
      sec = 1;
    }
    if (date_switch == 0) {
      date_switch++;
      te->fromdate = sec;
    } else {
      date_switch = 0;
      te->todate = sec;
    }
    break;

  case T_DVALCRON:
    p = strtok_r( element, "-./", &lineptr );
    Y = atoi(p);
    if (*p == '*')
      Y = -1;
    else
      Y = atoi(p);
    while ((p=strtok_r(NULL,"-./",&lineptr)) != NULL) 
    {
      if (*p == '*')
	if (M == 0)
	  M = -1;
	else 
	  D = -1;
      else
	if (M == 0)
	  M = atoi(p);
	else
	  D = atoi(p);
    }
    te->y = Y;
    te->m = M;
    te->d = D;
    break;

  case T_WEEKLY:
    p = element;
    while (*p != '\0') 
    {
      switch (*p) {
      case 'S':
      case 's':
	wday = wday | 0x01;
	break;
      case 'M':
      case 'm':
	wday = wday | 0x02;
	break;
      case 'T':
      case 't':
	wday = wday | 0x04;
	break;
      case 'W':
      case 'w':
	wday = wday | 0x08;
	break;
      case 'H':
      case 'h':
	wday = wday | 0x10;
	break;
      case 'F':
      case 'f':
	wday = wday | 0x20;
	break;
      case 'A':
      case 'a':
	wday = wday | 0x40;
	break;
      default:
	ufdbLogFatalError( "line %d: weekday format error in %s", lineno, ufdbNewGV.configFile );
	break;
      }
      p++;
    }
    te->wday = wday;
    break;
  }

  ufdbFree( (void*) element );
}


/* 
 * lookup a ufdbTime element by name.
 */
static struct ufdbTime * sgTimeFindName( 
   const char * name )
{
   struct ufdbTime * p;

   for (p = ufdbNewGV.timeList;  p != NULL;  p = p->next)
   {
      if (strcmp(name,p->name) == 0)
         return p;
   }
   return NULL;
}


/*
 * sgTimeCmp - Time array sort function.
 */
static int sgTimeCmp( const void * a, const void * b )
{
   const int * aa = (const int *) a;
   const int * bb = (const int *) b;

   return *aa - *bb;
}


/*
 * _getSortedTimeElementTimes - produce a sorted array of time element times
 */
static void _getSortedTimeElementTimes( void )           // uses ufdbGV
{
   struct ufdbTime *    p;
   struct TimeElement * te;
   int                  i, j;
   int                  totalNumElems;
 
   if (ufdbGV.debug > 1)
      ufdbLogMessage( "_getSortedTimeElementEvents" );

   if (ufdbGV.timeList == NULL)
      return;

   /* find total number of time elements */
   totalNumElems = 0;
   for (p = ufdbGV.timeList;  p != NULL;  p = p->next) 
      for (te = p->element;  te != NULL;  te = te->next) 
         totalNumElems++;

   TimeElementsEvents = (int *) ufdbCalloc( totalNumElems * 2 , sizeof(int) ); 

   i = 0;
   for (p = ufdbGV.timeList;  p != NULL;  p = p->next) 
   {
      for (te = p->element;  te != NULL;  te = te->next) 
      {
         TimeElementsEvents[i++] = te->from == 0 ? 1440 : te->from;
         TimeElementsEvents[i++] = te->to == 0   ? 1440 : te->to;
      }
   }
 
   qsort( TimeElementsEvents, totalNumElems * 2, sizeof(int), sgTimeCmp );

   if (ufdbGV.debug > 1)
      ufdbLogMessage( "   _getSortedTimeElementEvents: after qsort" );

   /* remove identical time elements */
   for (i=1,j=1;  i < totalNumElems * 2;  i++) 
   {
      if (TimeElementsEvents[i] > TimeElementsEvents[i-1])
      {
	 TimeElementsEvents[j] = TimeElementsEvents[i];
         j++;
      }
   }

   numTimeElements = j;			/* #unique time elements */
}


/*
 * _TimeEvaluateElements - evaluate all elements if they match the current time/date and mark them active.
 */
static void _TimeEvaluateElements(              // uses ufdbGV
  struct tm * tm_now, 
  time_t      now )
{
  struct ufdbTime *    tlist;
  struct TimeElement * te;
  int                  min;

  if (ufdbGV.debug > 1)
     ufdbLogMessage( "      _TimeEvaluateElements" );

  for (tlist = ufdbGV.timeList;  tlist != NULL;  tlist = tlist->next)
  {
    tlist->active = 0;
    for (te = tlist->element;  te != NULL;  te = te->next)
    {
      if (te->wday != 0) 			/* check wday */
      {
	if (((1 << tm_now->tm_wday) & te->wday) != 0)  
	{
	  min = (tm_now->tm_hour * 60) + tm_now->tm_min;
	  if (min >= te->from  &&  min < te->to) 
	  {
	    tlist->active = 1;
	    break;
	  }
	}
      }
      else if (te->fromdate != 0)		/* check date */
      {
	if (now >= te->fromdate  &&  now <= te->todate) 
	{
	  min = (tm_now->tm_hour * 60) + tm_now->tm_min;
	  if (min >= te->from  &&  min < te->to) 
	  {
	    tlist->active = 1;
	    break;
	  }
	}
      }
      else					/* check crondate */
      {
	if (te->y == -1  ||  te->y == (tm_now->tm_year + 1900)) 
	{
	  if (te->m == -1  ||  te->m == (tm_now->tm_mon + 1)) 
	  {
	    if (te->d == -1  ||  te->d == (tm_now->tm_mday)) 
	    {
	      min = (tm_now->tm_hour * 60) + tm_now->tm_min;
	      if (min >= te->from  &&  min < te->to) 
	      {
		tlist->active = 1;
		break;
	      }
	    }
	  }
	}
      }
    }
    if (ufdbGV.debug > 1)
       ufdbLogMessage( "      _TimeEvaluateElements: time %s is %sactive", tlist->name, tlist->active?"":"not " );
  }
}


/*
 * _TimeSetAclSrcDestRew - mark all acl/source/dest/rew (in)active.
 */
static void _TimeSetAclSrcDestRew( void )               // uses ufdbGV
{
  struct Acl *         acl;
  struct Category *    cat;
  struct Source *      s;
  struct sgRewrite *   rew;
  int                  a;

  if (ufdbGV.debug > 1)
     ufdbLogMessage( "   _TimeSetAclSrcDestRew" );

  for (acl = ufdbGV.aclList;  acl != NULL;  acl = acl->next)
  {
    if (acl->time != NULL  &&  acl->within != UFDB_ACL_ELSE) 
    {
      /* Be careful here: we are multithreaded and other threads use the value 
       * of acl->active at the same time.
       */
      a = acl->time->active;
      if (acl->within == UFDB_ACL_OUTSIDE)
	a = !a;
      if (acl->next != NULL  &&  acl->next->within == UFDB_ACL_ELSE) 
	acl->next->active = !a;
      acl->active = a;
    }
#if 0
    if (acl->pass == NULL)
       acl->active = 0;			/* it can have a 'continue' so do not make it inactive */
#endif
    if (ufdbGV.debug > 1)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: acl %s %s is %sactive", acl->name, 
		       acl->within==UFDB_ACL_ELSE ? "ELSE" :
			  acl->within==UFDB_ACL_WITHIN ? "WITHIN" :
			     acl->within==UFDB_ACL_OUTSIDE ? "OUTSIDE" : "",
		       acl->active?"":"not " );
  }

  for (cat = ufdbGV.catList;  cat != NULL;  cat = cat->next)
  {
    if (cat->time != NULL) 
    {
      cat->active = cat->time->active;
      if (cat->within == UFDB_ACL_OUTSIDE)
	cat->active = !cat->active;
    }
    if (ufdbGV.debug > 1)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: category %s is %sactive", cat->name, cat->active?"":"not " );
  }

  for (s = ufdbGV.sourceList;  s != NULL;  s = s->next)
  {
    if (s->time != NULL) 
    {
      s->active = s->time->active;
      if (s->within == UFDB_ACL_OUTSIDE)
	s->active = !s->active;
    }
    if (ufdbGV.debug > 1)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: source %s is %sactive", s->name, s->active?"":"not " );
  }

  for (rew = ufdbGV.rewrite; rew != NULL; rew = rew->next)
  {
    if (rew->time != NULL) 
    {
      rew->active = rew->time->active;
      if (rew->within == UFDB_ACL_OUTSIDE)
	 rew->active = !rew->active;
    }
    if (ufdbGV.debug > 1)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: rewrite %s is %sactive", rew->name, rew->active?"":"not " );
  }
}


static void sgAlarm( int s )
{
   if (s) { ; }         // prevent compiler warning
   // do nothing; there is a thread that waits for a SIGALRM which calls ufdbHandleAlarmForTimeEvents()
}


/*
 *  ufdbHandleAlarmForTimeEvents - the alarm for the next time event went off so 
 *                                 recalculate the time-dependent active state.
 */
void ufdbHandleAlarmForTimeEvents(              // uses ufdbGV
   int        why )
{
   time_t     now;
   struct tm  tm_now;
   int        m;
   int        tindex;
   int        lastval;

   if (ufdbGV.debug)
      ufdbLogMessage( "ufdbHandleAlarmForTimeEvents( why=%s )", why==UFDB_PARAM_INIT ? "init" : "alarm" );

   if (why == UFDB_PARAM_INIT)
      ufdbLogMessage( "time definitions are used; evaluating current ACLs" );
   else
   {
      ufdbLogMessage( "alarm went off to recalculate time ACLs" );
      if (ufdbGV.terminating)
      {
	 ufdbLogMessage( "This alarm is ignored because ufdbguardd is exiting" );
	 return;
      }
      if (ufdbGV.reconfig)
      {
	 ufdbLogMessage( "This alarm is ignored because the configuration is being reloaded"
	                 " and a new alarm is set to go off in 15 seconds" );
	 alarm( 15 );
	 return;
      }
   }

   if (ufdbGV.timeList == NULL)
   {
      return;
   }

   // NOTE: _getSortedTimeElementTimes() mallocs TimeElementsEvents[] and this function frees it.
   _getSortedTimeElementTimes();

   now = UFDBtime() + 30;
   localtime_r( &now, &tm_now ); 
   m = (tm_now.tm_hour * 60) + tm_now.tm_min;
  
   lastval = 0;
   for (tindex = 0;  tindex < numTimeElements;  tindex++)
   {
#if UFDB_TIME_DEBUG
      if (ufdbGV.debug > 1)
         ufdbLogMessage( "   TimeElementsEvents[%d] = %d", tindex, TimeElementsEvents[tindex] );
#endif
      lastval = TimeElementsEvents[tindex];
      if (TimeElementsEvents[tindex] >= m)
         break;
   }

   if (ufdbGV.debug > 1)
      ufdbLogMessage( "   ufdbHandleAlarmForTimeEvents: m = %d  tindex = %d, lastval = %d", m, tindex, lastval );

   if (lastval < m)
      m = (((1440 - m) + TimeElementsEvents[0]) * 60) - tm_now.tm_sec;
   else
      m = ((lastval - m) * 60) - tm_now.tm_sec;

   if (m <= 0)
      m = 30;

   _TimeEvaluateElements( &tm_now, now );
   _TimeSetAclSrcDestRew();

   ufdbFree( (void*) TimeElementsEvents );
   TimeElementsEvents = NULL;

   ufdbLogMessage( "next alarm is in %d seconds", (unsigned int) m );
   ufdbSetSignalHandler( SIGALRM, sgAlarm );
   (void) alarm( (unsigned int) m );
}


/*
 * sgTimeElementClone - copy a time specification.
 */
static void sgTimeElementClone( void )
{
  struct TimeElement * te;
  struct TimeElement * tmp;

  te = ufdbNewGV.lastTimeElement;
  if (te == NULL) 
  {
    ufdbLogFatalError( "No previous TimeElement in sgTimeElementClone !" );
    return;
  }
  else
  {
    sgTimeElementInit();
    ufdbNewGV.lastTimeElement->wday = te->wday;
    ufdbNewGV.lastTimeElement->from = te->from;
    ufdbNewGV.lastTimeElement->to = te->to;
    ufdbNewGV.lastTimeElement->y = te->y;
    ufdbNewGV.lastTimeElement->m = te->m;
    ufdbNewGV.lastTimeElement->d = te->d;
    ufdbNewGV.lastTimeElement->fromdate = te->fromdate;
    ufdbNewGV.lastTimeElement->todate = te->todate;
    tmp = ufdbNewGV.lastTimeElement;
    ufdbNewGV.lastTimeElement = te;
    sgTimeElementEnd();
    ufdbNewGV.lastTimeElement = tmp;
  }
}


/*
 * IP functions
 */

static struct Ipv4 * sgIpv4Last( 
   struct Source * s )
{
   struct Ipv4 * ipv4;
   struct Ipv4 * last;

   last = NULL;
   for (ipv4 = s->ipv4;  ipv4 != NULL;  ipv4 = ipv4->next)
      last = ipv4;

   return last;
}


static void sgIpv4( 
   const char *   addr,
   int            type,
   const char *   file,
   int            lineno )
{
   struct Ipv4 *  ipv4;
   char *         addr2;
   char *         cidr;
   char *         end;
   unsigned int   octet;

#if 1
   if (ufdbGV.debug> 1)
      ufdbLogMessage( "   sgIpv4( %s %d %s %d )", addr, type, file, lineno );
#endif

   switch (type)
   {
   case SG_IPTYPE_HOST:
	 if (ufdbNewGV.lastSource->ipv4hosts == NULL)
	    ufdbNewGV.lastSource->ipv4hosts = UFDBmemDBinit();
	 UFDBmemDBinsert( ufdbNewGV.lastSource->ipv4hosts, addr, NULL );
  	 break;

   case SG_IPTYPE_RANGE:
	 addr2 = strchr( addr, '-' );
	 *addr2 = '\0';
	 end = addr2;
	 while (*(end-1) == ' '  ||  *(end-1) == '\t')
	 {
	    *(end-1) = '\0';
	    end--;
	 }
	 addr2++;
	 while (*addr2 == ' ' || *addr2 == '\t')
	    addr2++;

         ipv4 = (struct Ipv4 *) ufdbMalloc( sizeof(struct Ipv4) );
	 ipv4->type = SG_IPTYPE_RANGE;
         ipv4->net_is_set = 1;
	 ipv4->next = NULL;
	 if (ufdbNewGV.lastSource->ipv4 == NULL) 
	    ufdbNewGV.lastSource->ipv4 = ipv4;
	 else
	    sgIpv4Last( ufdbNewGV.lastSource )->next = ipv4;

	 if (sgConvDot(addr,&ipv4->net) == NULL)
	 {
	    ufdbLogFatalError( "IPv4 address error in %s line %d: %s - %s", file, lineno, addr, addr2 );
	    ipv4->net = 0;
	    ipv4->net_is_set = 0;
	 }
	 if (sgConvDot(addr2,&ipv4->mask) == NULL)
	 {
	    ufdbLogFatalError( "IPv4 address error in %s line %d: %s - %s", file, lineno, addr, addr2 );
	    ipv4->mask = 0;
	    ipv4->net_is_set = 0;
	 }

	 if ((unsigned int) ipv4->net > (unsigned int) ipv4->mask)
	     ufdbLogFatalError( "IPv4 range error in %s line %d: %s - %s", file, lineno, addr, addr2 );
  	 break;

   case SG_IPTYPE_CLASS:
	 addr2 = strchr( addr, '/' );
	 *addr2 = '\0';
	 addr2++;
         ipv4 = (struct Ipv4 *) ufdbMalloc( sizeof(struct Ipv4) );
	 ipv4->type = SG_IPTYPE_CLASS;
         ipv4->net_is_set = 1;
	 ipv4->next = NULL;
	 if (ufdbNewGV.lastSource->ipv4 == NULL) 
	    ufdbNewGV.lastSource->ipv4 = ipv4;
	 else
	    sgIpv4Last( ufdbNewGV.lastSource )->next = ipv4;

	 if (sgConvDot(addr,&ipv4->net) == NULL)
	 {
	    ufdbLogFatalError( "IPv4 address error in %s line %d: %s/%s", file, lineno, addr, addr2 );
	    ipv4->net = 0;
	    ipv4->net_is_set = 0;
	 }
	 if (sgConvDot(addr2,&ipv4->mask) == NULL)
	 {
	    ufdbLogFatalError( "IPv4 address error in %s line %d: %s/%s", file, lineno, addr, addr2 );
	    ipv4->mask = 0;
	 }
  	 break;

   case SG_IPTYPE_CIDR:
	 cidr = strchr( addr, '/' );
	 *cidr = '\0';
	 cidr++;
	 octet = (unsigned long) atoi( cidr );
	 if (octet > 32) 
	 {
	    ufdbLogFatalError( "IPv4 address CIDR out of range in %s line %d: %s/%s",
	                       file, lineno, addr, cidr );
	    octet = 32;
	 }
         ipv4 = (struct Ipv4 *) ufdbMalloc( sizeof(struct Ipv4) );
	 ipv4->type = SG_IPTYPE_CIDR;
         ipv4->net_is_set = 1;
	 ipv4->next = NULL;
	 if (ufdbNewGV.lastSource->ipv4 == NULL) 
	    ufdbNewGV.lastSource->ipv4 = ipv4;
	 else
	    sgIpv4Last( ufdbNewGV.lastSource )->next = ipv4;

	 if (sgConvDot(addr,&ipv4->net) == NULL)
	 {
	    ufdbLogFatalError( "IPv4 address error in %s line %d: %s/%s", file, lineno, addr, cidr );
	    ipv4->net = 0;
	    ipv4->net_is_set = 0;
	 }
	 if (octet == 32)
	    ipv4->mask = 0xffffffff;
	 else
	    ipv4->mask = 0xffffffff ^ (0xffffffff >> octet);
	 ipv4->net = ipv4->net & ipv4->mask;
  	 break;
   }
}


static struct Ipv6 * sgIpv6Last( 
   struct Source * s )
{
   struct Ipv6 * ipv6;
   struct Ipv6 * last;

   last = NULL;
   for (ipv6 = s->ipv6;  ipv6 != NULL;  ipv6 = ipv6->next)
      last = ipv6;

   return last;
}



static void sgIpv6( 
   const char * addr,
   int          type,
   const char * file,
   int          line  )
{
#if 1
   if (ufdbGV.debug > 1)
      ufdbLogMessage( "   sgIpv6( %s %d  %s %d/%d )", addr, type, file, line, lineno );
#endif

   if (type == SG_IPV6TYPE_HOST)
   {
      struct in6_addr dummy;
      if (!sgValidateIPv6( addr, &dummy ))
      {
         ufdbLogFatalError( "incorrect IPv6 address \"%s\" in %s line %d", addr, file, lineno );
      }
      else
      {
         if (ufdbNewGV.lastSource->ipv6hosts == NULL)
	    ufdbNewGV.lastSource->ipv6hosts = UFDBmemDBinit();
	 UFDBmemDBinsert( ufdbNewGV.lastSource->ipv6hosts, addr, NULL );
      }
   }
   else if (type == SG_IPV6TYPE_CIDR)
   {
      char * s = (char*) strchr( addr, '/' );
      if (s == NULL)
      {
         ufdbLogFatalError( "IPv6 net has no '/' in \"%s\" in %s line %d", addr, file, lineno );
      }
      else
      {
	 struct Ipv6 *  ipv6;

	 ipv6 = (struct Ipv6 *) ufdbMalloc( sizeof(struct Ipv6) );
	 ipv6->type = SG_IPV6TYPE_CIDR;
	 ipv6->next = NULL;
	 if (ufdbNewGV.lastSource->ipv6 == NULL) 
	    ufdbNewGV.lastSource->ipv6 = ipv6;
	 else
	    sgIpv6Last( ufdbNewGV.lastSource )->next = ipv6;

         *s = '\0';
         ipv6->cidr = (unsigned long) atoi( s+1 );
         if (ipv6->cidr > 128) 
         {
            ufdbLogFatalError( "IPv6 address CIDR out of range \"%s\" in %s line %d", addr, file, lineno );
            ipv6->cidr = 128;
         }
         if (!sgValidateIPv6( addr, &ipv6->ipv6 ))
         {
            ufdbLogFatalError( "incorrect IPv6 address \"%s\" in %s line %d", addr, file, lineno );
         }
         *s = '/';
      }
   }
   else
   {
      ufdbLogFatalError( "sgIpv6 called with unsupported type %d in %s line %d: %s", type, file, lineno, addr );
   }
}


/*
 * ACL functions
 */

static void ufdbAcl( 
   const char *    name,
   const char *    value, 
   int             within )
{
   struct Acl *    acl;
   struct Source * source;

#if UFDB_DEBUG
   ufdbLogMessage( "ufdbAcl name=\"%s\" value=\"%s\" within=%d line=%d", 
                   name==NULL?"NULL":name,  value==NULL?"NULL":value, within, lineno );
#endif

   if (ufdbNewGV.aclList != NULL) 
   {
      if (ufdbAclFindByName(&ufdbNewGV,name) != NULL)
      {
	 ufdbLogFatalError( "line %d: ACL \"%s\" is already defined in configuration file %s",
			    lineno, name, ufdbNewGV.configFile );
      }
   }

   if (within == UFDB_ACL_ELSE)
   {
      if (ufdbNewGV.lastAcl == NULL)
      {
         ufdbLogFatalError( "line %d: ACL \"else\" has no parent ACL", lineno );
         return;
      }
      if (name == NULL)
         name = ufdbStrdup( ufdbNewGV.lastAcl->name );
   }

   acl = (struct Acl *) ufdbMalloc( sizeof(struct Acl) );

   source = NULL;
   if (strcmp(name,"default") == 0)
   {
      ufdbNewGV.defaultAcl = acl;
   }
   else
   {
      if ((source = defSourceFindName(ufdbNewGV.sourceList,name)) == NULL)
      {
         ufdbLogFatalError( "line %d: ACL source \"%s\" is not defined in configuration file %s",
                            lineno, name, ufdbNewGV.configFile );
         if (ufdbNewGV.fastRefresh  &&  ufdbGV.fastRefresh  &&
             defSourceFindName(ufdbGV.sourceList,name) != NULL)
            ufdbLogError( "But ACL source \"%s\" is defined in the old configuration  *****", name );
         if (ufdbGV.debug > 1)
            UFDBlogConfig( &ufdbGV );
         ufdbFree( (void*) name );
         ufdbFree( (void*) acl );
         return;
      }
   }

   acl->name = name;
   acl->active = within == UFDB_ACL_ELSE ? 0 : 1;
   acl->source = source;
   acl->pass = NULL;
   acl->implicitPass = NULL;
   acl->hasTerminatorNone = 0;
   acl->rewriteDefault = 1;
   acl->rewrite = NULL;
   acl->redirect = NULL;
   acl->time = NULL;
   acl->within = within;
   acl->next = NULL;

   if (value != NULL) 
   {
      struct ufdbTime * t;
      if ((t = sgTimeFindName(value)) == NULL) 
      {
         ufdbLogFatalError( "line %d: ACL time %s is not defined in configuration file %s",
                            lineno, value, ufdbNewGV.configFile );
         return;
      }
      acl->time = t;
   }

   if (ufdbNewGV.aclList == NULL) 
   {
      ufdbNewGV.aclList = acl;
      ufdbNewGV.lastAcl = acl;
   }
   else
   {
      ufdbNewGV.lastAcl->next = acl;
      ufdbNewGV.lastAcl = acl;
   }
}


static void ufdbAclSetValue( 
   const char *         what,
   const char *         value, 
   int                  allowed ) 
{
   struct Category *    cat = NULL;
   struct AclCategory * aclcat;
   int                  type;
  
#if UFDB_DEBUG
   ufdbLogMessage( "ufdbAclSetValue %s %s%s", what, allowed ? "" : "!", value );
#endif

   if (ufdbNewGV.lastAcl == NULL)
   {
      ufdbLogError( "error in configuration file on line %d: "
                    "cannot set value for \"%s\" because there is no defined ACL", 
                    lineno, what );
      ufdbFree( (void*) value );
      return;
   }

   if (strcmp(what,"pass") == 0)
   {
      if (strcmp(value,"any")==0 || strcmp(value,"all")==0)
      {
         if (!allowed)
            ufdbLogFatalError( "error in configuration file on line %d: do not use '!any' or '!all'.  "
                               "Use 'none' instead.", lineno );
         type = ACL_TYPE_TERMINATOR;
         allowed = 1;
      }
      else if (strcmp(value,"none") == 0)
      {
         if (!allowed)
            ufdbLogFatalError( "error in configuration file on line %d: do not use '!none'.  "
                               "Use 'any' instead.", lineno );
         type = ACL_TYPE_TERMINATOR;
         allowed = 0;
      }
      else if (strcmp(value,"in-addr") == 0)
      {
         type = ACL_TYPE_INADDR;
      }
      else
      {
         type = ACL_TYPE_DEFAULT;
         if ((cat = ufdbCategoryFindByName(&ufdbNewGV,value)) == NULL) 
         {
	    ufdbLogFatalError( "ACL category \"%s\" (line %d) is not defined in configuration file %s",
			       value, lineno, ufdbNewGV.configFile );
            if (ufdbNewGV.fastRefresh  &&  ufdbGV.fastRefresh  &&
                ufdbCategoryFindByName(&ufdbGV,value) != NULL)
            {
               ufdbLogError( "But category \"%s\" is defined in the old configuration  *****", value );
               UFDBlogConfig( &ufdbGV );
            }
	    ufdbFree( (void*) value );
            return;
         } 
      }

      aclcat = (struct AclCategory *) ufdbMallocAligned( UFDB_CACHELINE_SIZE, sizeof(struct AclCategory) );
      aclcat->name = value;
      aclcat->cat = cat;
      aclcat->access = allowed;
      aclcat->type = type;
      aclcat->next = NULL;
      aclcat->nblocks = 0;
      aclcat->nmatches = 0;

      if (ufdbNewGV.lastAcl->pass == NULL)
         ufdbNewGV.lastAcl->pass = aclcat;
      else 
         ufdbNewGV.lastAclCategory->next = aclcat;
      ufdbNewGV.lastAclCategory = aclcat;
   }
   else if (strcmp(what,"redirect") == 0)
   {
      if (strcmp(value,"default") != 0)
         ufdbNewGV.lastAcl->redirect = value;
      else 
      {
         ufdbNewGV.lastAcl->redirect = NULL;
         ufdbFree( (void*) value );
      }
   }
   else if (strcmp(what,"rewrite") == 0)
   {
      if (strcmp(value,"none") == 0)
      {
         ufdbNewGV.lastAcl->rewriteDefault = 0;
         ufdbNewGV.lastAcl->rewrite = NULL;
      }
      else
      {
         struct sgRewrite * rewrite;

         if ((rewrite = sgRewriteFindName(value)) == NULL) 
         {
            ufdbLogFatalError( "rewrite %s is not defined in configuration file %s",
                               value, ufdbNewGV.configFile );
         }
         ufdbNewGV.lastAcl->rewriteDefault = 0;
         ufdbNewGV.lastAcl->rewrite = rewrite;
      }
      ufdbFree( (void*) value );
   }
}


struct Acl * ufdbAclFindByName( 
   struct ufdbGV * gv,
   const char *    name )
{
   struct Acl * p;

   if (name == NULL)
      return NULL;

   for (p = gv->aclList;  p != NULL;  p = p->next)
   {
      if (strcmp(name,p->name) == 0)
         return p;
   }

   return NULL;
}


static void logConfig( void )
{
   int    lno;
   FILE * fin;
   char   line[32678];
   
   if (ufdbNewGV.configLogged)
      return;
   ufdbNewGV.configLogged = 1;

   fin = fopen( ufdbNewGV.configFile, "r" );
   if (fin == NULL)
      return;

   ufdbLogMessage( "======== literal content of config file ========" );
   lno = 1;
   while (UFDBfgetsNoNL(line,sizeof(line)-1,fin) != NULL)
   {
      ufdbLogMessage( "%04d: %s", lno, line );
      lno++;
   }
   ufdbLogMessage( "======== end of literal content ========" );
   fclose( fin );
}


void yyerror( const char * s )
{
   ufdbLogFatalError( "line %d: %s in configuration file %s", lineno, s, ufdbNewGV.configFile );
}


int yywrap( void )
{
  return 1;
}

